SystemOrganization addCategory: #'Spec-Bindings'!
SystemOrganization addCategory: #'Spec-Builder'!
SystemOrganization addCategory: #'Spec-Builder-Importer'!
SystemOrganization addCategory: #'Spec-Builder-Tools'!
SystemOrganization addCategory: #'Spec-Core'!
SystemOrganization addCategory: #'Spec-Core-Specs'!
SystemOrganization addCategory: #'Spec-Examples-PolyWidgets'!
SystemOrganization addCategory: #'Spec-Examples-Widgets'!
SystemOrganization addCategory: #'Spec-Layout'!
SystemOrganization addCategory: #'Spec-Tests'!
SystemOrganization addCategory: #'Spec-Tools-ChangeSorter'!
SystemOrganization addCategory: #'Spec-Tools-Monticello'!
SystemOrganization addCategory: #'Spec-Tools-Senders'!
SystemOrganization addCategory: #'Spec-Tools-VersionBrowser'!
SystemOrganization addCategory: #'Spec-Tools-Editor'!
SystemOrganization addCategory: #'Spec-Widgets'!
SystemOrganization addCategory: #'Spec-Widgets-PolyWidgets'!
SystemOrganization addCategory: #'Spec-Widgets-Utilities'!

IdentityDictionary subclass: #OrderedIdentityDictionary
	instanceVariableNames: 'keys'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!OrderedIdentityDictionary commentStamp: '<historical>' prior: 0!
An OrderedIdentityDictionary is a dictionary which keep the order of addition of the elements!

!OrderedIdentityDictionary methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 7/10/2012 21:12'!
add: anAssociation

	(self includesKey: anAssociation key)
		ifFalse: [ keys add: anAssociation key ].
		
	^ super add: anAssociation ! !

!OrderedIdentityDictionary methodsFor: 'enumerating' stamp: 'BenjaminVanRyseghem 7/10/2012 21:14'!
associationsDo: aBlock 

	keys do: [:k | aBlock value: (self associationAt: k )]! !

!OrderedIdentityDictionary methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 7/10/2012 21:32'!
at: key put: anObject 

	(self includesKey: key)
		ifFalse: [ keys add: key ].
		
	^ super at: key put: anObject ! !

!OrderedIdentityDictionary methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/10/2012 21:31'!
initialize
	"Initialization code for OrderedIdentityDictionary"
	"This method is not used since new is overriden to use initalize:"
	
	keys := OrderedCollection new.
	super initialize.	! !

!OrderedIdentityDictionary methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/10/2012 21:25'!
initialize: aNumber
	"Initialization code for OrderedIdentityDictionary"

	keys := OrderedCollection new.
	super initialize: aNumber! !

!OrderedIdentityDictionary methodsFor: 'removing' stamp: 'BenjaminVanRyseghem 7/10/2012 21:18'!
removeKey: key ifAbsent: aBlock

	"Here I do not do anything if absent not to perform the block twice"
	keys remove: key ifAbsent: [].
	^ super removeKey: key ifAbsent: aBlock ! !

!Morph methodsFor: '*Spec-Core' stamp: ''!
addMorphWrapper: aMorphWrapper
	
	
	aMorphWrapper addIn: self.! !

!Morph methodsFor: '*Spec-Core' stamp: 'bvr 6/1/2012 17:14'!
ensureLayoutAndAddMorph: aMorph

	aMorph layoutFrame
		ifNil: [ aMorph layoutFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: nil ) ].
		
	self addMorph: aMorph ! !

!LayoutFrame methodsFor: '*Spec-Core' stamp: 'bvr 6/1/2012 15:43'!
fractions: fractionsOrNil

	^ self fractions: fractionsOrNil offsets: nil! !

!LayoutFrame methodsFor: '*Spec-Core' stamp: ''!
fractions: fractionsOrNil offsets: offsetsOrNil

	| fractions offsets |

	fractions := fractionsOrNil ifNil: [0@0 extent: 0@0].
	offsets := offsetsOrNil ifNil: [0@0 extent: 0@0].
	
	^self
		topFraction: fractions top offset: offsets top;
		leftFraction: fractions left offset: offsets left;
		bottomFraction: fractions bottom offset: offsets bottom;
		rightFraction: fractions right offset: offsets right
! !

DialogWindow subclass: #SpecDialogWindow
	instanceVariableNames: 'specWidget toolbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!SpecDialogWindow commentStamp: '<historical>' prior: 0!
A SpecDialogWindow is a window made for embedding Spec models into dialog windows
!

!SpecDialogWindow methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/26/2012 02:09'!
cancelAction: aBlock

	self toolbar cancelAction: aBlock ! !

!SpecDialogWindow methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/2/2012 17:05'!
cancelled

	^ self toolbar cancelled! !

!SpecDialogWindow methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 7/10/2012 14:13'!
giveFocusToNextFrom: aMorph 

	^ self model giveFocusToNextFrom: aMorph ! !

!SpecDialogWindow methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 7/10/2012 14:13'!
giveFocusToPreviousFrom: aMorph 

	^ self model giveFocusToPreviousFrom: aMorph ! !

!SpecDialogWindow methodsFor: 'open/close' stamp: 'BenjaminVanRyseghem 7/10/2012 16:18'!
initialExtent 

	^ self model
		ifNil: [ super initialExtent ]
		ifNotNil: [:m | m initialExtent
						ifNil: [ super initialExtent ]]! !

!SpecDialogWindow methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 8/2/2012 17:05'!
model: aModel

	super model: aModel.

	aModel model focusOrder
		addLast: toolbar.! !

!SpecDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/26/2012 02:25'!
newButtonRow

	^ self toolbar buildWithSpec! !

!SpecDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 18:03'!
newContentMorph
	"Answer a new content morph."

	^ self specWidget 
			ifNil: [ nil ] 
			ifNotNil: [:w | 
				w
					hResizing: #spaceFill;
					vResizing: #spaceFill ]! !

!SpecDialogWindow methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 7/12/2012 18:04'!
newMainPanel
	"Answer a new main panel."
	| panel |
	panel := self newDialogPanel.
	self newContentMorph ifNotNil: [:m | panel 	addMorphBack: m ].
	self newButtonRow ifNotNil: [:m | panel 	addMorphBack: m ].
	^ panel! !

!SpecDialogWindow methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/26/2012 02:08'!
okAction: aBlock

	self toolbar okAction: aBlock ! !

!SpecDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/2/2012 17:01'!
specWidget

	^ specWidget! !

!SpecDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/2/2012 17:04'!
specWidget: anObject

	specWidget := anObject.! !

!SpecDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/2/2012 17:02'!
toolbar
	"Lazy initialization because this method is called efore the initialize method"
	
	^ toolbar ifNil: [ toolbar := OkCancelToolbar owner: self ]! !

!SpecDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/2/2012 17:01'!
toolbar: anObject

	toolbar := anObject.! !

!String methodsFor: '*Spec-Tools' stamp: 'BenjaminVanRyseghem 7/3/2012 14:29'!
firstWord
	| start end |
	start := self findFirst: [ :chr| chr isSeparator not ].
	end := self findFirst: [ :chr| chr isSeparator ].
	end isZero
		ifTrue: [^ self ].
	
	^ self copyFrom: start to: end! !

PragmaCollector subclass: #SpecPragmaCollector
	instanceVariableNames: 'behavior'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

SpecPragmaCollector class
	instanceVariableNames: 'behavior'!

!SpecPragmaCollector commentStamp: '<historical>' prior: 0!
A SpecPragmaCollector is a specialized PragmaCollector.

Sonce we just want specs defined on class side, we do not have to check the whole system, then to restrain.!

SpecPragmaCollector class
	instanceVariableNames: 'behavior'!

!SpecPragmaCollector class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/20/2012 19:11'!
behavior: behavior

	^ self new
		behavior: behavior;
		yourself! !

!SpecPragmaCollector methodsFor: 'private' stamp: 'BenjaminVanRyseghem 6/20/2012 19:10'!
allPragmas

	^ self allPragmasIn: (self behavior ifNil: [ ^ #() ])! !

!SpecPragmaCollector methodsFor: 'private' stamp: 'BenjaminVanRyseghem 6/20/2012 19:10'!
allPragmasIn: aClass

	^ (Array
		streamContents: [:stream | Pragma
									withPragmasIn: aClass
									do: [:pragma | stream nextPut: pragma ]]) ! !

!SpecPragmaCollector methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/20/2012 19:09'!
behavior
	^ behavior! !

!SpecPragmaCollector methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/20/2012 19:09'!
behavior: anObject
	behavior := anObject! !

!SpecPragmaCollector methodsFor: 'initializing' stamp: 'BenjaminVanRyseghem 6/20/2012 19:10'!
reset
	"reinitialize current system settings"
	self
		noMoreAnnounceWhile: [self collected copy
				do: [:pragma | self removePragma: pragma].
			self allPragmas
				do: [:pragma | self addPragma: pragma]].
	self announce: (PragmaCollectorReset collector: self)! !

Model subclass: #ComposableModel
	instanceVariableNames: 'bindings focusOrder owner window spec extentHolder needRebuild isEventForNextFocusBlock isEventForPreviousFocusBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!ComposableModel commentStamp: '<historical>' prior: 0!
ComposableModel is an abstract class which represent a applicative model made to be composed with other ComposableModel!

ComposableModel subclass: #AbstractApiSetter
	instanceVariableNames: 'choice method model selector retrievingMethod isSetting'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!AbstractApiSetter class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/11/2012 17:50'!
spec
	<spec>
	
	^ SpecLayout composed 
			newRow: [:r |
				r 
					add: #selector;
					newColumn: [:c | c add: #choice ] width: 75]
			height: 25;
			yourself! !

!AbstractApiSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 17:50'!
choice
	^ choice! !

!AbstractApiSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 18:46'!
initialExtent 

	^ 450@25! !

!AbstractApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/12/2012 20:35'!
initialize
	"Initialization code for BooleanApiSetter"

	
	method := nil asValueHolder.
	model := nil asValueHolder.
	retrievingMethod := nil asValueHolder.
	isSetting := false.
	
	super initialize.
	self registerEvents! !

!AbstractApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/11/2012 17:50'!
initializeWidgets 
	
	self instantiateModels: #(
		selector 	LabelModel 
		choice 		DropListModel ).
				
	self selector text: ''.
	self choice items: (#(true false) collect: [:b | DropListItem 
													named: b printString
													do: [ self setValueTo: b ]]).! !

!AbstractApiSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 20:34'!
internUpdateWith: aValue

	self subclassResponsibility! !

!AbstractApiSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 20:35'!
isSetting

	^ isSetting! !

!AbstractApiSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 20:35'!
isSetting: aBoolean 

	isSetting := aBoolean ! !

!AbstractApiSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 17:50'!
method

	^ method contents! !

!AbstractApiSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 17:50'!
method: anObject

	method contents: anObject! !

!AbstractApiSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 17:50'!
model

	^ model contents! !

!AbstractApiSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 17:50'!
model: anObject

	model contents: anObject! !

!AbstractApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/12/2012 19:45'!
registerEvents

	self registerRetrievingMethodEvent.
	self registerModelEvent.
	self registerMethodEvents! !

!AbstractApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/13/2012 02:41'!
registerMethodEvents

	method whenChangedDo: [ :s | 
			selector text: s asString.
			self model ifNotNil: [ :m | choice help: (m class lookupSelector: s) comment ] ]! !

!AbstractApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/12/2012 20:34'!
registerModelEvent

	model whenChangedDo: [ :m | 
			self retrievingMethod
				ifNotNil: [ :meth || value |
					value := m perform: meth.
					self internUpdateWith: value ]]! !

!AbstractApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/12/2012 20:34'!
registerRetrievingMethodEvent

	retrievingMethod whenChangedDo: [ :meth | 
			self model
				ifNotNil: [ :m || value |
					value := m perform: meth.
					self internUpdateWith: value ]]! !

!AbstractApiSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 17:50'!
retrievingMethod

	^ retrievingMethod contents! !

!AbstractApiSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 17:50'!
retrievingMethod: anObject

	retrievingMethod contents: anObject! !

!AbstractApiSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 17:50'!
selector
	^ selector! !

!AbstractApiSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 19:25'!
selectorWidth: aNumber
	| layout |
	layout := SpecLayout composed 
				newRow: [:r | 
					r 
						newColumn: [:c | c add: #selector ] width: aNumber;
						add: #choice ]
				height: 25;
				yourself.
				
	self needRebuild: false.
	selector needRebuild: false.
	choice needRebuild: false.
	
	self buildWithSpecLayout: layout.! !

!AbstractApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/12/2012 20:41'!
setValueTo: anObject

	self model ifNil: [ ^ self ].
	self method ifNil: [ ^ self ].
	
	self isSetting ifFalse: [ 
		self isSetting: true.
		self model perform: (self method) with: anObject.
		self isSetting: false ].! !

!AbstractApiSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 18:59'!
updateWith: aValue

	self isSetting ifFalse: [ 
		self isSetting: true.
		self internUpdateWith: aValue.
		self isSetting: false ]! !

AbstractApiSetter subclass: #BlockApiSetter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!BlockApiSetter class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/11/2012 19:00'!
spec
	<spec>
	
	^ SpecLayout composed 
			newRow: [:r |
				r 
					add: #selector;
					newColumn: [:c | c add: #choice ] width: 75]
			height: 25;
			yourself! !

!BlockApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/11/2012 19:11'!
initializeWidgets 
	
	self instantiateModels: #(
		selector 	LabelModel 
		choice 		BlocEditor ).
				
	self selector text: ''.
	self choice whenBlockChangedDo: [:b | self setValueTo: b ]! !

!BlockApiSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 18:45'!
internUpdateWith: value
	| string idx start end pre body |
	
	string := value printString.
	idx := string indexOf: $|.
	idx isZero
		ifTrue: [ 
			pre := '['.
			idx := idx +1 ]
		ifFalse: [ pre := (string copyFrom: 1 to: idx), ' ' ].
	start := idx + 1.
	end := string size-1.
	body := (string copyFrom: start to: end) trimBoth.

	choice pre text: pre.
	choice text text: body! !

AbstractApiSetter subclass: #BooleanApiSetter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!BooleanApiSetter class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/11/2012 17:30'!
spec
	<spec>
	
	^ SpecLayout composed 
			newRow: [:r |
				r 
					add: #selector;
					newColumn: [:c | c add: #choice ] width: 75]
			height: 25;
			yourself! !

!BooleanApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/13/2012 02:12'!
initializeWidgets 
	
	self instantiateModels: #(
		selector 	LabelModel 
		choice 		CheckBoxModel ).
				
	self selector text: ''.
	self choice 
		label: 'true/false';
		labelClickable: true;
		whenChangedDo: [:b | self setValueTo: b ];
		state: false.! !

!BooleanApiSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 22:25'!
internUpdateWith: value

	choice state: value! !

AbstractApiSetter subclass: #ColorApiSetter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!ColorApiSetter class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/16/2012 19:24'!
spec
	<spec>
	
	^ SpecLayout composed 
			newRow: [:r |
				r 
					add: #selector;
					newColumn: [:c | c add: #choice ] width: 75]
			height: 25;
			yourself! !

!ColorApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/16/2012 19:29'!
initializeWidgets 
	
	self instantiateModels: #(
		selector 	LabelModel 
		choice 		ColorEditor ).
				
	self selector text: ''.
	self choice whenColorChangedDo: [:c | self setValueTo: c ]! !

!ColorApiSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 19:26'!
internUpdateWith: aColor

	choice setAbsoluteRed: aColor red.
	choice setAbsoluteBlue: aColor blue.
	choice setAbsoluteGreen: aColor green.
	choice setAbsoluteAlpha: aColor alpha.! !

AbstractApiSetter subclass: #IntegerApiSetter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!IntegerApiSetter class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/12/2012 19:44'!
spec
	<spec>
	
	^ SpecLayout composed 
			newRow: [:r |
				r 
					add: #selector;
					newColumn: [:c | c add: #choice ] width: 75]
			height: 25;
			yourself! !

!IntegerApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/12/2012 20:01'!
initializeWidgets 
	
	self instantiateModels: #(
		selector 	LabelModel 
		choice 		IntegerEditor ).
				
	self selector text: ''.
	self choice whenIntegerChangedDo: [:b | self setValueTo: b ]! !

!IntegerApiSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 18:58'!
internUpdateWith: value

	choice value: value ! !

!IntegerApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/13/2012 02:55'!
registerMethodEvents

	method whenChangedDo: [ :s |
			selector text: s asString.
			self model ifNotNil: [ :m || mth |
				mth := (m class lookupSelector: s).
				self updateSliderWith: mth.
				choice help: mth comment ]]! !

!IntegerApiSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/13/2012 04:30'!
updateSliderWith: aMethod
	| prg min max old | 
	
	prg := aMethod pragmas detect: [:e | e keyword beginsWith: 'api:' ] ifNone: [ ^ self ].
	min := prg arguments second.
	max := prg arguments third.
	"
	
	old := self model perform: prg arguments fourth."
	
	max isInteger
		ifTrue: [ choice max: max ]
		ifFalse: [ choice max: (self model perform: max) ].
	min isInteger
		ifTrue: [ choice min: min ]
		ifFalse: [ choice min: (self model perform: min) ].
		
	"self isSetting ifFalse:[
		self isSetting: true.
		choice value: old.
		self isSetting: false ]"! !

AbstractApiSetter subclass: #StApiSetter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!StApiSetter class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/12/2012 18:16'!
spec
	<spec>
	
	^ SpecLayout composed 
			newRow: [:r |
				r 
					add: #selector;
					newColumn: [:c | c add: #choice ] width: 75]
			height: 25;
			yourself! !

!StApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/12/2012 18:22'!
initializeWidgets 
	
	self instantiateModels: #(
		selector 	LabelModel 
		choice 		STEditor ).
				
	self selector text: ''.
	self choice whenObjectChangedDo: [:b | self setValueTo: b ]! !

!StApiSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 20:34'!
internUpdateWith: value
	
	choice text text: "value storeString"''! !

AbstractApiSetter subclass: #StringApiSetter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!StringApiSetter class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/11/2012 17:45'!
spec
	<spec>
	
	^ SpecLayout composed 
			newRow: [:r |
				r 
					add: #selector;
					add: #choice ]
			height: 25;
			yourself! !

!StringApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/11/2012 17:44'!
initializeWidgets 
	
	self instantiateModels: #(
		selector 	LabelModel 
		choice 		TextInputFieldModel  ).
				
	self selector text: ''.
	self choice
			autoAccept: true;
			entryCompletion: nil;
			ghostText: 'new value';
			acceptBlock: [:t | self setValueTo: t ].! !

!StringApiSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 20:34'!
internUpdateWith: value

	choice text: value asString! !

ComposableModel subclass: #AbstractBasicWidget
	instanceVariableNames: 'helpHolder borderWidth borderColor enabledHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!AbstractBasicWidget commentStamp: '<historical>' prior: 0!
AbstractBasicWidget is an abstract class for basic widgets!

!AbstractBasicWidget class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 6/13/2012 16:36'!
defaultSpec

	^ SpecLayout composed! !

!AbstractBasicWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 05:27'!
borderColor
	<api: #inspect>
	"Return the border color"
	
	^ borderColor contents! !

!AbstractBasicWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 19:31'!
borderColor: aColor
	<api: #color getter:#borderColor registration: #whenBorderColorChanged:>
	"Set the border width"
	
	borderColor contents: aColor ! !

!AbstractBasicWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 05:17'!
borderWidth
	<api: #inspect>
	"Return the border width"
	
	^ borderWidth contents! !

!AbstractBasicWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 17:46'!
borderWidth: anInteger
	<api: #integer min:0 max: 5 getter:#borderWidth registration: #whenBorderWidthChanged:>
	"Set the border width"
	
	borderWidth contents: anInteger! !

!AbstractBasicWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 16:51'!
color

	^ self widget
		ifNil: [ Color white ]
		ifNotNil: [:w | w color ]! !

!AbstractBasicWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 16:51'!
color: aColor

	^ self widget
		ifNotNil: [:w | w color: aColor ]! !

!AbstractBasicWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 18:06'!
disable
	<api: #do>
	"Disable the label"
	
	self enabled: false! !

!AbstractBasicWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 18:06'!
enable
	<api: #do>
	"Enable the label"
	
	self enabled: true! !

!AbstractBasicWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 18:02'!
enabled
	<api: #inspect>
	^ enabledHolder contents! !

!AbstractBasicWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 18:02'!
enabled: aBoolean
	<api: #boolean getter: #enabled registration: #whenEnabledChanged:>
	"Set if the button is enabled (clickable)"
	
	enabledHolder contents: aBoolean! !

!AbstractBasicWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 17:55'!
help
	<api: #inspect>
	"Return the ballon text"
	
	^ helpHolder contents! !

!AbstractBasicWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 05:18'!
help: aString
	<api: #string getter:#help registration: #whenHelpChanged:>
	"Set the help string"
	
	helpHolder contents: aString! !

!AbstractBasicWidget methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/16/2012 18:09'!
initialize
	"Initialization code for AbstractBasicWidget"

	super initialize.

	helpHolder := nil asValueHolder.
	borderWidth := 0 asValueHolder.
	borderColor := Color transparent asValueHolder.
	enabledHolder := true asValueHolder.
	
	helpHolder whenChangedDo: [:string | 
		self widget ifNotNil: [:w | w setBalloonText: string ]].
	
	borderWidth whenChangedDo: [:int | 
		self widget ifNotNil: [:w | w borderWidth: int ]].
	
	borderColor whenChangedDo: [:color | 
		self widget ifNotNil: [:w | w borderColor: color ]].
	
	enabledHolder whenChangedDo: [:b |
		self widget ifNotNil: [:w | w enabled: b ]].! !

!AbstractBasicWidget methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:10'!
initializeWidgets 
	"ignore this method since there is no composition in basic widgets"! !

!AbstractBasicWidget methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 17:36'!
whenBorderColorChanged: aBlock
	<api: #event>
	"Set a block to be performed when the brder width changed"
	
	borderColor whenChangedDo: aBlock! !

!AbstractBasicWidget methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 17:36'!
whenBorderWidthChanged: aBlock
	<api: #event>
	"Set a block to be performed when the brder width changed"
	
	borderWidth whenChangedDo: aBlock! !

!AbstractBasicWidget methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 18:03'!
whenEnabledChanged: aBlock
	<api: #event>
	"Set a block to performed when the widget is enabled or disabled"
	
	enabledHolder whenChangedDo: aBlock! !

!AbstractBasicWidget methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 17:36'!
whenHelpChanged: aBlock
	<api: #event>
	"Set a block to be performed when the help changed"
	
	helpHolder whenChangedDo: aBlock! !

AbstractBasicWidget subclass: #ButtonModel
	instanceVariableNames: 'actionHolder labelHolder stateHolder actionPerformedHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!ButtonModel commentStamp: '<historical>' prior: 0!
A ButtonComposableModel is an applicative model which handle a basic button.

self example!

!ButtonModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/13/2012 05:29'!
defaultSpec
	<spec>
	^ {#ButtonSpec.
	    		#on:getState:action:label:menu:. 	#model. #state. #action. #label. #nil.
			#getEnabledSelector:. 				#enabled.
			#hResizing:. 						#spaceFill.
			#vResizing:. 						#spaceFill.
			#borderWidth:.						#(model borderWidth).
			#borderColor:.						#(model borderColor).
			#setBalloonText:.					{ #model . #help}.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!ButtonModel class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 4/24/2012 03:09'!
example

	| b |
	b:= ButtonModel new.
	b openWithSpec.
	b label: 'Click me'.! !

!ButtonModel class methodsFor: 'specs' stamp: ''!
title

	^ 'Button'! !

!ButtonModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/11/2012 17:12'!
action

	self widget ifNotNil: [:m | m takeKeyboardFocus ].
	actionHolder contents value.
	" Here I set a dummy value just to make the holder raise an event "
	actionPerformedHolder contents: nil.! !

!ButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 20:21'!
action: aBlock
	<api: #block getter: #getAction registration: #whenActionChangedDo:>
	"set the block performed when the button is clicked"

	actionHolder contents: aBlock! !

!ButtonModel methodsFor: 'focus' stamp: 'StephaneDucasse 5/17/2012 18:17'!
eventStringForNextFocus
	"String describing the keystroke to perform to jump to the next widget"
	^ '<right>'! !

!ButtonModel methodsFor: 'focus' stamp: 'StephaneDucasse 5/17/2012 18:18'!
eventStringForPreviousFocus
	"String describing the keystroke to perform to jump to the previous widget"
	^ '<left>'! !

!ButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 17:16'!
getAction
	<api: #inspect>
	"get the block performed when the button is clicked"

	^ actionHolder contents! !

!ButtonModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/12/2012 17:54'!
initialize
	"Initialization code for ButtonComposableModel"

	super initialize.

	actionHolder := [] asValueHolder.
	labelHolder := '' asValueHolder.
	stateHolder := true asValueHolder.
	enabledHolder := true asValueHolder.
	helpHolder := nil asValueHolder.
	actionPerformedHolder := nil asValueHolder.
	
	labelHolder whenChangedDo: [	self changed: #label ].
	stateHolder whenChangedDo: [	self changed: #state ].
	enabledHolder whenChangedDo: [	self changed: #enabled ].! !

!ButtonModel methodsFor: 'focus' stamp: ''!
keyStroke: anEvent fromMorph: aMorph

	anEvent keyString = '<space>'
		ifTrue: [ self action ].
		
	super keyStroke: anEvent fromMorph: aMorph! !

!ButtonModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/11/2012 17:17'!
label
	<api: #inspect>
	^ labelHolder contents! !

!ButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 20:22'!
label: aString
	<api: #string getter: #label registration: #whenLabelChangedDo:>
	"set the label of the button"

	labelHolder contents: aString! !

!ButtonModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/11/2012 17:17'!
state
	<api: #inspect>
	^ stateHolder contents! !

!ButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 20:32'!
state: aBoolean
	<api: #boolean getter: #state registration: #whenStateChangedDo:>
	"set if the button is highlighted"
	
	^ stateHolder contents: aBoolean! !

!ButtonModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/12/2012 20:21'!
whenActionChangedDo: aBlock 

	actionHolder whenChangedDo: aBlock! !

!ButtonModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/11/2012 17:12'!
whenActionPerformedDo: aBlock
	<api: #event>
	"set a block to perform after that the button has been aclicked, and its action performed"

	actionPerformedHolder whenChangedDo: aBlock! !

!ButtonModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/12/2012 20:23'!
whenLabelChangedDo: aBlock
	<api: #event>
	"set a block to perform after that the button has been aclicked, and its action performed"

	labelHolder whenChangedDo: aBlock! !

!ButtonModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/12/2012 20:23'!
whenStateChangedDo: aBlock
	<api: #event>
	"set a block to perform after that the button has been aclicked, and its action performed"

	stateHolder whenChangedDo: aBlock! !

AbstractBasicWidget subclass: #CheckBoxModel
	instanceVariableNames: 'actionWhenActivatedHolder actionWhenDesactivatedHolder stateHolder labelClickableHolder labelHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!CheckBoxModel commentStamp: '<historical>' prior: 0!
A CheckboxModel is a spec model for Checkbox

You can also have a look at CheckBoxExample for a full example of how to use them with a group.
!

!CheckBoxModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/13/2012 05:29'!
defaultSpec
	<spec>
	^ {#CheckboxSpec.
	    		#on:selected:changeSelected:. 	#model. #state. #state:.
			#label:.								{	#model. #label		}.
			#beCheckbox.
			#hResizing:. 						#shrinkWrap.
			#vResizing:. 						#shrinkWrap.
			#setBalloonText:.					{ #model . #help}.
			#borderWidth:.						#(model borderWidth).
			#borderColor:.						#(model borderColor).
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}.
			#labelClickable:.					{	#model. #labelClickable}.}! !

!CheckBoxModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/13/2012 02:00'!
title

	^ 'Checkbox Button'! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 16:56'!
activationAction: aBlock
	<api: #block getter: #activationAction registration: #whenActivationActionChanged:>
	"This method is used to set the action to perform when I am activated"
	
	actionWhenActivatedHolder contents: aBlock! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 17:50'!
click
	<api: #do>
	"Simulate a click on the checkbox
	Used when the checkboc is a list item"

	self toggleState! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 17:00'!
desactivationAction: aBlock
	<api: #block getter: #desactivationAction registration: #whenDesactivationActionChanged:>
	"This method is used to set the action to perform when I am desactivated"
	
	actionWhenDesactivatedHolder contents: aBlock! !

!CheckBoxModel methodsFor: 'focus' stamp: 'StephaneDucasse 5/17/2012 18:17'!
eventStringForNextFocus
	"String describing the keystroke to perform to jump to the next widget"
	^ '<right>'! !

!CheckBoxModel methodsFor: 'focus' stamp: 'StephaneDucasse 5/17/2012 18:18'!
eventStringForPreviousFocus
	"String describing the keystroke to perform to jump to the previous widget"
	^ '<left>'! !

!CheckBoxModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/7/2012 12:28'!
initialize
	"initialization code for CheckBox"

	super initialize.
	
	actionWhenActivatedHolder := [] asValueHolder.
	actionWhenDesactivatedHolder := [] asValueHolder.
	enabledHolder := true asValueHolder.
	stateHolder := false asValueHolder.
	labelClickableHolder := true asValueHolder. 
	labelHolder := '' asValueHolder.
	stateHolder whenChangedDo: [:bool |
		bool
			ifTrue: actionWhenActivatedHolder contents
			ifFalse: actionWhenDesactivatedHolder contents.
		self changed: #state ].
	labelClickableHolder whenChangedDo: [:aBoolean |
		self widget ifNotNil: [:w | w labelClickable: aBoolean ]].
	labelHolder whenChangedDo: [:label |
		self widget ifNotNil: [:w | w label: label ]].
	! !

!CheckBoxModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/12/2012 17:50'!
label
	<api: #inspect>
	^ labelHolder contents! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 17:03'!
label: aString
	<api: #string getter: #label registration: #whenLabelChanged:>
	"Set the label of the checkbox"

	labelHolder contents: aString.! !

!CheckBoxModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/13/2012 02:10'!
labelClickable
	<api: #inspect>
	"Return true if the label can be clicked to select the checkbox"

	^ labelClickableHolder contents! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 17:03'!
labelClickable: aBoolean
	<api: #boolean getter: #labelClickable registration: #whenLabelClickableChanged:>
	"Set if the label can be clicked to select the checkbox"
	
	labelClickableHolder contents: aBoolean! !

!CheckBoxModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/16/2012 17:06'!
state
	<api: #inspect>
	"Return the current state of the checkBox"
	
	^ stateHolder contents! !

!CheckBoxModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/12/2012 17:49'!
state: aBoolean
	<api: #boolean getter: #state>
	"Set if the checkbox is activated or not"

	stateHolder contents: aBoolean! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 17:51'!
toggleState
	<api: #do>
	"Toogle the current state of the checkbox"

	self state: self state not! !

!CheckBoxModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/12/2012 17:51'!
whenActivatedDo: aBlock
	<api: #event>
	"This method is used to propagate the event that I have been activated" 
	
	stateHolder whenChangedDo: [:bool | bool ifTrue: aBlock ]! !

!CheckBoxModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 16:52'!
whenActivationActionChanged: aBlock
	<api: #event>
	"A block performed when the activation action changed"
	actionWhenActivatedHolder whenChangedDo:  aBlock ! !

!CheckBoxModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/13/2012 01:40'!
whenChangedDo: aBlock
	<api: #event>
	"This method is used to propagate the event that I have changed"
	
	stateHolder whenChangedDo: aBlock! !

!CheckBoxModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/12/2012 17:51'!
whenDesactivatedDo: aBlock
	<api: #event>
	"This method is used to propagate the event that I have been desactivated"
	
	stateHolder whenChangedDo: [:bool | bool ifFalse: aBlock ]! !

!CheckBoxModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 16:59'!
whenDesactivationActionChanged: aBlock
	<api: #event>
	"A block performed when the desactivation action changed"
	actionWhenDesactivatedHolder whenChangedDo:  aBlock ! !

!CheckBoxModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 17:01'!
whenLabelChanged: aBlock
	"A block performed when the label changed"
	<api: #event>
	
	labelHolder whenChangedDo:  aBlock ! !

!CheckBoxModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 17:02'!
whenLabelClickableChanged: aBlock
	"A block performed when the label click is activated or descativated"
	<api: #event>
	
	labelClickableHolder whenChangedDo:  aBlock ! !

AbstractBasicWidget subclass: #DropListModel
	instanceVariableNames: 'listHolder selectionHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!DropListModel commentStamp: '<historical>' prior: 0!
A DropListModel is a Spec model for drop lists.

I am assume there is a little problem on an empty list, but frankly, who creates an empty drop list ?

See DropListExample for an example!

!DropListModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/13/2012 05:29'!
defaultSpec
	<spec>
	
	^ {#DropListSpec.
	    		#on:list:selected:changeSelected:. 	#model. #getList. #getIndex. #setIndex:.
			#hResizing:. 						#spaceFill.
			#vResizing:. 						#spaceFill.
			#borderWidth:.						#(model borderWidth).
			#borderColor:.						#(model borderColor).
			#setBalloonText:.					{ #model . #help}.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!DropListModel class methodsFor: 'specs' stamp: ''!
title

	^ 'Drop List'! !

!DropListModel methodsFor: 'focus' stamp: 'StephaneDucasse 5/17/2012 18:17'!
eventStringForNextFocus
	"String describing the keystroke to perform to jump to the next widget"
	^ '<right>'! !

!DropListModel methodsFor: 'focus' stamp: 'StephaneDucasse 5/17/2012 18:18'!
eventStringForPreviousFocus
	"String describing the keystroke to perform to jump to the previous widget"
	^ '<left>'! !

!DropListModel methodsFor: 'morphic' stamp: 'StephaneDucasse 5/17/2012 18:12'!
getIndex

	^ selectionHolder index contents! !

!DropListModel methodsFor: 'morphic' stamp: 'StephaneDucasse 5/17/2012 18:02'!
getList

	^ listHolder contents collect: #label! !

!DropListModel methodsFor: 'initialization' stamp: 'StephaneDucasse 5/17/2012 19:32'!
initialize
	"Initialization code for DropListModel"

	super initialize.

	listHolder := {} asValueHolder.
	selectionHolder := SelectionValueHolder new.
	
	listHolder whenChangedDo: [ 
					self changed: #getList.
					self internalResetSelection. ].
				
	selectionHolder whenChangedDo: [ self changed: #getIndex ].
	self whenSelectedItemChanged: [:item | item value ]! !

!DropListModel methodsFor: 'private' stamp: 'StephaneDucasse 5/17/2012 18:05'!
internalResetSelection

	selectionHolder reset.
	self getList isEmpty not
		ifTrue: [ self setSelectedIndex: 1 ]! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 18:07'!
items: aList
	<api: #st getter: #listItems>
	"Populate the drop list with a list of DropItems"
	
	listHolder contents: aList! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 18:08'!
listItems
	<api: #inspect>
	"Return the list of DropItems used to populate the drop list"
	
	^ listHolder contents! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 20:02'!
listSize
	<api: #inspect>
	"Return the size of the list of choices"

	^ self listItems size! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 18:08'!
resetSelection
	<api: #do>
	"Reset the current selection state"

	selectionHolder reset! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 18:08'!
selectedIndex
	<api: #inspect>
	"Useless method but it provides a better and more consistent API"

	^ self getIndex! !

!DropListModel methodsFor: 'private' stamp: 'StephaneDucasse 5/17/2012 18:04'!
selectedIndexHolder

	^ selectionHolder index! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 18:08'!
selectedItem
	<api: #inspect>
	"Return the selected item"

	^ self selectedItemHolder contents! !

!DropListModel methodsFor: 'private' stamp: 'StephaneDucasse 5/17/2012 18:04'!
selectedItemHolder

	^ selectionHolder selection! !

!DropListModel methodsFor: 'morphic' stamp: 'StephaneDucasse 5/17/2012 18:04'!
setIndex: anIndex
	| item |
	
	selectionHolder index contents: anIndex.
	item := (listHolder contents at: anIndex ifAbsent: [ nil ]).
	item value.
	selectionHolder selection contents: item.
	self changed: #getIndex! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 20:05'!
setSelectedIndex: anIndex
	<api: #integer min:1 max:#listSize getter: #selectedIndex>
	"Force the selection of the item at index anIndex"
	| selection |

	selection := listHolder contents at: anIndex ifAbsent: [ ^ self ].
	selection value.
	selectionHolder index contents: anIndex.
	selectionHolder selection contents: selection! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 18:10'!
setSelectedItem: anItem
	<api: #st getter: #selectedItem>
	"Force the selection of the item anItem"
	| index realItem |
	
	index := self getList indexOf: anItem ifAbsent: [ ^ self ].
	realItem := (self listItems at: index) value.
	selectionHolder index contents: index.
	selectionHolder selection contents: realItem.! !

!DropListModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/12/2012 18:10'!
whenSelectedItemChanged: aBlock
	<api: #event>
	"Set a block to perform when the selected item is changed"

	selectionHolder selection whenChangedDo: aBlock! !

!DropListModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/12/2012 18:10'!
whenSelectionChanged: aBlock
	<api: #event>
	"Set a block to perform when the selection is changed"

	selectionHolder whenChangedDo: aBlock.! !

!DropListModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/12/2012 18:10'!
whenSelectionIndexChanged: aBlock
	<api: #event>
	"Set a block to perform when the selected index is changed"

	selectionHolder index whenChangedDo: aBlock! !

AbstractBasicWidget subclass: #LabelModel
	instanceVariableNames: 'textHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!LabelModel commentStamp: '<historical>' prior: 0!
A LabelModel is a spec model for Labels!

!LabelModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/13/2012 05:29'!
defaultSpec
	<spec>
	^ {#LabelSpec.
			#model:. 				#model.
			#getEnabledSelector:.	#enabled.
			#getTextSelector:.		#getText.
			#vResizing:.			#shrinkWrap.
			#hResizing:.			#spaceFill.
			#borderWidth:.						#(model borderWidth).
			#borderColor:.						#(model borderColor).
			#setBalloonText:.					{ #model . #help}.
			#eventHandler:.	{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!LabelModel class methodsFor: 'specs' stamp: ''!
title

	^ 'Label Morph'! !

!LabelModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/13/2012 02:17'!
getText
	<api: #inspect>

	^ textHolder contents! !

!LabelModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/16/2012 18:07'!
initialize
	"Initialization code for LabelModel"

	super initialize.

	textHolder := '' asValueHolder.
	enabledHolder := true asValueHolder.
	textHolder whenChangedDo: [ self changed: #getText ].! !

!LabelModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:15'!
text: aText
	<api: #string getter: #getText registration: #whenTextChanged:>
	"Set the text of the label"
	
	textHolder contents: aText! !

!LabelModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/13/2012 02:16'!
whenTextChanged: aBlock
	<api: #event>
	"Set a block to performed when the text is changed"
	
	textHolder whenChangedDo: aBlock! !

AbstractBasicWidget subclass: #ListComposableModel
	instanceVariableNames: 'selectionHolder listHolder menuHolder shortcutsHolder multiSelectionHolder multiSelection allowToSelect listItemsCache filteringBlockHolder sortingBlockHolder wrapBlockHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!ListComposableModel commentStamp: '<historical>' prior: 0!
A ListComposableModel is an applicative model which handle a basic list.

| t |
t:= ListComposableModel new.
t openWithSpec.
t items: (Smalltalk allClasses).


self example

| t |
t:= ListComposableModel new.
t openWithSpec.
t sortingBlock: [:a :b| a name > b name].
t items: (Smalltalk allClasses).


| t |
t:= ListComposableModel new.
t openWithSpec.
t filteringBlock: [:col | col select: [:each | each name beginsWith: 'Zn']].
t sortingBlock: [:a :b| a name > b name].
t items: (Smalltalk allClasses).
!

ListComposableModel subclass: #IconListModel
	instanceVariableNames: 'iconHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!IconListModel commentStamp: '<historical>' prior: 0!
An IconListModel is a spec model for icon list!

!IconListModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/31/2012 17:05'!
defaultSpec
	<spec>
	^ {#IconListSpec.
	    		#model:. 						#model.
			#getListSizeSelector:. 			#listSize.
			#getListElementSelector:. 		#listElementAt:.
			#getIndexSelector:. 			#getIndex.
			#setIndexSelector:. 			#setIndex:.
			#getSelectionListSelector:.		#getSelectionStateFor:.
			#setSelectionListSelector:.		#setSelectionStateFor:at:.
			#getIconSelector:.				#getIconFor:.
			#resetListSelector:.				#resetListSelection.
			#getMenuSelector:.			#menu:shifted:.
			#keystrokeSelector:.			#keyStroke:fromMorph:.
			#setMultipleSelection:.			{#model. #multiSelection}.
			#wrapSelector:. 				#wrapItem:index:.
			#borderWidth:.						#(model borderWidth).
			#borderColor:.						#(model borderColor).
			#setBalloonText:.					{ #model . #help}.
			#hResizing:. 					#spaceFill.
			#vResizing:. 					#spaceFill}! !

!IconListModel class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 7/10/2012 15:50'!
example

	self new
		icons: [:e | UITheme current forwardIcon ];
		items: (1 to: 10) asArray;
		openWithSpec! !

!IconListModel methodsFor: 'morphic' stamp: ''!
getIconFor: anItem

	^ iconHolder contents cull: anItem cull: self! !

!IconListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:51'!
icons
	<api: #inspect>
	"Return the block which takes an item as argument and returns the icon to display in the list"
	
	^ iconHolder contents! !

!IconListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:50'!
icons: aBlock
	<api: #block getter: #icon registration: #whenIconsChanged: >
	"Set a block which takes an item as argument and returns the icon to display in the list"
	iconHolder contents: aBlock! !

!IconListModel methodsFor: 'initialization' stamp: ''!
initialize
	"Initialization code for IconListModel"

	super initialize.

	iconHolder := [:item | nil ] asValueHolder.! !

!IconListModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/13/2012 02:51'!
whenIconsChanged: aBlock 
	<api: #block>
	
	iconHolder whenChangedDo: aBlock 

! !

!ListComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/16/2012 17:38'!
defaultSpec
	<spec: #default>
	^ {#ListSpec.
	    		#model:. 					#model.
			#getListSizeSelector:. 			#listSize.
			#getIndexSelector:. 			#getIndex.
			#setIndexSelector:. 			#setIndex:.
			#getSelectionListSelector:.		#getSelectionStateFor:.
			#setSelectionListSelector:.		#setSelectionStateFor:at:.
			#getListElementSelector:. 		#listElementAt:.
			#resetListSelector:.			#resetListSelection.
			#getMenuSelector:.			#menu:shifted:.
			#keystrokeSelector:.			#keyStroke:fromMorph:.
			#setMultipleSelection:.			{#model. #multiSelection}.
			#wrapSelector:. 				#wrapItem:index:.
			#borderWidth:.						#(model borderWidth).
			#borderColor:.						#(model borderColor).
			#setBalloonText:.					{ #model . #help}.
			#hResizing:. 					#spaceFill.
			#vResizing:. 					#spaceFill}! !

!ListComposableModel class methodsFor: 'example' stamp: 'StephaneDucasse 5/17/2012 18:02'!
example
	| instance |

	instance := self new.
	instance openWithSpec.
	instance items: (Smalltalk allClasses).! !

!ListComposableModel class methodsFor: '*Spec-Builder' stamp: 'bvr 5/31/2012 13:36'!
possibleEvents

	^ #(whenListChanged whenSelectionChanged whenSelectedItemChanged whenSelectedIndexChanged)! !

!ListComposableModel class methodsFor: 'specs' stamp: ''!
title

	^ 'List'! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:20'!
allowToSelect
	<api: #inspect>
	"Return whether the list items can be selected or not"

	^ allowToSelect contents! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 17:53'!
allowToSelect: aBoolean
	<api: #boolean getter: #allowToSelect registration: #whenAllowToSelectChanged:>
	"Set if the list items can be selected or not"

	allowToSelect contents: aBoolean.
	aBoolean 
		ifFalse: [ self resetSelection ].! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:21'!
beMultipleSelection
	<api: #do>
	"Make list selection multiple"

	self multiSelection: true! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:21'!
beSingleSelection
	<api: #do>
	"Make list selection single"

	self multiSelection: false! !

!ListComposableModel methodsFor: 'initialize' stamp: 'SD 4/19/2012 15:26'!
defaultFilteringBlock 
	^ [:col | col]! !

!ListComposableModel methodsFor: 'initialize' stamp: 'StephaneDucasse 4/17/2012 19:15'!
defaultSortingBlock 
	^ [:a :b | true]! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:39'!
displayBlock
	<api: #inspect>
	"Return the one argument block used to wrap your domain specific items.
	The block should return something that can be displayed in a list - like a String or a Text"
	
	^ wrapBlockHolder contents! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:39'!
displayBlock: aBlock
	<api: #block getter:#displayBlock registration: #whenDisplayBlockChanged:>
	"Set the one argument block used to wrap your domain specific items.
	The block should return something that can be displayed in a list - like a String or a Text"
	
	wrapBlockHolder contents: aBlock! !

!ListComposableModel methodsFor: 'focus' stamp: 'StephaneDucasse 5/17/2012 18:17'!
eventStringForNextFocus
	"String describing the keystroke to perform to jump to the next widget"	
	^ '<right>'! !

!ListComposableModel methodsFor: 'focus' stamp: 'StephaneDucasse 5/17/2012 18:18'!
eventStringForPreviousFocus
	"String describing the keystroke to perform to jump to the previous widget"
	^ '<left>'! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:39'!
filteringBlock
	<api: #inspect>
	"Return the filtering of the items"
	
	^ filteringBlockHolder contents! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:38'!
filteringBlock: aBlock
	<api: #block getter: #filteringBlock registration: #whenFilteringBlockChanged:>
	"To set the filtering of the items"
	
	filteringBlockHolder contents: aBlock! !

!ListComposableModel methodsFor: 'private-morphic' stamp: 'StephaneDucasse 5/17/2012 18:22'!
getIndex
	"Morphic API - The method should only be used internally for the communication between the model and the morphic widget" 
	"Return the index of the selected item"
	
	^  selectionHolder index contents! !

!ListComposableModel methodsFor: 'private-morphic' stamp: 'StephaneDucasse 5/17/2012 18:24'!
getSelectionStateFor: anIndex
	"Morphic API - The method should only be used internally for the communication between the model and the morphic widget" 
	"Return the current state of the item -if selected or not - iun a multiple selection list"
	"Answer true if the item at index _anIndex_ is selected"
	
	^ (multiSelectionHolder at: anIndex ifAbsent: [ ^ false ]) == true! !

!ListComposableModel methodsFor: 'initialize' stamp: 'StephaneDucasse 5/17/2012 18:57'!
initialize

	super initialize.

	selectionHolder := SelectionValueHolder new.
	listHolder := Array new asValueHolder.
	sortingBlockHolder := self defaultSortingBlock asValueHolder.
	filteringBlockHolder := self defaultFilteringBlock asValueHolder.
	wrapBlockHolder := [ :object | object asStringOrText ] asValueHolder.
	menuHolder := [ :menu :shifted | nil ] asValueHolder.
	shortcutsHolder := [ :event :sourceMorph |  ] asValueHolder.
	multiSelectionHolder := IdentityDictionary new asValueHolder.
	multiSelection := false asValueHolder.
	allowToSelect := true asValueHolder.

	self registerEvents! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:21'!
items: aList
	<api: #st getter: #listItems registration: #whenListChanged:>
	"Set the items of the list.
	aList is a collection of your domain specific items"

	listHolder contents: (aList sorted: sortingBlockHolder contents)! !

!ListComposableModel methodsFor: 'focus' stamp: 'StephaneDucasse 5/17/2012 18:20'!
keyStroke: anEvent fromMorph: aMorph

	"Simulate a click on the selected item when space is pressed"
	anEvent keyString = String space
		ifTrue: [| item |
			item := self selectedItem. 
			(item notNil and: [ item respondsTo: #click ])
				ifTrue: [ ^ item click ]].

	"Now check the shortcuts defined by the user"
	shortcutsHolder contents cull: anEvent cull: aMorph.

	"Finally do a super call for the focus change"
	^ super keyStroke: anEvent fromMorph: aMorph! !

!ListComposableModel methodsFor: 'private-morphic' stamp: 'StephaneDucasse 5/17/2012 18:25'!
listElementAt: anIndex
	"Morphic API - The method should only be used internally for the communication between the model and the morphic widget" 
	"Return the item at index _anIndex_"
	
	^ self listItems at: anIndex ifAbsent: [ nil ]! !

!ListComposableModel methodsFor: 'private-morphic' stamp: 'BenjaminVanRyseghem 7/16/2012 19:10'!
listElementAt: anIndex ifAbsent: aBlock
	"Morphic API - The method should only be used internally for the communication between the model and the morphic widget" 
	"Return the item at index _anIndex_"
	
	^ self listItems at: anIndex ifAbsent: aBlock! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:21'!
listItems
	<api: #inspect>
	"Return the items of the list. They are your domain specific items"
	
	^ listItemsCache ifNil: [ listItemsCache :=  filteringBlockHolder contents value: listHolder contents ]
	! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:31'!
listSize
	<api: #inspect>
	"Return the size of the list"
	
	^ self listItems size! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:33'!
menu
	<api: #inspect>
	"Return the block used to defined the menu"
	
	^ menuHolder contents! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:34'!
menu: aBlock
	<api: #block getter: #menu registration: #whenMenuChanged:>
	"Set the block used to defined the menu"
	
	menuHolder contents: aBlock! !

!ListComposableModel methodsFor: 'private-morphic' stamp: 'StephaneDucasse 5/17/2012 18:49'!
menu: aMenu shifted: aBoolean
	"Morphic API - The method should only be used internally for the communication between the model and the morphic widget" 
	"Build the menu when you right click on an item"

	^ menuHolder contents cull: aMenu cull: aBoolean! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:22'!
multiSelection
	<api: #inspect>
	"Return true if the list has a multiple selection.
	False if the list has a single selection"
	
	^ multiSelection contents! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:22'!
multiSelection: aBoolean
	<api: #boolean getter: #multiSelection registration: #whenMultiSelectionChanged:>
	"Make the list seelction become multiple if aBoolean is true.
	Otherwise set the selection as single"
	
	multiSelection contents: aBoolean.
	! !

!ListComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/7/2012 13:23'!
refreshListItems

	listItemsCache := nil.
	^ self changed: #listElementAt:! !

!ListComposableModel methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/7/2012 12:28'!
registerEvents

	listHolder whenChangedDo: [ self refreshListItems ].
	filteringBlockHolder whenChangedDo: [ self refreshListItems ].
	selectionHolder index whenChangedDo: [ self changed: #getIndex ].
	multiSelection whenChangedDo: [ :b | self widget ifNotNil: [:w | w setMultipleSelection: b ] ].
	wrapBlockHolder whenChangedDo:[ self changed: #listElementAt: ].
	sortingBlockHolder
		whenChangedDo: [ 
			listHolder contents: (listHolder contents sorted: sortingBlockHolder contents).
			self changed: #listElementAt: ].
! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:22'!
resetFilteringBlock
	<api: #do>
	"Reset the filtering block with the default value which consists in showing everything"

	filteringBlockHolder contents: self defaultFilteringBlock! !

!ListComposableModel methodsFor: 'private-morphic' stamp: 'StephaneDucasse 5/17/2012 18:50'!
resetListSelection
	"Morphic API - The method should only be used internally for the communication between the model and the morphic widget" 
	"Reset the selection manager for multiple selection lists"
	
	multiSelectionHolder removeAll! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:22'!
resetSelection
	<api: #do>
	"Unselect every items"

	selectionHolder reset.
	multiSelectionHolder removeAll! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:22'!
resetSortingBlock
	<api: #do>
	"Reset the sortering block with the default value which consists in not sorting"

	sortingBlockHolder contents: self defaultSortingBlock! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:22'!
selectedIndex
	<api: #inspect>
	"Return the index of the selected item
	In the case of a multiple selection list, it returns the last selected item"

	^ self getIndex! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:22'!
selectedIndexes
	<api: #inspect>
	"Return the indexes of selected items on the case of a multiple selection list"
	
	^ multiSelectionHolder keys select: [:index | multiSelectionHolder at: index ]! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:23'!
selectedItem
	<api: #inspect>
	"Return the selected item.
	In the case of a multiple selection list, it returns the last selected item"
	
	^ self selectedItemHolder contents! !

!ListComposableModel methodsFor: 'private' stamp: 'StephaneDucasse 5/17/2012 18:04'!
selectedItemHolder

	^ selectionHolder selection! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:23'!
selectedItems
	<api: #inspect>
	"Return all the selected items in the case of a multiple selection list"

	^ multiSelectionHolder keys select: [:index | multiSelectionHolder at: index ] thenCollect: [:index | self listElementAt: index ]! !

!ListComposableModel methodsFor: 'private-morphic' stamp: 'StephaneDucasse 5/17/2012 19:18'!
setIndex: anIndex
	"Morphic API - The method should only be used internally for the communication between the model and the morphic widget" 
	"Set the index of the selected item when you click on an item"

	self allowToSelect ifFalse: [ ^ self ].
	self okToChange ifFalse: [ ^ self ].
	selectionHolder index contents: anIndex.
	selectionHolder selection contents: (self listElementAt: anIndex).! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 19:10'!
setSelectedIndex: anIndex
	<api: #integer min: 0 max: #listSize getter: #selectedIndex registration: #whenSelectionIndexChanged:>
	"Set the index of the item you want to be selected"
	| idx selection |
	
	self allowToSelect ifFalse: [ ^ self ].
	self okToChange ifFalse: [ ^ self ].
	idx := anIndex min: self listSize.
	selection := self 
					listElementAt: idx 
					ifAbsent: [ idx := 0.
								nil ].

	selectionHolder index contents: idx.
	selectionHolder selection contents: selection.! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:24'!
setSelectedItem: anItem
	<api: #st getter: #selectedItem registration: #whenSelectedItemChanged:>
	"Set the item you want to be selected"
	| index |

	self okToChange ifFalse: [ ^ self ].
	index := self listItems identityIndexOf: anItem ifAbsent: [ ^ self ].
	selectionHolder index contents: index.
	selectionHolder selection contents: anItem! !

!ListComposableModel methodsFor: 'private-morphic' stamp: 'StephaneDucasse 5/17/2012 18:55'!
setSelectionStateFor: anIndex at: aBoolean
	"Morphic API - The method should only be used internally for the communication between the model and the morphic widget" 
	"Set the selection state of the item at index _anIndex_ in the case of multiple selection list"

	self allowToSelect ifFalse: [ ^ self ].
	^ multiSelectionHolder at: anIndex put: aBoolean! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:35'!
shortcuts
	<api: #inspect>
	"Return the block used to defined the shortcuts"
	
	^ shortcutsHolder contents! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:35'!
shortcuts: aBlock
	<api: #block getter: #shortcuts registration: #whenShortcutsChanged:>
	"Set the block used to defined the shortcuts"
	
	shortcutsHolder contents: aBlock! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:40'!
sortingBlock
	<api: #inspect>
	"Return the ordering of the items"
	
	^ sortingBlockHolder contents! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:40'!
sortingBlock: aBlock
	<api: #block getter: #sortingBlock registration: #whenSortingBlockChanged:>
	"To set the ordering of the items"
	
	sortingBlockHolder contents: aBlock! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:24'!
updateList
	<api: #do>
	"Refresh the list"
	
	self changed: #listElementAt:.
	self resetSelection! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/13/2012 02:25'!
whenAllowToSelectChanged: aBlock
	<api: #event>
	"Set a block to value when the value of allowToSelect has changed"
	
	allowToSelect whenChangedDo: aBlock! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/13/2012 02:39'!
whenDisplayBlockChanged: aBlock
	<api: #event>
	"Set a block to value when the filtering block block has changed"
	
	wrapBlockHolder whenChangedDo: aBlock! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/13/2012 02:38'!
whenFilteringBlockChanged: aBlock
	<api: #event>
	"Set a block to value when the filtering block block has changed"
	
	filteringBlockHolder whenChangedDo: aBlock! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/13/2012 02:24'!
whenListChanged: aBlock
	<api: #event>
	"Specify a block to value after the contents of the list has changed"
	"Basically when you set a new list of items"

	listHolder whenChangedDo: aBlock! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/13/2012 02:34'!
whenMenuChanged: aBlock
	<api: #event>
	"Set a block to value when the menu block has changed"
	
	menuHolder whenChangedDo: aBlock! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/13/2012 02:43'!
whenMultiSelectionChanged: aBlock
	<api: #event>
	"Set a block to value when the multiSelection value has changed"
	
	multiSelection whenChangedDo: aBlock! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/13/2012 02:24'!
whenSelectedItemChanged: aBlock
	<api: #event>
	"Set a block to value when the select item is changed"
	
	selectionHolder selection whenChangedDo: aBlock! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/13/2012 02:24'!
whenSelectionChanged: aBlock
	<api: #event>
	"Set a block to value when the selection of the list has changed"

	selectionHolder whenChangedDo: aBlock.
	multiSelectionHolder whenChangedDo: aBlock.! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/13/2012 02:24'!
whenSelectionIndexChanged: aBlock
	<api: #event>
	"Set a block to value when the selection index has changed"
	
	selectionHolder index whenChangedDo: aBlock! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/13/2012 02:35'!
whenShortcutsChanged: aBlock
	<api: #event>
	"Set a block to value when the shortcuts block has changed"
	
	shortcutsHolder whenChangedDo: aBlock! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/13/2012 02:40'!
whenSortingBlockChanged: aBlock
	<api: #event>
	"Set a block to value when the sorting block has changed"
	
	sortingBlockHolder whenChangedDo: aBlock! !

!ListComposableModel methodsFor: 'private-morphic' stamp: 'BenjaminVanRyseghem 7/14/2012 16:41'!
wrapItem: anObject index: index
	"Morphic API - The method should only be used internally for the communication between the model and the morphic widget" 
	"Return the item _anObject_ wrapped"

	^ wrapBlockHolder contents cull: anObject cull: index! !

ListComposableModel subclass: #MultiColumnListModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!MultiColumnListModel commentStamp: '<historical>' prior: 0!
A MultiColumnListModel is a spec model for Multi columns list!

!MultiColumnListModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/16/2012 17:37'!
defaultSpec
	<spec>
	^ {#MultiColumnListSpec.
			#wrapSelector:. 				#wrapItem:index:.
	    		#model:. 						#model.
			#getListSizeSelector:. 			#listSize.
			#getIndexSelector:. 			#getIndex.
			#setIndexSelector:. 			#setIndex:.
			#getSelectionListSelector:.		#getSelectionStateFor:.
			#setSelectionListSelector:.		#setSelectionStateFor:at:.
			#getListElementSelector:. 		#listElementAt:.
			#resetListSelector:.				#resetListSelection.
			#getMenuSelector:.			#menu:shifted:.
			#keystrokeSelector:.			#keyStroke:fromMorph:.
			#setMultipleSelection:.			{#model. #multiSelection}.
			#borderWidth:.						#(model borderWidth).
			#borderColor:.						#(model borderColor).
			#setBalloonText:.					{ #model . #help}.
			#hResizing:. 					#spaceFill.
			#vResizing:. 					#spaceFill}! !

!MultiColumnListModel methodsFor: 'remove me' stamp: 'StephaneDucasse 5/17/2012 18:03'!
getIndex

	^ selectionHolder index contents! !

!MultiColumnListModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/14/2012 16:41'!
listElementAt: anIndex

	^ self wrapItem: (self listItems at: anIndex) index: anIndex ! !

!MultiColumnListModel methodsFor: 'morphic' stamp: 'StephaneDucasse 5/17/2012 18:03'!
setIndex: anIndex

	self allowToSelect ifFalse: [ ^ self ].
	self okToChange ifFalse: [ ^ self ].
	selectionHolder index contents: anIndex.
	selectionHolder selection contents: (self listItems at: anIndex ifAbsent: [ nil ]).! !

!MultiColumnListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 18:55'!
setSelectedIndex: anIndex
	<api: #integer min: 0 max: #listSize getter: #selectedIndex registration: #whenSelectionIndexChanged:>
	"Set the index of the item you want to be selected"
	| idx selection |
	
	self allowToSelect ifFalse: [ ^ self ].
	self okToChange ifFalse: [ ^ self ].
	self listSize isZero ifTrue:  [ ^self ].
	idx := anIndex min: self listSize.
	selection := (self listItems at: idx ifAbsent: [ nil ]).
	
	selectionHolder index contents: idx.
	selectionHolder selection contents: selection.! !

AbstractBasicWidget subclass: #RadioButtonModel
	instanceVariableNames: 'actionWhenActivatedHolder actionWhenDesactivatedHolder stateHolder labelClickableHolder labelHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!RadioButtonModel commentStamp: '<historical>' prior: 0!
A RadioButtonModel is a spec model for RadioButton

!! The method privateSetState: is really private and should only be used by RadioButtonGroup !!

You can also have a look at RadioButtonGroupExample for a full example of how to use them with a group.!

!RadioButtonModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/13/2012 05:29'!
defaultSpec
	<spec>
	^ {#CheckboxSpec.
	    		#on:selected:changeSelected:. 	#model. #state. #state:.
			#label:.								{	#model. #label		}.
			#labelClickable:.					{	#model. #labelClickable}.
			#beRadioButton.
			#hResizing:. 						#shrinkWrap.
			#vResizing:. 						#shrinkWrap.
			#setBalloonText:.					{ #model . #help}.
			#borderWidth:.						#(model borderWidth).
			#borderColor:.						#(model borderColor).
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!RadioButtonModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 6/12/2012 12:36'!
title

	^ 'Radio Button'! !

!RadioButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2012 12:36'!
actionWhenActivatedHolder
	
	^ actionWhenActivatedHolder! !

!RadioButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2012 12:36'!
actionWhenDesactivatedHolder
	
	^ actionWhenDesactivatedHolder! !

!RadioButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 16:56'!
activationAction: aBlock
	<api: #block getter: #activationAction registration: #whenActivationActionChanged:>
	"This method is used to set the action to perform when I am activated"
	
	actionWhenActivatedHolder contents: aBlock! !

!RadioButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 16:50'!
click
	<api: #do>
	"Simulate a click on the radioButton.
	Used when the checkboc is a list item"

	self toggleState! !

!RadioButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 17:05'!
desactivationAction: aBlock
	<api: #block getter: #desactivationAction registration: #whenDesactivationActionChanged:>
	"This method is used to set the action to perform when I am desactivated"
	
	actionWhenDesactivatedHolder contents: aBlock! !

!RadioButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2012 12:36'!
enabledHolder
	
	^ enabledHolder! !

!RadioButtonModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 6/12/2012 12:36'!
eventStringForNextFocus
	"String describing the keystroke to perform to jump to the next widget"
	^ '<right>'! !

!RadioButtonModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 6/12/2012 12:36'!
eventStringForPreviousFocus
	"String describing the keystroke to perform to jump to the previous widget"
	^ '<left>'! !

!RadioButtonModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 12:36'!
initialize
	"initialization code for CheckBox"

	super initialize.
	
	actionWhenActivatedHolder := [] asValueHolder.
	actionWhenDesactivatedHolder := [] asValueHolder.
	enabledHolder := true asValueHolder.
	stateHolder := false asValueHolder.
	labelClickableHolder := true asValueHolder. 
	labelHolder := '' asValueHolder.
	stateHolder whenChangedDo: [:bool |
		bool
			ifTrue: actionWhenActivatedHolder contents
			ifFalse: actionWhenDesactivatedHolder contents.
		self changed: #state ].
	labelClickableHolder whenChangedDo: [:aBoolean |
		self widget ifNotNil: [:w | w labelClickable: aBoolean ]].
	labelHolder whenChangedDo: [:label |
		self widget ifNotNil: [:w | w label: label ]].
	! !

!RadioButtonModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/16/2012 17:06'!
label
	<api: #inspect>
	^ labelHolder contents! !

!RadioButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 17:05'!
label: aString
	<api: #string getter: #label registration: #whenLabelChanged:>
	"Set the label of the radioButton"

	labelHolder contents: aString.! !

!RadioButtonModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/16/2012 17:06'!
labelClickable
	<api: #inspect>
	"Return true if the label can be clicked to select the radioButton"

	^ labelClickableHolder contents! !

!RadioButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 17:04'!
labelClickable: aBoolean
	<api: #boolean getter: #labelClickable registration: #whenLabelClickableChanged:>
	"Set if the label can be clicked to select the radioButton"
	
	labelClickableHolder contents: aBoolean! !

!RadioButtonModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/11/2012 17:13'!
privateSetState: aBoolean
	"Should only be used by RadioButtonGroup"
	
	stateHolder contents: aBoolean.
	self changed: #state! !

!RadioButtonModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/16/2012 17:06'!
state
	<api: #inspect>
	"Return the current state of the radio button"

	^ stateHolder contents! !

!RadioButtonModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/16/2012 17:06'!
state: aBoolean
	<api: #boolean getter: #state>
	"Set if the checkbox is activated or not"

	stateHolder contents: aBoolean! !

!RadioButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2012 12:36'!
stateHolder
	
	^ stateHolder! !

!RadioButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/12/2012 13:40'!
toggleState
	"Toogle the current state of the radioButton"

	self state: self state not! !

!RadioButtonModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/11/2012 17:13'!
whenActivatedDo: aBlock
	"This method is used to propagate the event that I have been activated" 
	
	stateHolder whenChangedDo: [:bool | bool ifTrue: aBlock ]! !

!RadioButtonModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 16:56'!
whenActivationActionChanged: aBlock
	<api: #event>
	"A block performed when the activation action changed"
	actionWhenActivatedHolder whenChangedDo:  aBlock ! !

!RadioButtonModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 16:57'!
whenChangedDo: aBlock
	<api: #event>
	"This method is used to propagate the event that I have changed"
	
	stateHolder whenChangedDo: aBlock! !

!RadioButtonModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/11/2012 17:13'!
whenDesactivatedDo: aBlock
	"This method is used to propagate the event that I have been desactivated"
	
	stateHolder whenChangedDo: [:bool | bool ifFalse: aBlock ]! !

!RadioButtonModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 16:59'!
whenDesactivationActionChanged: aBlock
	<api: #event>
	"A block performed when the desactivation action changed"
	actionWhenDesactivatedHolder whenChangedDo:  aBlock ! !

!RadioButtonModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 17:01'!
whenLabelChanged: aBlock
	"A block performed when the label changed"
	<api: #event>
	
	labelHolder whenChangedDo:  aBlock ! !

!RadioButtonModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 17:02'!
whenLabelClickableChanged: aBlock
	"A block performed when the label click is activated or descativated"
	<api: #event>
	
	labelClickableHolder whenChangedDo:  aBlock ! !

AbstractBasicWidget subclass: #SliderModel
	instanceVariableNames: 'max min quantum value isSetting isChanging absoluteValue labelHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!SliderModel commentStamp: '<historical>' prior: 0!
A SliderModel is a spec model for a slider!

!SliderModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/18/2012 16:45'!
defaultSpec
	<spec>
	
	^ SpecLayout slider
		send: #model: withArguments: #( model );
		send: #getValueSelector: withArguments: #(value);
		send: #setValueSelector: withArguments: #( value: );
		send: #value: withArguments: #(#(model absoluteValue));
		send: #getLabelSelector: withArguments: #( label );
		send: #max: withArguments: #(#(model max));
		send: #min: withArguments: #(#(model min));		
		send: #quantum: withArguments: #(#(model quantum));
		send: #borderWidth: withArguments: #(#(model borderWidth));
		send: #borderColor: withArguments: #(#(model borderColor));
		send:#setBalloonText: withArguments:	#(#(model help));
		send: #eventHandler: withArguments: #(#(EventHandler on:send:to: keyStroke keyStroke:fromMorph: model));
		send: #vSpaceFill;
		send: #hSpaceFill;
		yourself! !

!SliderModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/16/2012 17:14'!
absoluteValue
	<api: #inspect>
	"Return the position of the slider in a scale between 0 and 1 despite of the min and max value"
	^ absoluteValue contents! !

!SliderModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/16/2012 17:26'!
absoluteValue: aFloat
	<api: #float min: 0 max: 1 getter:#absoluteValue registration: #whenAbsoluteValueChanged:>
	"Set the position of the slider in a scale between 0 and 1 despite of the min and max value"

	absoluteValue contents: aFloat! !

!SliderModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/18/2012 18:59'!
color: aColor

	self widget ifNotNil: [:w | w == self ifFalse: [ super color: aColor ]]! !

!SliderModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/12/2012 19:17'!
defaultValue

	^ 50! !

!SliderModel methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/18/2012 16:47'!
initialize
	"Initialization code for SliderModel"

	super initialize.

	max := 10 asValueHolder.
	min := 0 asValueHolder.
	quantum := 1 asValueHolder.
	value := 5 asValueHolder.
	absoluteValue := 0.5 asValueHolder.
	labelHolder := '' asValueHolder.
	isChanging := false.
	
	max whenChangedDo: [:m | self widget ifNotNil: [:w | w max: m ]].
	min whenChangedDo: [:m | self widget ifNotNil: [:w | w min: m ]].
	quantum whenChangedDo: [:m | self widget ifNotNil: [:w | w quantum: m ]].
	
	value whenChangedDo: [:v |
		isChanging ifFalse: [
			isChanging := true.
			self absoluteValue: ((v-self min)/(self max-self min)).
			self widget ifNotNil: [:w | w == self ifFalse: [ w scaledValue: v ]].
			isChanging := false ]].
	
	absoluteValue whenChangedDo: [:v | 
		isChanging ifFalse: [
			isChanging := true.
			self value: (self min+(v*(self max-self min)) roundTo: self quantum).
			self widget ifNotNil: [:w | w == self ifFalse: [ w value: v ]].
			isChanging := false ]].
	
	labelHolder whenChangedDo: [	self widget ifNotNil: [:w | w updateLabel ]].! !

!SliderModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/18/2012 16:45'!
label
	<api: #inspect>
	"Return the label of the slider"
	
	^ labelHolder contents! !

!SliderModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 16:46'!
label: aString
	<api: #string getter: #label registration: #whenLabelChanged:>
	"Set the label of the slider"
	
	labelHolder contents: aString! !

!SliderModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/16/2012 17:32'!
max
	<api: #inspect>
	"Return the maximun value"
	
	^ max contents! !

!SliderModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 17:34'!
max: anObject
	<api: #integer min: 1 max: 100 getter:#max registration: #whenMaxChanged:>
	"Set the maximun value"

	max contents: anObject! !

!SliderModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/16/2012 17:33'!
min
	<api: #inspect>
	"Return the minimum value"
	
	^ min contents! !

!SliderModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 17:34'!
min: anObject
	<api: #integer min: 0 max: 99 getter:#min registration: #whenMinChanged:>
	"Set the minimum value"
	
	min contents: anObject! !

!SliderModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/16/2012 17:33'!
quantum
	<api: #inspect>
	"Return the quantum betwen values"

	^ quantum contents! !

!SliderModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 17:33'!
quantum: aNumber
	<api: #integer min: #min max: #max getter:#quantum registration: #whenQuantumChanged:>
	"Set the quantum betwen values"

	quantum contents: aNumber! !

!SliderModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 17:57'!
reset
	<api:#do>
	"Reset the cursor to the minimum value"
	
	self value: self min! !

!SliderModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/16/2012 17:33'!
value
	<api: #inspect>
	"Return the current value in a range between min and max"

	^ value contents! !

!SliderModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 17:30'!
value: aNumber
	<api: #integer min: #min max: #max getter:#value registration: #whenValueChanged:>
	"Set the value in a range between min and max"

	value contents: aNumber.
	self changed: #value.! !

!SliderModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 17:35'!
whenAbsoluteValueChangedDo: aBlock
	<api: #event>
	"Block performed when the absolute value changed"

	absoluteValue whenChangedDo: aBlock! !

!SliderModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/18/2012 16:46'!
whenLabelChangedDo: aBlock
	<api: #event>
	"Block performed when the label changed"

	labelHolder whenChangedDo: aBlock! !

!SliderModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 17:35'!
whenMaxChangedDo: aBlock 
	<api: #event>
	"Block performed when the maximum value changed"

	max whenChangedDo: aBlock! !

!SliderModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 17:35'!
whenMinChangedDo: aBlock 
	<api: #event>
	"Block performed when the minimum value changed"

	min whenChangedDo: aBlock! !

!SliderModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 17:35'!
whenQuantumChangedDo: aBlock 
	<api: #event>
	"Block performed when the quantum value changed"

	quantum whenChangedDo: aBlock! !

!SliderModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 17:35'!
whenValueChangedDo: aBlock 
	<api: #event>
	"Block performed when the value changed"

	value whenChangedDo: aBlock! !

AbstractBasicWidget subclass: #TextModel
	instanceVariableNames: 'aboutToStyleHolder behaviorHolder textHolder actionToPerformHolder readSelectionHolder actionPerformedHolder isCodeCompletionAllowedHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!TextModel commentStamp: '<historical>' prior: 0!
A TextComposableModel is an applicative model which handle a basic text.

| t |
t:= TextComposableModel new.
t openWithSpec.
t textHolder contents: 'This is a test'.

self example!

TextModel subclass: #TextInputFieldModel
	instanceVariableNames: 'ghostText alwaysAccept acceptOnCR autoAccept entryCompletion isEncrypted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!TextInputFieldModel commentStamp: '<historical>' prior: 0!
A TextInputFieldModel is a spec model for TextInputField.!

!TextInputFieldModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/13/2012 05:29'!
defaultSpec
	<spec>
	^ {#TextField.
			#convertTo:. 							String.
			#on:text:accept:readSelection:menu:. 	#model. #getText. #accept:. nil. nil.
			#entryCompletion:. 				{	#model. 	#entryCompletion	}.
			#autoAccept:.						{	#model. 	#autoAccept			}.	
			#acceptOnCR:. 					{	#model. 	#acceptOnCR			}.
			#ghostText:.						{	#model. 	#ghostText			}.
			#enabled:.							{	#model. 	#enabled				}.
			#encrypted:.						{ 	#model.	#encrypted			}.
			#borderWidth:.						#(model borderWidth).
			#borderColor:.						#(model borderColor).
			#setBalloonText:.					{ #model . #help}.
			#hResizing:. 							#spaceFill.
			#vResizing:. 							#spaceFill.
			#hideScrollBarsIndefinitely.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!TextInputFieldModel class methodsFor: 'example' stamp: ''!
example
	| instance |
	
	instance := self new.
	instance openWithSpec.
	instance ghostText: 'This is a ghost'.
	instance text: 'This is a text'! !

!TextInputFieldModel class methodsFor: 'specs' stamp: ''!
title

	^ 'Text'! !

!TextInputFieldModel methodsFor: 'morphic' stamp: 'StephaneDucasse 5/17/2012 17:45'!
accept: aText

	textHolder contents: aText.
	actionToPerformHolder contents cull: aText.
	self changed: #clearUserEdits.! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 21:56'!
acceptOnCR
	<api: #inspect>
	"Return true if the text is accepted when the Enter key is stroked"

	^ acceptOnCR contents! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 21:57'!
acceptOnCR: aBoolean
	<api: #boolean getter: #acceptOnCR registration: #whenAcceptOnCRChanged:>
	"Set if the text is accepted when the Enter key is stroked or not"

	acceptOnCR contents: aBoolean! !

!TextInputFieldModel methodsFor: 'accessing' stamp: ''!
actionToPerformHolder

	^ actionToPerformHolder! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 21:59'!
autoAccept 
	<api: #inspect>
	"Return true if the text is accepted after ech keystroke"

	^ autoAccept contents! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 21:59'!
autoAccept: aBoolean
	<api: #boolean getter: #autoAccept registration: #whenAutoAcceptChanged:>
	"Set if the text is accepted after each keystroke or not"

	autoAccept contents: aBoolean.! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 22:01'!
beDecrypted
	<api: #do>
	"Decrypt the entered text"
	
	self encrypted: false! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 22:02'!
beEncrypted
	<api: #do>
	"Encrypt the entered text"
	
	self encrypted: true! !

!TextInputFieldModel methodsFor: 'private' stamp: 'EstebanLorenzano 8/17/2012 16:41'!
defaultEntryCompletion

	| applicants |
	applicants := (Array
				streamContents: [:strm | Symbol
						allSymbolTablesDo: [:each | (each notEmpty
									and: [each first canBeGlobalVarInitial
											and: [Smalltalk globals includesKey: each]])
								ifTrue: [strm nextPut: each]]]) sort.

	^ EntryCompletion new
				dataSourceBlock: [:currText | applicants];
				filterBlock: [:currApplicant :currText | currText size > 3
						and: [currApplicant asUppercase includesSubstring: currText asString asUppercase]].! !

!TextInputFieldModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 14:52'!
encrypted

	^ isEncrypted contents! !

!TextInputFieldModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 14:53'!
encrypted: aBoolean

	isEncrypted contents: aBoolean ! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 22:03'!
entryCompletion
	<api: #st getter: #entryCompletion registration: #whenEntryCompletionChanged:>
	"Return an entry completion used to suggest text while typing"

	^ entryCompletion contents! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 22:03'!
entryCompletion: anEntryCompletion
	<api: #st getter: #entryCompletion registration: #whenEntryCompletionChanged:>
	"Set an entry completion used to suggest text while typing"

	entryCompletion contents: anEntryCompletion.! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 22:04'!
ghostText
	<api: #inspect>
	"Return the ghost text of the text zone"

	^ ghostText contents! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 22:05'!
ghostText: aText
	<api: #string getter: #ghostText registration: #whenGhostTextChanged:>
	"Set the ghost text of the text zone"

	ghostText contents: aText translated.! !

!TextInputFieldModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/4/2012 14:51'!
initialize
	"Initialization code for TextComposableModel"

	super initialize.
	
	ghostText := '' asValueHolder.
	acceptOnCR := true asValueHolder.
	autoAccept := false asValueHolder.
	entryCompletion := self defaultEntryCompletion asValueHolder.
	isEncrypted := false asValueHolder.
	
	ghostText  whenChangedDo: [:txt | self widget ifNotNil: [:w | w ghostText: txt ]].
	acceptOnCR whenChangedDo: [:bool | self widget ifNotNil: [:w | w acceptOnCR: bool ]].
	autoAccept whenChangedDo: [:bool | self widget ifNotNil: [:w | w autoAccept: bool ]].
	isEncrypted whenChangedDo: [:bool | self widget ifNotNil: [:w | w encrypted: bool ]].! !

!TextInputFieldModel methodsFor: 'NOCompletion' stamp: 'BenjaminVanRyseghem 6/25/2012 23:46'!
isCodeCompletionAllowed
	
	^ false! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 22:06'!
removeEntryCompletion
	< api:#do>
	"Remove the entry completion"
	
	self entryCompletion: nil! !

!TextInputFieldModel methodsFor: 'accessing' stamp: ''!
textHolder

	^ textHolder! !

!TextInputFieldModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/19/2012 21:58'!
whenAcceptOnCRChanged: aBlock
	<api: #event>
	"aBlock will be performed when acceptOnCR changed"
	
	acceptOnCR whenChangedDo: aBlock! !

!TextInputFieldModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/19/2012 22:00'!
whenAutoAcceptChanged: aBlock
	<api: #event>
	"aBlock will be performed when autoAccept changed"
	
	autoAccept whenChangedDo: aBlock! !

!TextInputFieldModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/19/2012 22:04'!
whenEntryCompletionChanged: aBlock
	<api: #event>
	"aBlock will be performed when entryCompletion changed"
	
	entryCompletion whenChangedDo: aBlock! !

!TextInputFieldModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/19/2012 22:05'!
whenGhostTextChanged: aBlock
	<api: #event>
	"aBlock will be performed when ghostText changed"
	
	ghostText whenChangedDo: aBlock! !

!TextModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/13/2012 05:30'!
defaultSpec
	<spec>
	
	^ SpecLayout text
			send: #on:text:accept:readSelection:menu: withArguments: #(model getText accept:notifying: readSelection codePaneMenu:shifted:);
			send: #classOrMetaClass: withArguments: {#(model behavior)};
			send: #enabled: withArguments: {#(model enabled)};
			send: #borderWidth: withArguments: #(#(model borderWidth));
			send: #borderColor: withArguments: #(#(model borderColor));
			send:#setBalloonText: withArguments:	{ #(model help)};
			send: #eventHandler: withArguments: {#(EventHandler on:send:to: keyStroke keyStroke:fromMorph: model)};
			send: #vSpaceFill;
			send: #hSpaceFill;
			yourself! !

!TextModel class methodsFor: 'example' stamp: ''!
example
	| instance |
	
	instance := self new.
	instance openWithSpec.
	instance text: 'This is a test'.! !

!TextModel class methodsFor: '*Spec-Builder' stamp: 'bvr 5/31/2012 13:34'!
possibleEvents

	^ #(whenTextChanged:)! !

!TextModel class methodsFor: 'specs' stamp: ''!
title

	^ 'Text'! !

!TextModel methodsFor: 'protocol-shout' stamp: 'BenjaminVanRyseghem 7/16/2012 22:12'!
aboutToStyle: aBoolean	
	<api: #boolean getter: #isAboutToStyle registration: #whenAboutToStyleChanged:>
	"Set if the text zone must be styled"
	
	aboutToStyleHolder contents: [ aBoolean ]! !

!TextModel methodsFor: 'protocol-shout' stamp: 'BenjaminVanRyseghem 7/16/2012 20:11'!
aboutToStyleBlock
	<api: #inspect>
	"Return the block used to know if the text must be styled"	

	^ aboutToStyleHolder contents! !

!TextModel methodsFor: 'protocol-shout' stamp: 'BenjaminVanRyseghem 7/16/2012 22:21'!
aboutToStyleBlock: aBlockReturningABoolean
	<api: #block getter: #aboutToStyleBlock registration: #whenAboutToStyleBlockChanged:>
	"Set the block used to know if the text must be styled.
	The block must return a boolean"

	aboutToStyleHolder contents: aBlockReturningABoolean! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 19:37'!
accept
	<api: #do>
	"Accep the current pendingtext"
	
	self widget ifNotNil: [:w | w accept ]! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 6/12/2012 13:51'!
accept: aText notifying: aNotifyier

	textHolder contents: aText.
	actionToPerformHolder contents cull: aText cull: aNotifyier.
	
	"Dummy changed to raise an announcement"
	actionPerformedHolder contents: nil.
	self changed: #clearUserEdits.! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 22:13'!
acceptBlock
	<api: #inspect>
	"Return the block to perform when the text is accepted.
	The block must have one argument, which will be the accepted text"

	^ actionToPerformHolder contents! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 22:13'!
acceptBlock: aBlockWithOneArgument
	<api: #block getter: #acceptBlock registration: #whenAcceptBlockChanged:>
	"Set the block to perform when the text is accepted.
	The block must have one argument, which will be the accepted text"

	actionToPerformHolder contents: aBlockWithOneArgument! !

!TextModel methodsFor: 'protocol-shout' stamp: 'BenjaminVanRyseghem 7/16/2012 20:12'!
behavior
	<api: #inspect>
	"Return the class corresponding to the method class of the source code you are editing"
	
	^ behaviorHolder contents! !

!TextModel methodsFor: 'protocol-shout' stamp: 'BenjaminVanRyseghem 7/16/2012 20:13'!
behavior: aClass
	< api: #st getter: #behavior registration: #whenBehaviorChanged:>
	"Set the class corresponding to the method class of the source code you are editing"

	behaviorHolder contents: aClass! !

!TextModel methodsFor: 'morphic' stamp: ''!
clearUserEditFlag
	
	self text: self getText.
	self changed: #clearUserEdits! !

!TextModel methodsFor: 'morphic' stamp: ''!
codePaneMenu: aMenu shifted: shifted 
	"Note that unless we override perform:orSendTo:, 
	PluggableTextController will respond to all menu items in a 
	text pane"
	
	^ shifted
			ifTrue: [SmalltalkEditor shiftedYellowButtonMenu]
			ifFalse: [SmalltalkEditor yellowButtonMenu].! !

!TextModel methodsFor: 'morphic' stamp: ''!
doItContext

	^ nil! !

!TextModel methodsFor: 'morphic' stamp: ''!
doItReceiver

	^ self selectedBehavior
		ifNil: [ nil ]
		ifNotNil: [:class | class theNonMetaClass ]! !

!TextModel methodsFor: 'focus' stamp: 'StephaneDucasse 5/17/2012 17:47'!
eventStringForNextFocus
	"String describing the keystroke to perform to jump to the next widget"
	^ '<Ctrl-Cmd-right>'! !

!TextModel methodsFor: 'focus' stamp: 'StephaneDucasse 5/17/2012 17:47'!
eventStringForPreviousFocus
	"String describing the keystroke to perform to jump to the previous widget"

	^ '<Ctrl-Cmd-left>'! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 19:38'!
getSelection
	<api:#inspect>
	"Get the text selection"

	self widget
		ifNil: [ self readSelection ]
		ifNotNil: [:w | w selectionInterval ]! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/16/2012 20:10'!
getText
	<api: #inspect>	
	^ textHolder contents! !

!TextModel methodsFor: 'NOCompletion' stamp: 'BenjaminVanRyseghem 6/22/2012 14:17'!
guessTypeForName: aString

	^nil! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 19:38'!
hasEditingConflicts
	<api:#inspect>
	"Return if the text zone has editing conflicts"

	^ self widget 
		ifNil: [ false ]
		ifNotNil: [:w | w hasEditingConflicts ]! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 19:39'!
hasEditingConflicts: aBoolean
	<api:#boolean getter: #hasEditingConflicts>
	"Set if the text zone has editing conflicts"

	^ self widget 
		ifNil: [ false ]
		ifNotNil: [:w | w hasEditingConflicts: aBoolean ]! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 20:03'!
hasUnacceptedEdits
	<api:#inspect>
	"Return if the text zone has unaccepted edits (orange corner)"

	^ self widget 
		ifNil: [ false ]
		ifNotNil: [:w | w hasUnacceptedEdits ]! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 20:03'!
hasUnacceptedEdits: aBoolean
	<api:#boolean getter: #hasUnacceptedEdits>
	"Return if the text zone has unaccepted edits (orange corner)"

	^ self widget 
		ifNil: [ false ]
		ifNotNil: [:w | w hasUnacceptedEdits: aBoolean ]! !

!TextModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/4/2012 14:50'!
initialize
	"Initialization code for TextComposableModel"

	super initialize.
	
	textHolder := '' asValueHolder.
	behaviorHolder := nil asValueHolder.
	aboutToStyleHolder := [ false ] asValueHolder.
	actionToPerformHolder := [ :text |  ] asValueHolder.
	readSelectionHolder := [ 1 to: 0 ] asValueHolder.
	enabledHolder := true asValueHolder.
	actionPerformedHolder := nil asValueHolder.
	isCodeCompletionAllowedHolder := true asValueHolder.
	
	self registerEvents.
	self registerEventsForShout! !

!TextModel methodsFor: 'protocol-shout' stamp: 'BenjaminVanRyseghem 7/16/2012 20:13'!
isAboutToStyle
	< api: #inspect>
	"Return if the text zone is shouted or not"

	^ self aboutToStyleBlock value! !

!TextModel methodsFor: 'NOCompletion' stamp: 'BenjaminVanRyseghem 7/16/2012 20:04'!
isCodeCompletionAllowed
	<api:#inspect>
	"Return if code completion is allowed"
	
	^ isCodeCompletionAllowedHolder contents! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 20:05'!
isCodeCompletionAllowed: aBoolean
	<api: #boolean getter: #isCodeCompletionAllowed registration: #whenCodeCompletionAllowedChanged:>
	"Set if code completion is allowed"
	
	isCodeCompletionAllowedHolder contents: aBoolean! !

!TextModel methodsFor: 'private-shout' stamp: ''!
okToStyle

	^ true! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 20:05'!
pendingText
	<api: #inspect>
	"Return the current pending text"

	self widget
		ifNil: [ ^ self getText ]
		ifNotNil: [:w |  ^ w text ]! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 20:07'!
pendingText: aText
	<api: #string getter: #pendingText>
	"Set the pending text. Do no accept it"

	self widget
		ifNil: [ self text: aText ]
		ifNotNil: [:w |
			w setText: aText.
			w hasUnacceptedEdits: true ]! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/16/2012 20:10'!
readSelection
	<api: #inspect>
	^ readSelectionHolder contents cull: (self widget ifNil: [ nil ] ifNotNil: [:w | w text ]) cull: self! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 20:07'!
readSelectionBlock
	<api: #inspect>
	"Return the block used to calculate the text selection"

	^ readSelectionHolder contents! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 20:08'!
readSelectionBlock: aBlock
	<api: #block getter: #readSelectionBlock registration: #whenReadSelectionIsChanged:>
	"Set the block used to calculate the text selection"

	^ readSelectionHolder contents: aBlock! !

!TextModel methodsFor: 'NOCompletion' stamp: 'BenjaminVanRyseghem 6/22/2012 14:18'!
receiverClass

	^ self behavior! !

!TextModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/7/2012 12:29'!
registerEvents

	textHolder whenChangedDo: [ self changed: #getText ].
	readSelectionHolder whenChangedDo: [ self changed: #readSelection ].
	enabledHolder whenChangedDo: [ :bool | self widget ifNotNil: [:w | w enabled: bool ] ]! !

!TextModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/7/2012 12:29'!
registerEventsForShout
	aboutToStyleHolder whenChangedDo: [ self changed: #getText ].
	behaviorHolder
		whenChangedDo: [ :class | 
			self widget ifNotNil: [ :w | w classOrMetaClass: class ].
			self changed: #getText ]! !

!TextModel methodsFor: 'morphic' stamp: 'StephaneDucasse 5/17/2012 17:45'!
selectedBehavior

	^ behaviorHolder contents! !

!TextModel methodsFor: 'NOCompletion' stamp: 'BenjaminVanRyseghem 6/22/2012 14:19'!
selectedClassOrMetaClass

	^ self behavior! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 20:08'!
setSelection: anInterval
	<api: #st getter: #getSelection>
	"Set the text selection without changing the readSelectionBlock"

	self widget
		ifNotNil: [:w | w selectionInterval: anInterval ]! !

!TextModel methodsFor: 'morphic' stamp: 'StephaneDucasse 5/17/2012 17:44'!
shoutAboutToStyle: aMorph
	
	^ self isAboutToStyle! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 20:09'!
text: aText
	<api: #string getter: #getText registration: #whenTextChanged:>
	"Set the text of the text zone"
	
	textHolder contents: aText! !

!TextModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 22:21'!
whenAboutToStyleBlockChanged: aBlock
	<api: #event>
	"Set a block to perform when the about to style block changed"
	
	aboutToStyleHolder whenChangedDo: aBlock! !

!TextModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 22:24'!
whenAboutToStyleChanged: aBlock
	<api: #event>
	"Set a block to perform when the about to style block changed"
	
	self whenAboutToStyleBlockChanged: [:block :old :announcement :announcer | 
		aBlock cull: (block value) cull: old cull: announcement cull: announcer ]! !

!TextModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 22:14'!
whenAcceptBlockChanged: aBlock
	<api: #event>
	"Set a block to perform when the accept block changed"
	
	actionToPerformHolder whenChangedDo: aBlock! !

!TextModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 20:13'!
whenBehaviorChanged: aBlock
	<api: #event>
	"Set a block to perform when the behavior class changed"
	
	behaviorHolder whenChangedDo: aBlock! !

!TextModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 22:11'!
whenCodeCompletionAllowedChanged: aBlock
	<api: #event>
	"Set a block to perform when the code completion value changed"
	
	actionPerformedHolder whenChangedDo: aBlock! !

!TextModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 20:11'!
whenReadSelectionIsChanged: aBlock
	<api: #event>
	"Set a block to perform when the read selection block changed"
	
	readSelectionHolder whenChangedDo: aBlock! !

!TextModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 22:11'!
whenTextChanged: aBlock
	<api: #event>
	"Set a block to perform when the text changed"
	
	textHolder whenChangedDo: aBlock! !

!TextModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 22:11'!
whenTextIsAccepted: aBlock
	<api: #event>
	"Set a block to perform when the text is accepted"
	
	actionPerformedHolder whenChangedDo: aBlock! !

AbstractBasicWidget subclass: #TreeModel
	instanceVariableNames: 'childrenBlockHolder rootsHolder selectionHolder menuBlockHolder wrapBlockHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!TreeModel commentStamp: '<historical>' prior: 0!
A TreeModel is a spec model of a Tree ;)!

!TreeModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/13/2012 05:29'!
defaultSpec
	<spec>
	
	^ {#TreeSpec.
	    		#model:.							#model.
			#getLabelSelector:.				#wrapItem:.
			#getRootsSelector:.				#getRoots.
			#getChildrenSelector:.				#getChildrenFor:.
			#setSelectedSelector:.			#setSelectedItem:.
			#color:.							Color white.
			#getMenuSelector:.				#getMenu:.
			#hResizing:. 						#spaceFill.
			#setBalloonText:.					{ #model . #help}.
			#borderColor:.						#(model borderColor).
			#borderWidth:.						#(model borderWidth).
			#vResizing:. 						#spaceFill.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!TreeModel class methodsFor: 'example' stamp: 'bvr 6/2/2012 12:46'!
example
	| m |

	m := TreeModel new.
	m openWithSpec.
	m roots: #(a b c d).
	m childrenBlock: [:it | it = #c 
							ifTrue: [ {1. 2. 3} ]
							ifFalse: [ {} ]].
	m displayBlock: [:item | item isSymbol
								ifTrue: [ item, ' symbol' ]
								ifFalse: [ item printString ]].! !

!TreeModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 4/13/2012 14:38'!
title

	^ 'Tree'! !

!TreeModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 22:10'!
childrenBlock
	< api: #inspect>
	"Return the block used to retrieve the children of a node.
	The optional block arguments are:
		- the node
		- the tree"

	^ childrenBlockHolder contents! !

!TreeModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 22:11'!
childrenBlock: aBlock
	< api: #block getter: #childrenBlock registration: #whenChildrenBlockChanged:>
	"Set the block used to retrieve the children of a node.
	The optional block arguments are:
		- the node
		- the tree"

	childrenBlockHolder contents: aBlock! !

!TreeModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 22:10'!
displayBlock
	< api: #inspect>
	"Return the block used to generate the display of the items.
	The optioanl block arguments are:
		- the item
		- the tree"

	^ wrapBlockHolder contents! !

!TreeModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 22:12'!
displayBlock: aBlock
	< api: #block getter: #displayBlock registration: #whenDisplayBlockChanged:>
	"Set the block used to generate the display of the items.
	The optioanl block arguments are:
		- the item
		- the tree"

	wrapBlockHolder contents: aBlock! !

!TreeModel methodsFor: 'focus' stamp: 'StephaneDucasse 5/17/2012 18:17'!
eventStringForNextFocus
	"String describing the keystroke to perform to jump to the next widget"
	^ '<right>'! !

!TreeModel methodsFor: 'focus' stamp: 'StephaneDucasse 5/17/2012 18:18'!
eventStringForPreviousFocus
	"String describing the keystroke to perform to jump to the previous widget"
	^ '<left>'! !

!TreeModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 4/13/2012 14:24'!
getChildrenFor: anItem

		^ childrenBlockHolder contents cull: anItem cull: self! !

!TreeModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 4/13/2012 14:29'!
getMenu: aMenu

	menuBlockHolder contents cull: aMenu cull: self.
	^ aMenu! !

!TreeModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 6/6/2012 20:45'!
getRoots
							
	^ rootsHolder contents! !

!TreeModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 4/13/2012 14:36'!
initialize
	"Initialization code for TreeModel"

	super initialize.

	childrenBlockHolder := [ {} ] asValueHolder.
	rootsHolder := {} asValueHolder.
	selectionHolder := nil asValueHolder.
	menuBlockHolder := [] asValueHolder.
	wrapBlockHolder := [:item | item printString ] asValueHolder.

	self registerEvents! !

!TreeModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 22:13'!
menu
	<api: #inspect>
	"Return the block used to generate the tree menu"

	^ menuBlockHolder contents! !

!TreeModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 22:14'!
menu: aBlock
	< api: #block getter: #menu registration: #whenMenuChanged:>
	"Set the block used to generate the tree menu"

	menuBlockHolder contents: aBlock! !

!TreeModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/13/2012 16:31'!
registerEvents

	rootsHolder whenChangedDo: [ self changed: #getRoots ].
	childrenBlockHolder whenChangedDo: [ self changed: #getRoots ].
	wrapBlockHolder whenChangedDo: [ self changed: #getRoots ].! !

!TreeModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 22:15'!
roots
	< api: #inspect>
	"Return the tree roots"

	^ rootsHolder contents! !

!TreeModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 22:15'!
roots: aCollection
	< api: #st getter: #roots registration: #whenRootsChanged:>
	"Set the tree roots"

	rootsHolder contents: aCollection! !

!TreeModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 22:16'!
selectedItem
	< api: #inspect>
	"Return the selected item"
	"In the case of a multiple selection list, it returns the last selected item"
	
	^ selectionHolder contents! !

!TreeModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 22:17'!
selectedItem: anItem
	< api: #st getter: #selectedItem registration: #whenSelectedItemChanged:>
	"Set the selected item"
	"In the case of a multiple selection list, it returns the last selected item"
	
	selectionHolder contents: anItem! !

!TreeModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 4/13/2012 14:30'!
setSelectedItem: anItem

	selectionHolder contents: anItem.! !

!TreeModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/19/2012 22:18'!
updateTree
	< api: #do>
	"Force the tree to refresh"

	self changed: #getRoots! !

!TreeModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/19/2012 22:11'!
whenChildrenBlockChanged: aBlock
	"Set a block to perform when a new childrenBlock is set"

	childrenBlockHolder whenChangedDo: aBlock! !

!TreeModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/19/2012 22:12'!
whenDisplayBlockChanged: aBlock
	"Set a block to perform when a new displayBlock is set"

	wrapBlockHolder whenChangedDo: aBlock! !

!TreeModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/19/2012 22:14'!
whenMenuChanged: aBlock
	"Set a block to perform when a new menuBlock is set"

	menuBlockHolder whenChangedDo: aBlock! !

!TreeModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 6/12/2012 14:03'!
whenSelectedItemChanged: aBlock
	"Set a block to perform when a new item is selected"

	selectionHolder whenChangedDo: aBlock! !

!TreeModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 4/13/2012 14:35'!
wrapItem: anItem

	^ wrapBlockHolder contents cull: anItem cull: self! !

AbstractBasicWidget subclass: #WindowModel
	instanceVariableNames: 'model initialExtent title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!WindowModel commentStamp: '<historical>' prior: 0!
A WindowModel is a spec model for a Window!

WindowModel subclass: #DialogWindowModel
	instanceVariableNames: 'contentMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets'!

!DialogWindowModel commentStamp: '<historical>' prior: 0!
A DialogWindowModel is a model used to describe a DialogWindow!

!DialogWindowModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/10/2012 16:22'!
defaultSpec
	<spec>
	
	^ #( DialogWindowSpec 
			specWidget: #(model contentMorph)
			initialize
			model: model )! !

!DialogWindowModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/12/2012 18:02'!
buildWithSpec: aSpec
	"Build the widget using the spec name provided as argument"
	| widget |
	
	(self spec notNil and: [ self needRebuild not ])
		ifTrue: [ widget := self spec instance ]
		ifFalse: [ 
			contentMorph := self model ifNil: [ nil ] ifNotNil: [:m | m buildWithSpec: aSpec ].
			widget := SpecInterpreter buildMorphFor: self withSpec: self defaultSpecSelector.
			contentMorph := nil ].

	self extent ifNotNil: [:ex | 
		(widget respondsTo: #extent:)
			ifTrue: [ widget extent: ex ]].
		
	^ widget! !

!DialogWindowModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/10/2012 16:34'!
buildWithSpecLayout: aSpec
	"Build the widget using the spec name provided as argument"
	| widget |
	
	(self spec notNil and: [ self needRebuild not ])
		ifTrue: [ widget := self spec instance ]
		ifFalse: [ 
			contentMorph := self model buildWithSpecLayout: aSpec.
			widget := SpecInterpreter buildMorphFor: self withSpec: self defaultSpecSelector.
			contentMorph := nil ].

	self extent ifNotNil: [:ex | 
		(widget respondsTo: #extent:)
			ifTrue: [ widget extent: ex ]].
		
	^ widget! !

!DialogWindowModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/10/2012 16:25'!
cancelAction: aBlock

	^ self widget
		ifNotNil: [:w | w cancelAction: aBlock ]! !

!DialogWindowModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/10/2012 16:25'!
cancelled

	^ self widget
		ifNil: [ false ]
		ifNotNil: [:w | w cancelled ]! !

!DialogWindowModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/10/2012 16:14'!
contentMorph

	^ contentMorph! !

!DialogWindowModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/10/2012 16:25'!
okAction: aBlock

	^ self widget
		ifNotNil: [:w | w okAction: aBlock ]! !

!DialogWindowModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/10/2012 16:25'!
toolbar

	^ self widget
		ifNotNil: [:w | w toolbar ]! !

!WindowModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/10/2012 15:09'!
defaultSpec
	<spec>
	
	^ #( WindowSpec model: model )! !

!WindowModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/31/2012 14:42'!
addModelIn: widget withSpec: aSpec

	self model ifNil: [ ^ self ].
	
	widget
		addMorph: (self model buildWithSpec: aSpec)
		frame: (0@0 corner: 1@1)! !

!WindowModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/10/2012 15:43'!
addModelIn: widget withSpecLayout: aSpec

	self model ifNil: [ ^ self ].
	widget
		addMorph: (self model buildWithSpecLayout: aSpec)
		frame: (0@0 corner: 1@1)! !

!WindowModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/10/2012 15:42'!
buildWithSpec: aSpec
	"Build the widget using the spec name provided as argument"
	| widget |
	
	(self spec notNil and: [ self needRebuild not ])
		ifTrue: [ widget := self spec instance ]
		ifFalse: [ 
			widget := SpecInterpreter buildMorphFor: self withSpec: self defaultSpecSelector.
			self addModelIn: widget withSpec: aSpec ].

	self extent ifNotNil: [:ex | 
		(widget respondsTo: #extent:)
			ifTrue: [ widget extent: ex ]].
		
	^ widget! !

!WindowModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/11/2012 00:12'!
buildWithSpecLayout: aSpec
	"Build the widget using the spec name provided as argument"
	| widget |
	
	(self spec notNil and: [ self needRebuild not ])
		ifTrue: [ widget := self spec instance ]
		ifFalse: [ 
			widget := SpecInterpreter buildMorphFor: self withSpec: self defaultSpecSelector.
			self addModelIn: widget withSpecLayout: aSpec ].

	self extent ifNotNil: [:ex | 
		(widget respondsTo: #extent:)
			ifTrue: [ widget extent: ex ]].
		
	^ widget! !

!WindowModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/10/2012 15:15'!
defaultInitialExtent
	
	^ 400@300! !

!WindowModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 8/2/2012 16:55'!
giveFocusToNextFrom: aMorph 

	^ self model giveFocusToNextFrom: aMorph! !

!WindowModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 7/10/2012 16:26'!
giveFocusToPreviousFrom: aMorph 

	^ self model giveFocusToPreviousFrom: aMorph ! !

!WindowModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/10/2012 16:21'!
initialExtent

	^ initialExtent contents
		ifNil: [ self model 
				ifNil: [ self defaultInitialExtent ]
				ifNotNil: [:m | m initialExtent
								ifNil: [ self defaultInitialExtent ]]]! !

!WindowModel methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/10/2012 15:29'!
initialize
	"Initialization code for WindowModel"

	super initialize.

	model := nil asValueHolder.
	initialExtent := nil asValueHolder.
	title := self class title asValueHolder.
	
	model whenChangedDo: [:m | self updateTitle ].
	title whenChangedDo: [ ]! !

!WindowModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 01:49'!
isDisplayed

	^ self window
		ifNil: [ false ]
		ifNotNil: [:w | w isDisplayed ]! !

!WindowModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 7/10/2012 15:04'!
model
	
	^ model contents! !

!WindowModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/10/2012 15:17'!
model: aModel

	model contents: aModel! !

!WindowModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/2/2012 15:44'!
openModal: aWindow 

	self widget ifNotNil: [:w | w openModal: aWindow ]! !

!WindowModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/10/2012 15:19'!
openWithSpec: aSpec

	window := self buildWithSpec: aSpec.
	window openInWorld.
	window title: self title! !

!WindowModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/10/2012 15:43'!
openWithSpecLayout: aSpec

	window := self buildWithSpecLayout: aSpec.
	window openInWorld.
	window title: self title! !

!WindowModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/10/2012 15:42'!
rebuildWithSpec: aSpec
	| sub |
	
	sub := window submorphs copy.
	window removeAllMorphs.
	sub allButLast do: [:e | window addMorphBack: e ].
	self addModelIn: self widget withSpec: aSpec! !

!WindowModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/10/2012 15:43'!
rebuildWithSpecLayout: aSpec
	| sub |
	
	sub := window submorphs copy.
	window removeAllMorphs.
	sub allButLast do: [:e | window addMorphBack: e ].
	self addModelIn: self widget withSpecLayout: aSpec! !

!WindowModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/10/2012 15:18'!
title

	^ self model
		ifNil: [ super title ]
		ifNotNil: [:m | m title ]! !

!WindowModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/2/2012 17:14'!
title: aString

	^ self widget
		ifNotNil: [:w | w title: aString ]! !

!WindowModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/10/2012 15:36'!
updateTitle
	"Update the window title"

	self window
		ifNotNil: [:w | w title: self title ]! !

ComposableModel subclass: #BlocEditor
	instanceVariableNames: 'block ok post pre text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!BlocEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 18:17'!
block

	^ block contents! !

!BlocEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 18:17'!
block: aBlock

	block contents: aBlock ! !

!BlocEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 18:05'!
buildWithSpec

	^ self buildWithSpecLayout: self layout! !

!BlocEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 18:09'!
buildWithSpec: aSpec

	^ self buildWithSpecLayout: self layout! !

!BlocEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 18:00'!
help: aString 
	
	text help: aString ! !

!BlocEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/11/2012 18:18'!
initialize
	"Initialization code for BlocEditor"

	super initialize.

	block := nil asValueHolder! !

!BlocEditor methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/12/2012 18:25'!
initializeWidgets 

	self  instantiateModels: #( 
		pre 	LabelModel 
		post 	LabelModel 
		text 	TextInputFieldModel
		ok 		ButtonModel ).
			
	pre text: '['.
	post text: ']'.
	text
		autoAccept: false;
		entryCompletion: nil;
		acceptBlock: [ self okAction ];
		ghostText: 'body'.
		
	ok 
		label: 'ok';
		state: false;
		enabled: true;
		action: [ self okAction ].
		
	self focusOrder 
		add: text;
		add: ok! !

!BlocEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/11/2012 18:58'!
layout
	| width width2 |
	width := StandardFonts defaultFont widthOfStringOrText: pre getText.
	width2 := StandardFonts defaultFont widthOfStringOrText: post getText.
	^ SpecLayout composed 
		newRow: [:r |
			r
				newColumn: [:c | c add: #pre ] width: width;
				add: #text;
				newColumn: [:c | c add: #post ] width: width2;
				newColumn: [:c | c add: #ok ] width: 25 ]
		 height: 25;
		yourself! !

!BlocEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 18:20'!
ok

	^ ok! !

!BlocEditor methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/11/2012 18:20'!
okAction

	text accept.
	block contents: (Compiler evaluate: (String streamContents: [:s | s << '[' << text getText <<']'])).! !

!BlocEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 18:08'!
post
	^ post! !

!BlocEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 18:08'!
pre
	^ pre! !

!BlocEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 18:20'!
text
	^ text! !

!BlocEditor methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/11/2012 19:11'!
whenBlockChangedDo: aBlock

	block whenChangedDo: aBlock ! !

ComposableModel subclass: #ChangeSorterApplication
	instanceVariableNames: 'model changesListModel classesListModel methodsListModel textModel prettyPrint showDiff title prettyButton diffButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-ChangeSorter'!

!ChangeSorterApplication commentStamp: '<historical>' prior: 0!
A ChangeSorterApplication is spec version of the dual sorter!

!ChangeSorterApplication class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/31/2012 16:09'!
defaultSpec
	<spec>
	
	^ SpecLayout composed
		newColumn: [:c | 
				c 
					newRow: [:r | r 
									add: #changesListModel;
									addSplitter;
									add: #classesListModel ];
					addSplitter;
					add: #methodsListModel;
					addSplitter;
					add: #textModel ].! !

!ChangeSorterApplication class methodsFor: 'tools-registry' stamp: 'StephaneDucasse 7/4/2012 19:48'!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 
	registry register: self as: #changeSorter! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
addPreamble

	self model addPreambleTo: self selectedChangeSet.
	changesListModel setSelectedItem: self selectedChangeSet! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
browseChangeSet
	"Open a message list browser on methods in the current change set"

	| messages |
	messages := self selectedChangeSet changedMessageList select: [ :each | each isValid].	
	Smalltalk tools  messageList
		openMessageList: messages 
		name: 'Methods in Change Set ', self selectedChangeSet name 
		autoSelect: ''! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: ''!
browseImplementorsOfMessages

	self model browseMessagesFrom: self selectedSelector! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: ''!
browseMethodFull
	"Create and schedule a full Browser and then select the current class and message."

	self selectedClass ifNotNil:
		[:myClass | Smalltalk tools browser fullOnClass: myClass selector: self selectedSelector ]! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: ''!
browseSendersOfMessages

	self model browseSendersOfMessagesFrom: self selectedSelector! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: ''!
browseVersions
	"Create and schedule a changelist browser on the versions of the 
	selected message."
	
	self selectedClass ifNotNil: [:class |
		self selectedSelector ifNotNil: [:selector || method |
			method := class methodDict 
								at: selector 
								ifAbsent: [ ^ self inform: 'Sorry, only actual methods have retrievable versions.' ].
			self model browseVersionsFrom: method ]]! !

!ChangeSorterApplication methodsFor: 'menu' stamp: ''!
changeSetMenu1: aMenu shifted: isShifted 
	"Set up aMenu to hold commands for the change-set-list pane.  This could be for a single or double changeSorter"
	
	aMenu 
		title: 'Change Set';
		target: self.
		
	self selectedChangeSet
		ifNotNil:[
			aMenu
				add: 'Make changes go to me (m)'
				action: #setCurrentChangeSet;
				addLine;
				add: 'New change set... (n)'
				action: #newSet ].
	aMenu
		add: 'Find...(f)' 
		action: #findChangeSet.

	self selectedChangeSet
		ifNotNil:[
			aMenu
				addLine;
				add: 'Rename change set (r)'
				action: #rename;
				add: 'File out (o)'
				action: #fileOut;
				add: 'Browse methods (b)' 
				action: #browseChangeSet;
				add: 'Browse change set (B)'
				action: #openChangeSetBrowser;
				addLine ]! !

!ChangeSorterApplication methodsFor: 'menu' stamp: ''!
changeSetMenu2: aMenu shifted: isShifted 
	"Set up aMenu to hold commands for the change-set-list pane.  This could be for a single or double changeSorter"
	| cs |
	
	cs := self selectedChangeSet.
	self selectedChangeSet
		ifNotNil:[
			(cs notNil and: [ cs hasPreamble ])
				ifTrue: [
							aMenu add: 'Edit preamble (p)' action: #addPreamble.
							aMenu add: 'Remove preamble' action: #removePreamble	]
				ifFalse: [	aMenu add: 'Add preamble (p)' action: #addPreamble			].
			(cs notNil and: [ cs hasPostscript ])
				ifTrue: [	
							aMenu add: 'Edit postscript...' action: #editPostscript.
							aMenu add: 'Remove postscript' action: #removePostscript	]
				ifFalse: [	aMenu add: 'Add postscript...' action: #editPostscript			].

			aMenu addLine.

			aMenu add: 'Destroy change set (x)' action: #remove ].! !

!ChangeSorterApplication methodsFor: 'menu' stamp: ''!
changeSetMenu: aMenu shifted: isShifted 
	"Set up aMenu to hold commands for the change-set-list pane.  This could be for a single or double changeSorter"
	
	isShifted ifTrue: [^ self shiftedChangeSetMenu: aMenu].
	self changeSetMenu1: aMenu shifted: isShifted.
	self changeSetMenu2: aMenu shifted: isShifted.
	
	^ aMenu! !

!ChangeSorterApplication methodsFor: 'shortcuts' stamp: ''!
changeSetShortcuts: event from: aMorph

	self selectedChangeSet
		ifNotNil:[
			event keyString = '<Cmd-b>' 		ifTrue: [ ^ self browseChangeSet ].
			event keyString = '<Cmd-B>' 		ifTrue: [ ^ self openChangeSetBrowser ].
			event keyString = '<Cmd-m>' 	ifTrue: [ ^ self setCurrentChangeSet ].
			event keyString = '<Cmd-n>' 		ifTrue: [ ^ self newSet ].
			event keyString = '<Cmd-o>' 		ifTrue: [ ^ self fileOut ].
			event keyString = '<Cmd-r>' 		ifTrue: [ ^ self rename ].
			event keyString = '<Cmd-p>' 		ifTrue: [ ^ self addPreamble ].
			event keyString = '<Cmd-x>' 		ifTrue: [ ^ self remove ]].
			
	event keyString = '<Cmd-f>' 				ifTrue: [ ^ self findChangeSet ].
		! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
changeSets

	^ self changesListModel getList! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: ''!
changesListModel

	^ changesListModel! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
changesMenu: aBlock

	changesListModel menu: aBlock! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
changesShortcuts: aBlock

	changesListModel shortcuts: aBlock! !

!ChangeSorterApplication methodsFor: 'menu' stamp: ''!
classMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the class list"

	self selectedClass ifNil: [ ^ nil ].
	aMenu title: 'Class list'.

	aMenu target: self.
	aMenu addList: #(
			-
			('Delete class from change set (d)'		forgetClass)
			('Remove class from system (x)'		removeClass)
			-
			('Browse full (b)'						browseMethodFull)
			-
			('FileOut'								fileOutClass)).

	^ aMenu! !

!ChangeSorterApplication methodsFor: 'shortcuts' stamp: ''!
classShortcuts: event from: aMorph

	self selectedClass
		ifNotNil:[
			event keyString = '<Cmd-b>' 		ifTrue: [ ^ self browseMethodFull ].
			event keyString = '<Cmd-d>' 		ifTrue: [ ^ self forgetClass ].
			event keyString = '<Cmd-x>' 		ifTrue: [ ^ self removeClass ]].! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: ''!
classesListModel

	^ classesListModel! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
classesMenu: aBlock

	classesListModel menu: aBlock! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
classesShortcuts: aBlock

	classesListModel shortcuts: aBlock! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
currentText

	 ^ textModel getText! !

!ChangeSorterApplication methodsFor: 'private' stamp: ''!
defaultTitle
	
	^  'Change Sorter'! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
editPostscript
	
	self selectedChangeSet editPostscript! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
fileOut

	self selectedChangeSet fileOut! !

!ChangeSorterApplication methodsFor: 'menu - class' stamp: ''!
fileOutClass

	self model fileOutClass: self selectedClass from: self selectedChangeSet! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: ''!
fileOutMessage
	"Put a description of the selected message on a file"

	self selectedSelector ifNotNil: [:selector |
		Cursor write showWhile:
			[ self model fileOutSelector: selector from: self selectedClass ]]! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
findChangeSet

	| set |
	set := self model findChangeSetIn: self changeSets.
	changesListModel setSelectedItem: set.! !

!ChangeSorterApplication methodsFor: 'private' stamp: ''!
forceChangesListRefresh
	| sel |
	
	sel := self selectedChangeSet.
	changesListModel items: self model allChanges.
	changesListModel setSelectedItem: sel.! !

!ChangeSorterApplication methodsFor: 'menu - class' stamp: ''!
forgetClass
	"Remove all mention of this class from the changeSet"

	self okToChange ifFalse: [^ self].
	self selectedClass ifNotNil: [:class |
		self model removeClass: class from: self selectedChangeSet.
		self setSelectedChangeSet: self selectedChangeSet ].
! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: ''!
forgetMessage

	self okToChange ifFalse: [^ self].
	self selectedSelector ifNotNil: [:selector | 
		self model 
			forgetSelector: selector 
			inClass: self selectedClass 
			fromChangeSet: self selectedChangeSet.
		self updateClassesList.
		self setSelectedClassIndex: self selectedClassIndex ]! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/13/2012 11:54'!
initialize
	"Initialization code for ChangeSorterApplication"

	prettyPrint := false.
	showDiff := false.
	
	model := ChangeSorterModel new.
	title := self defaultTitle.
	
	super initialize.
	self bindings: MorphicBindingsWithSplitters new.	
	
	! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:22'!
initializePresenter

	prettyButton activationAction: [ 
		prettyPrint := true.
		self updateTextContents ].
	prettyButton desactivationAction: [ 
		prettyPrint := false.
		self updateTextContents  ].
	diffButton activationAction: [ 
		showDiff := true.
		self updateTextContents ].
	diffButton desactivationAction: [ 
		showDiff := false.
		self updateTextContents  ].
	self registerChangeActions.
	self registerClassActions.
	self registerSelectorActions.! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/13/2012 11:52'!
initializeWidgets

	self instantiateModels: #(
		methodsListModel ListComposableModel
		classesListModel ListComposableModel
		changesListModel ListComposableModel
		prettyButton CheckBoxModel
		diffButton CheckBoxModel
		textModel TextModel ).
	
	self setFocus.
	
	methodsListModel menu: [:menu :shifted | self messageMenu: menu shifted: shifted ].
	methodsListModel shortcuts: [:event :source | self methodShortcuts: event from: source ].
	changesListModel menu: [:aMenu :shifted | self changeSetMenu: aMenu shifted: shifted  ].
	changesListModel shortcuts: [:event :source | self changeSetShortcuts: event from: source ].	
	classesListModel menu: [:aMenu :shifted | self classMenu: aMenu shifted: shifted ].
	classesListModel shortcuts: [:event :source | self classShortcuts: event from: source ].

	changesListModel items: self model allChanges.
	changesListModel displayBlock: [:item | item name ].
	textModel aboutToStyle: true.
	! !

!ChangeSorterApplication methodsFor: 'menu' stamp: ''!
messageMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the message list; could be for a single or double changeSorter"

	self selectedSelector ifNil: [ ^ nil ].	
	aMenu title: 'Message list'.
	aMenu target: self.

	aMenu addList: #(
			('Delete method from changeSet (d)'	forgetMessage)
			('Remove method from system (x)'		removeMessage)
				-
			('Browse full (b)'						browseMethodFull)
			-
			('FileOut'								fileOutMessage)
			-
			('Senders of... (n)'						browseSendersOfMessages)
			('Implementors of... (m)'				browseImplementorsOfMessages)
			('Versions (v)'							browseVersions)).
	^ aMenu
! !

!ChangeSorterApplication methodsFor: 'shortcuts' stamp: ''!
methodShortcuts: event from: aMorph

	self selectedSelector
		ifNotNil:[
			event keyString = '<Cmd-b>' 		ifTrue: [ ^ self browseMethodFull ].
			event keyString = '<Cmd-d>' 		ifTrue: [ ^ self forgetMessage ].
			event keyString = '<Cmd-m>' 	ifTrue: [ ^ self browseImplementorsOfMessages ].
			event keyString = '<Cmd-n>' 		ifTrue: [ ^ self browseSendersOfMessages ].
			event keyString = '<Cmd-v>' 		ifTrue: [ ^ self browseVersions ].
			event keyString = '<Cmd-x>' 		ifTrue: [ ^ self removeMessage ]].! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: ''!
methodsListModel

	^ methodsListModel! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
methodsMenu: aBlock

	methodsListModel menu: aBlock! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
methodsShortcuts: aBlock

	methodsListModel shortcuts: aBlock! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: ''!
model

	^ model! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
newSet

	| aSet |
	self okToChange ifFalse: [ ^ self ].
	aSet := self model createNewSet.
	aSet ifNotNil:
		[	self updateChangesList.
			changesListModel setSelectedItem: aSet ]! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
openChangeSetBrowser
	| cs env |
	
	cs := self selectedChangeSet.
	cs ifNil: [ ^ nil ].
	
	env := RBBrowserEnvironment new forClasses: cs changedClasses.

	Smalltalk tools browser fullOnEnvironment: env! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'StephaneDucasse 5/17/2012 19:32'!
registerChangeActions
	
	changesListModel
		whenSelectedItemChanged: [:change | 
			classesListModel resetSelection.
			self updateTextContents.
			change 
				ifNil: [
					classesListModel items: {}.
					methodsListModel items: {}.
					self title: self defaultTitle ]
				ifNotNil: [
					classesListModel items: (change changedClasses sort: [:a :b | a name < b name ]).
					self title: change name ]].
	! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'StephaneDucasse 5/17/2012 19:32'!
registerClassActions
	
	classesListModel whenSelectedItemChanged: [:class | 
		methodsListModel resetSelection.
		self updateTextContents.
		textModel behavior: class.
		textModel aboutToStyle: false.
		class 
			ifNil: [ methodsListModel items: {} ]
			ifNotNil: [ methodsListModel items: (self selectedChangeSet selectorsInClass: class name) sort ]].! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'StephaneDucasse 5/17/2012 19:32'!
registerSelectorActions

	methodsListModel whenSelectedItemChanged: [:selector |
		self updateTextContents ]! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
remove
	"Completely destroy my change set.  Check if it's OK first"

	self okToChange ifFalse: [^ self].
	self model removeChangeSet: self selectedChangeSet prompting: true.
	self updateChangesList.
	changesListModel resetSelection! !

!ChangeSorterApplication methodsFor: 'menu - class' stamp: ''!
removeClass
	"Remove the selected class from the system, at interactive user request.  Make certain the user really wants to do this, since it is not reversible.  Answer true if removal actually happened."

	(self model removeClass: self selectedClass)
		ifTrue: [ self setSelectedChangeSet: self selectedChangeSet ]! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: ''!
removeMessage
	"Remove the selected message from the system."
	
	self okToChange
		ifFalse: [^ self].
	self selectedSelector
		ifNotNil: [:selector |
				(self model removeMethod: selector inClass: self selectedClass)
					ifTrue: [ self updateMessagesList ]]! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
removePostscript

	self model removePostscriptFrom: self selectedChangeSet.
	changesListModel setSelectedItem: self selectedChangeSet! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
removePreamble

	self selectedChangeSet removePreamble.
	changesListModel setSelectedItem: self selectedChangeSet! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
rename

	| set |
	set := self model rename: self selectedChangeSet.
	
	changesListModel 
		updateList;
		setSelectedItem: set! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
selectedChangeSet

	 ^ changesListModel selectedItem! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
selectedChangeSetIndex

	 ^ changesListModel selectedIndex! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
selectedClass

	 ^ classesListModel selectedItem! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
selectedClassIndex

	 ^ classesListModel selectedIndex! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
selectedSelector

	 ^ methodsListModel selectedItem! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
selectorsMenu: aBlock

	methodsListModel menu: aBlock! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
setCurrentChangeSet

	self model setCurrentChangeSet: self selectedChangeSet.! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: ''!
setFocus

	self focusOrder
		add: changesListModel;
		add: classesListModel;
		add: methodsListModel;
		add: textModel.! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
setSelectedChangeSet: aChangeSet

	 ^ changesListModel setSelectedItem: aChangeSet! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
setSelectedChangeSetIndex: anIndex

	 ^ changesListModel setSelectedIndex: anIndex! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
setSelectedClass: aClass

	 ^ classesListModel setSelectedItem: aClass! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
setSelectedClassIndex: anIndex

	 ^ classesListModel setSelectedIndex: anIndex! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: ''!
textModel

	^ textModel! !

!ChangeSorterApplication methodsFor: 'private' stamp: ''!
title

	^ title! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/12/2012 18:14'!
title: aTitle

	title := aTitle.
	self updateTitle! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
updateChangesList
	| sel |
	
	sel := self selectedChangeSet.
	changesListModel items: self model allChanges.
	changesListModel setSelectedItem: sel.! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
updateClassesList
	| sel |
	sel := self selectedClass.
	
	self selectedChangeSet
			ifNil: [ classesListModel items: {} ]
			ifNotNil: [:change |	classesListModel items: (change changedClasses sort: [:a :b | a name < b name ])].
				
	classesListModel setSelectedItem: sel! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
updateClassesListAndMessagesList
	| sel |
	sel := methodsListModel selectedItem.
	
	self updateClassesList.
	methodsListModel setSelectedItem: sel.
	self updateMessagesList.! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
updateMessagesList
	| sel |
	sel := methodsListModel selectedItem.
	
	self selectedClass
			ifNil: [ methodsListModel items: {} ]
			ifNotNil: [:class | methodsListModel items: (self selectedChangeSet selectorsInClass: class name) sort].
				
	methodsListModel setSelectedItem: sel! !

!ChangeSorterApplication methodsFor: 'private' stamp: ''!
updateTextContents

	| text |
	text :=  (self model 
				setContentsOfChangeSet: self selectedChangeSet
				forClass: self selectedClass
				andSelector: self selectedSelector
				prettyPrint: prettyPrint
				showDiff: showDiff).
	({'Method was added, but cannot be found!!'. 'Added then removed (see versions)'. 'Method has been removed (see versions)'} includes: text)
		ifTrue: [ textModel aboutToStyle: false ]
		ifFalse: [ textModel aboutToStyle: true ] .
	textModel text: text.! !

!ChangeSorterApplication methodsFor: 'protocol-events' stamp: 'StephaneDucasse 5/17/2012 19:31'!
whenChangesListChanges: aBlock

	changesListModel whenListChanged: aBlock! !

ComposableModel subclass: #CheckBoxExample
	instanceVariableNames: 'button1 button2 button3 container morph1 morph2 morph3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples-Widgets'!

!CheckBoxExample commentStamp: '<historical>' prior: 0!
A CheckBoxExample is a simple example of how to use CheckBoxes.

CheckBoxExample new openWithSpec!

!CheckBoxExample class methodsFor: 'specs' stamp: 'bvr 6/4/2012 17:24'!
defaultSpec

	^ { #ComposableSpec.
			#add:.	{ self topSpec.
								#layout:. 	{#LayoutFrame.
																#fractions:offsets:.	(0@0 corner: 1@0).	(0@0 corner: 0@20). }}.
			#add:.	{{#model. #container.}.
											#layout:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0 corner: 1@1).	(0@22 corner: 0@0). }}}! !

!CheckBoxExample class methodsFor: 'specs' stamp: 'bvr 6/4/2012 17:27'!
defaultSpec2

	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#button1.}.
			#addMorph:. {#model.	#button2.}.
			#addMorph:. {#model.	#button3.}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!CheckBoxExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/5/2012 17:17'!
title

	^ 'CheckBox Example'! !

!CheckBoxExample class methodsFor: 'specs' stamp: 'bvr 6/4/2012 17:17'!
topSpec

	^ { #ComposableSpec.
			#add:. {{#model.	#button1.}.
						#layout:. {#LayoutFrame.
										#fractions:offsets:. (0@0 corner: 0.33@0). (0@0 corner: 0@25).}}.
			#add:.  {{#model.	#button2.}.
						#layout:. {#LayoutFrame.
										#fractions:offsets:. (0.33@0 corner: 0.66@0). (0@0 corner: 0@25).}}.
			#add:.  {{#model.	#button3.}.
						#layout:. {#LayoutFrame.
										#fractions:offsets:. (0.66@0 corner: 1@0). (0@0 corner: 0@25).}}}! !

!CheckBoxExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
button1

	^ button1! !

!CheckBoxExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
button2

	^ button2! !

!CheckBoxExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
button3

	^ button3! !

!CheckBoxExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
container

	^ container! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:23'!
initialize
	"Initialization code for RadioButtonGroupExample"

	container := PanelMorph new.
	
	container
		changeTableLayout;
		listDirection: #bottomToLeft.
	
	self instantiateMorphs.
	super initialize.! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:23'!
initializePresenter

	self setActionsForButton1.
	self setActionsForButton2.
	self setActionsForButton3.	! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:23'!
initializeWidgets 

	self instantiateModels: #(
		button1 CheckBoxModel
		button2 CheckBoxModel
		button3 CheckBoxModel ).
	
	button1 label: 'Button 1'.
	button2 label: 'Button 2'.
	button3 label: 'Button 3'.
	self setFocus.! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
instantiateMorphs

	morph1 := Morph new
					color: Color red;
					width: 60;
					height: 20.
	morph2 := Morph new
					color: Color blue;
					width: 20;
					height: 60.
	morph3 := Morph new
					color: Color green;
					width: 50;
					height: 50.! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setActionsForButton1

	button1 whenActivatedDo: [ container addMorph: morph1 ].
	button1 whenDesactivatedDo: [ container removeMorph: morph1 ]! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setActionsForButton2

	button2 whenActivatedDo: [ container addMorph: morph2 ].
	button2 whenDesactivatedDo: [ container removeMorph: morph2 ]! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setActionsForButton3

	button3 whenActivatedDo: [ container addMorph: morph3 ].
	button3 whenDesactivatedDo: [ container removeMorph: morph3 ]! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setFocus
	
	self focusOrder
		add: button1;
		add: button2;
		add: button3.
	! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setGroup

	RadioButtonGroup new 
		addRadioButton: button1;
		addRadioButton: button2;
		addRadioButton: button3;
		default: button1.
	! !

ComposableModel subclass: #ClassMethodBrowser
	instanceVariableNames: 'listModel methodModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples-PolyWidgets'!

!ClassMethodBrowser commentStamp: '<historical>' prior: 0!
A ClassMethodBrowser is a simple browser using spec and reusing MethodBrowser to browse classes>>methods>>sourceCode.
	| cb |
	cb := ClassMethodBrowser new.
	cb openWithSpec.
	cb classes: Smalltalk allClasses.!

!ClassMethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 6/22/2012 19:19'!
defaultSpec
<spec>
	^ SpecLayout composed
		newRow: [:row | row
						add: #listModel;
						add: #methodModel ];
		yourself! !

!ClassMethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 6/22/2012 19:17'!
defaultSpec2
<spec: #default>
	^ { #ComposableSpec.
			#add:. {{#model. #listModel.}.
											#layout:. {#FrameLayout.
												#fractions:. 	( 0@0 corner: 0.5@0.5 )}}.
			#add:. {{#model. #methodModel. #listModel.}.
											#layout:. {#FrameLayout.
												#fractions:. 	( 0.5@0 corner: 1@0.5 )}}.
			#add:. {{#model. #methodModel. #textModel}.
											#layout:. {#FrameLayout.
												#fractions:. 	( 0@0.5 corner: 1@1 )}}}.! !

!ClassMethodBrowser class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 2/2/2012 13:39'!
example

	"self example"
	| cb |
	cb := ClassMethodBrowser new.
	cb openWithSpec.
	cb classes: Smalltalk allClasses.! !

!ClassMethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 12/14/2011 18:12'!
title

	^ 'Class Method Browser'! !

!ClassMethodBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/22/2012 19:16'!
classes: aList

	self listModel items: aList! !

!ClassMethodBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/6/2012 20:46'!
initialize
	"Initialization code for ClassMethodBrowser"

	super initialize.

	listModel := self instantiate: ListComposableModel.
	methodModel := self instantiate: MethodBrowser.
	
	self focusOrder
		add: listModel;
		add: methodModel.
	
	listModel whenSelectedItemChanged: [:selection |
		selection 
			ifNotNil: [:class | 
				methodModel methods: (class methodDict values sort: [:a :b | a selector < b selector]).
				methodModel listModel resetSelection ]].
	
	methodModel wrapWith: [:method | method selector ].! !

!ClassMethodBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:34'!
initializePresenter
	
	listModel whenSelectedItemChanged: [:selection |
		selection 
			ifNotNil: [:class | 
				methodModel methods: (class methodDict values sort: [:a :b | a selector < b selector]).
				methodModel listModel resetSelection ]].! !

!ClassMethodBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:34'!
initializeWidgets

	self instantiateModels: #(
		listModel ListComposableModel
		methodModel MethodBrowser ).
	
	self focusOrder
		add: listModel;
		add: methodModel.
	
	methodModel displayBlock: [:method | method selector ].! !

!ClassMethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 18:03'!
listModel

	^ listModel! !

!ClassMethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 18:03'!
methodModel

	^ methodModel! !

ComposableModel subclass: #ClassNameSetter
	instanceVariableNames: 'classNameLabel classNameTextField categoryLabel categoryField toolbar descriptionHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder-Tools'!

!ClassNameSetter class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:57'!
defaultSpec
	<spec>
	^ {#Panel. #changeProportionalLayout. #'add:'. {#(#model 'classNameLabel' ). #layout:. {#LayoutFrame. #fractions:offsets:. (0@0) corner: (1@0). (0@0) corner: (0@25)}}. #'add:'. {#(#model 'classNameTextField' ). #layout:. {#LayoutFrame. #fractions:offsets:. (0@0) corner: (1@0). (0@30) corner: (0@65)}}. #'add:'. {#(#model 'categoryLabel' ). #layout:. {#LayoutFrame. #fractions:offsets:. (0@0) corner: (1@0). (0@70) corner: (0@95)}}. #'add:'. {#(#model 'categoryField' ). #layout:. {#LayoutFrame. #fractions:offsets:. (0@0) corner: (1@0). (0@100) corner: (0@135)}}. #add:. {#(#model #toolbar ). #layout:. {#LayoutFrame. #fractions:offsets:. (0@1) corner: (1@1). (0@ -25) corner: (0@0)}}. #vResizing:. #spaceFill. #hResizing:. #spaceFill}! !

!ClassNameSetter class methodsFor: 'generating' stamp: 'BenjaminVanRyseghem 3/30/2012 14:38'!
generatingSpec
	
	^ ((Array new: 57) at: 1 put: #model; at: 2 put: #subclass:category:; at: 3 put: #ClassNameSetter; at: 4 put: 'Spec-Builder-Tools'; at: 5 put: #addInstVarNamed:type:; at: 6 put: 'classNameLabel'; at: 7 put: LabelModel; at: 8 put: #addInstVarNamed:type:; at: 9 put: 'classNameTextField'; at: 10 put: TextInputFieldModel; at: 11 put: #addInstVarNamed:type:; at: 12 put: 'categoryLabel'; at: 13 put: LabelModel; at: 14 put: #addInstVarNamed:type:; at: 15 put: 'categoryField'; at: 16 put: TextInputFieldModel; at: 17 put: #addInstVarNamed:type:; at: 18 put: 'toolbar'; at: 19 put: OkCancelToolbar; at: 20 put: #compileWithoutReturn:classified:; at: 21 put: 'initialize
	
	super initialize'; at: 22 put: 'initialize'; at: 23 put: #compileWithoutReturn:classified:; at: 24 put: 'classNameLabel
	
	^ classNameLabel'; at: 25 put: 'accessing'; at: 26 put: #compileWithoutReturn:classified:; at: 27 put: 'classNameTextField
	
	^ classNameTextField'; at: 28 put: 'accessing'; at: 29 put: #compileWithoutReturn:classified:; at: 30 put: 'categoryLabel
	
	^ categoryLabel'; at: 31 put: 'accessing'; at: 32 put: #compileWithoutReturn:classified:; at: 33 put: 'categoryField
	
	^ categoryField'; at: 34 put: 'accessing'; at: 35 put: #compileWithoutReturn:classified:; at: 36 put: 'toolbar
	
	^ toolbar'; at: 37 put: 'accessing'; at: 38 put: #addSourceCode:into:; at: 39 put: 'toolbar := self instantiate: OkCancelToolbar'; at: 40 put: #initialize; at: 41 put: #addSourceCode:into:; at: 42 put: 'categoryField := self instantiate: TextInputFieldModel'; at: 43 put: #initialize; at: 44 put: #addSourceCode:into:; at: 45 put: 'categoryLabel := self instantiate: LabelModel'; at: 46 put: #initialize; at: 47 put: #addSourceCode:into:; at: 48 put: 'classNameTextField := self instantiate: TextInputFieldModel'; at: 49 put: #initialize; at: 50 put: #addSourceCode:into:; at: 51 put: 'classNameLabel := self instantiate: LabelModel'; at: 52 put: #initialize; at: 53 put: #theMetaClass; at: 54 put: #compileWithoutReturn:classified:; at: 55 put: 'internSpec
	<spec>
	^ {#Panel. #changeProportionalLayout. #''add::''. {#(#model ''classNameLabel'' ''internSpec''). #layout:. {#LayoutFrame. #fractions:offsets:. (0@0) corner: (1@0). (0@0) corner: (0@25)}}. #''add::''. {#(#model ''classNameTextField'' ''internSpec''). #layout:. {#LayoutFrame. #fractions:offsets:. (0@0) corner: (1@0). (0@30) corner: (0@45)}}. #''add::''. {#(#model ''categoryLabel'' ''internSpec''). #layout:. {#LayoutFrame. #fractions:offsets:. (0@0) corner: (1@0). (0@50) corner: (0@75)}}. #''add::''. {#(#model ''categoryField'' ''internSpec''). #layout:. {#LayoutFrame. #fractions:offsets:. (0@0) corner: (1@0). (0@80) corner: (0@105)}}. #add:. {#(#model #toolbar #internSpec). #layout:. {#LayoutFrame. #fractions:offsets:. (0@1) corner: (1@1). (0@ -25) corner: (0@0)}}. #vResizing:. #spaceFill. #hResizing:. #spaceFill}'; at: 56 put: 'specs'; at: 57 put: #theNonMetaClass; yourself)! !

!ClassNameSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/30/2012 14:38'!
categoryField
	
	^ categoryField! !

!ClassNameSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/30/2012 14:38'!
categoryLabel
	
	^ categoryLabel! !

!ClassNameSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/30/2012 14:38'!
classNameLabel
	
	^ classNameLabel! !

!ClassNameSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/30/2012 14:38'!
classNameTextField
	
	^ classNameTextField! !

!ClassNameSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/30/2012 17:28'!
description: aDescription

	descriptionHolder contents: aDescription! !

!ClassNameSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/30/2012 15:34'!
initialExtent

	^  (300@200)! !

!ClassNameSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 19:08'!
initialize
	
	descriptionHolder := nil asValueHolder.
	super initialize.
	! !

!ClassNameSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:54'!
initializePresenter

	toolbar okAction: [ 
		classNameTextField getText ifNotNil: [:cn |
			categoryField getText ifNotNil: [:cat |
				descriptionHolder contents
									addClassNamed: cn
									categorized: cat  ]]].
	
	descriptionHolder whenChangedDo: [:desc || acDesc | 
		acDesc:= desc addClassDescription.
		classNameTextField text: acDesc newClassName.
		categoryField text: acDesc category ]! !

!ClassNameSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:55'!
initializeWidgets

	self instantiateModels: #(
		toolbar OkCancelToolbar
		categoryField TextInputFieldModel
		categoryLabel LabelModel
		classNameTextField TextInputFieldModel
		classNameLabel LabelModel ).
	
	categoryField autoAccept: true.
	classNameTextField autoAccept: true.
	
	classNameLabel text: 'Class name:'.
	categoryLabel text: 'Category:'.! !

!ClassNameSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/30/2012 14:38'!
toolbar
	
	^ toolbar! !

ComposableModel subclass: #ColorEditor
	instanceVariableNames: 'a b color g morph r'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!ColorEditor class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/16/2012 19:19'!
spec
	<spec>
	
	^ SpecLayout composed
			newRow: [:r |
				r 
					add: #r;
					add: #g;
					add: #b;
					add: #a;
					newColumn: [:c | c add: #morph ] width: 25 ]
			 height: 25;
			yourself! !

!ColorEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/16/2012 19:18'!
a
	^ a! !

!ColorEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/16/2012 19:18'!
b
	^ b! !

!ColorEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/16/2012 19:05'!
color
	^ color contents! !

!ColorEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/16/2012 19:06'!
color: anObject
	color contents: anObject! !

!ColorEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/16/2012 19:18'!
g
	^ g! !

!ColorEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 19:19'!
help: aString 
	
	r help: aString.
	g help: aString.
	b help: aString.
	a help: aString.! !

!ColorEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/16/2012 19:15'!
initialize
	"Initialization code for ColorEditor"

	super initialize.

	color := Color black asValueHolder.
	morph := Morph new 
				color: self color;
				extent: 25@25;
				yourself! !

!ColorEditor methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/18/2012 16:48'!
initializeWidgets 

	self instantiateModels: #(
		r 	SliderModel
		g 	SliderModel
		b 	SliderModel
		a 	SliderModel ).
					
	r 
		min: 0;
		max: 255;
		label: 'red';
		quantum: 1;
		value: 0;
		whenValueChangedDo: [ self updateColor ].

	g 
		min: 0;
		max: 255;
		label: 'green';
		quantum: 1;
		value: 0;
		whenValueChangedDo: [ self updateColor ].

	b 
		min: 0;
		max: 255;
		label: 'blue';
		quantum: 1;
		value: 0;
		whenValueChangedDo: [ self updateColor ].

	a 
		min: 0;
		max: 255;
		label: 'alpha';
		quantum: 1;
		value: 255;
		whenValueChangedDo: [ self updateColor ].

	! !

!ColorEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/16/2012 19:06'!
morph
	^ morph! !

!ColorEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/16/2012 19:05'!
morph: anObject
	morph := anObject! !

!ColorEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/16/2012 19:18'!
r
	^ r! !

!ColorEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 19:27'!
setAbsoluteAlpha: aFloat

	a absoluteValue: aFloat ! !

!ColorEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 19:27'!
setAbsoluteBlue: aFloat

	b absoluteValue: aFloat ! !

!ColorEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 19:27'!
setAbsoluteGreen: aFloat

	g absoluteValue: aFloat ! !

!ColorEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 19:27'!
setAbsoluteRed: aFloat

	r absoluteValue: aFloat ! !

!ColorEditor methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/18/2012 16:54'!
updateColor
	| newColor |
	
	newColor := TranslucentColor r: r value g: g value b: b value range: 256.
	newColor := newColor alpha: (a value) / 256.
	r color: (Color r: r value g: 0 b: 0 range: 256).
	g color: (Color r: 0 g: g value b: 0 range: 256).
	b color: (Color r: 0 g: 0 b: b value range: 256).
	self color: newColor.
	morph color: newColor! !

!ColorEditor methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 19:08'!
whenColorChangedDo: aBlock

	color whenChangedDo: aBlock ! !

!ComposableModel class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 02:54'!
apiMethods
	| methods class |
	methods := OrderedCollection new.
	class := self.
	[ class = ComposableModel ]
		whileFalse: [| newMethods | 
			newMethods := ((SpecPragmaCollector behavior: class)
									filter: [:prg | prg keyword beginsWith: 'api:' ];
									reset;
									collected) collect: [:e | e method ].
			newMethods do: [:m | (methods noneSatisfy: [:m2 | m2 selector = m selector ])
										ifTrue: [ methods add: m ]].
			class := class superclass ].
		
	^ methods! !

!ComposableModel class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 16:13'!
apiSelectors

	^ self apiMethods collect: #selector! !

!ComposableModel class methodsFor: '*Spec-Builder' stamp: 'bvr 5/31/2012 13:39'!
bindings 

	^ BindingsHolder new! !

!ComposableModel class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:35'!
defaultSpec

	^ self subclassResponsibility! !

!ComposableModel class methodsFor: 'instance creation' stamp: ''!
owner: owner

	^ self new
		owner: owner;
		yourself! !

!ComposableModel class methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 2/28/2012 14:15'!
possibleEvents

	^ #()! !

!ComposableModel class methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 3/28/2012 17:59'!
retrieveClassSymbolFor: aSymbol

	^ self bindings classSymbolFor: aSymbol ifAbsent: [ aSymbol ]! !

!ComposableModel class methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 3/28/2012 17:59'!
retrieveSelectorSymbolFor: aSymbol

	^ self bindings selectorSymbolFor: aSymbol ifAbsent: [ aSymbol ]! !

!ComposableModel class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/26/2012 00:13'!
specSelectors
	
	^ (((SpecPragmaCollector behavior: self class)
		filter: [:prg | prg keyword = #spec])
		reset;
		collected)
		collect: [:e | e method selector ]! !

!ComposableModel class methodsFor: 'specs' stamp: ''!
title
	
	^ 'Untitled window'! !

!ComposableModel class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:39'!
windowSpec

	^{ #StandardWindow.
			#addMorphBack:.	{ self defaultSpec .
						#layout:. {#FrameLayout.
							#fractions:offsets:. (0@0 corner: 1@1). nil	}}.
			#title:.					self title}! !

!ComposableModel methodsFor: 'private' stamp: ''!
addAll: aWindow withSpec: aSpec

	aWindow
		addMorph: (self buildWithSpec: aSpec)
		frame: (0@0 corner: 1@1).! !

!ComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/9/2012 16:13'!
addAll: aWindow withSpecLayout: aSpec

	aWindow
		addMorph: (self buildWithSpecLayout: aSpec)
		frame: (0@0 corner: 1@1).! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 16:13'!
apiMethods

	^ self class apiMethods! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 16:14'!
apiSelectors

	^ self class apiSelectors! !

!ComposableModel methodsFor: 'Morphic-Widgets-should-be-an-extension' stamp: 'StephaneDucasse 5/17/2012 19:26'!
beginsWith: aString fromList: aMorph
	"This method is used bu the list for the search of elements when you are typing directly in the list"
	
	^ false! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 10:31'!
bindings

	^ bindings! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 10:50'!
bindings: aBindings

	self bindings bindings: aBindings! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/12/2012 14:56'!
buildWithSpec
	"Build the widget using the default spec"
	
	^ self buildWithSpec: self defaultSpecSelector! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 03:32'!
buildWithSpec: aSpec
	"Build the widget using the spec name provided as argument"
	| widget |
	
	(self spec notNil and: [ self needRebuild not ])
		ifTrue: [ | old |
			self needRebuild: true.
			old := self widget.
			old removeAllMorphs.
			self ensureExtentFor: old.
			widget := SpecInterpreter buildMorphFor: self withSpec: aSpec.
			widget submorphs do:[ :e |  old addMorphBack: e ].
			self spec instance: old.
			^ old ]
		ifFalse: [ widget := SpecInterpreter buildMorphFor: self withSpec: aSpec. ].

	self ensureExtentFor: widget.
		
	^ widget! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 03:10'!
buildWithSpecLayout: aSpecLayout
	"Build the widget using the spec name provided as argument"

	| widget |
	(self spec notNil and: [ self needRebuild not ])
		ifTrue: [ | old |
			self needRebuild: true.
			old := self widget.
			old removeAllMorphs.
			self ensureExtentFor: old.
			widget := SpecInterpreter new interpretASpec: aSpecLayout model: self.
			widget submorphs do: [ :e | 
					old addMorph: e.
					e adoptPaneColor: old paneColor ].
			self spec instance: old.
			^ old ]
		ifFalse: [ widget := SpecInterpreter new interpretASpec: aSpecLayout model: self ].
		
	self ensureExtentFor: widget.
	^ widget! !

!ComposableModel methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/10/2012 14:59'!
createInstanceFor: aClassSymbol
	"Retrieve the class corresponding to aClassSymbol using the bindings, then create a new instance of theis class"
	| class |
	
	class := self resolveSymbol: aClassSymbol.
	^ self instantiate: class.! !

!ComposableModel methodsFor: 'specs' stamp: 'bvr 6/1/2012 17:12'!
defaultSpec

	^ self class perform: self defaultSpecSelector! !

!ComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 6/26/2012 00:14'!
defaultSpecSelector
	
	((((SpecPragmaCollector behavior: self class class)
		filter: [:prg | prg keyword = 'spec:' and: [prg arguments includes: #default]])
		reset;
		collected)
		collect: [:e | e method selector ])
		ifNotEmpty: [:col | ^ col first ].


	self specSelectors
		ifNotEmpty: [:col | col size = 1 ifTrue: [ ^ col first ]].
		
	"should use pragmas"
	^ #defaultSpec
	
! !

!ComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/3/2012 17:45'!
delete

	self widget
		ifNotNil: [:widget | window 
						ifNil: [ widget delete ]
						ifNotNil: [:o | o delete ]]! !

!ComposableModel methodsFor: '*Spec-Tools-Editor' stamp: 'BenjaminVanRyseghem 7/11/2012 17:41'!
edit

	WidgetSetter new
		model: self;
		openWithSpec.! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 02:05'!
ensureExtentFor: old
	self extent
		ifNotNil: [ :ex | 
			(old respondsTo: #extent:)
				ifTrue: [ old extent: ex ] ].
	self initialExtent
		ifNotNil: [ :ex | 
			(old respondsTo: #extent:)
				ifTrue: [ old extent: ex ] ]! !

!ComposableModel methodsFor: 'protocol-focus' stamp: 'StephaneDucasse 5/17/2012 18:17'!
eventStringForNextFocus
	"String describing the keystroke to perform to jump to the next widget"
	^ ''! !

!ComposableModel methodsFor: 'protocol-focus' stamp: 'StephaneDucasse 5/17/2012 18:18'!
eventStringForPreviousFocus
	"String describing the keystroke to perform to jump to the previous widget"
	^ ''! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/26/2012 00:18'!
extent

	^  extentHolder contents! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/26/2012 00:18'!
extent: aPoint

	^  extentHolder contents: aPoint! !

!ComposableModel methodsFor: 'accessing' stamp: ''!
focusOrder

	^ focusOrder ifNil: [ focusOrder := OrderedCollection new ].! !

!ComposableModel methodsFor: 'private-focus' stamp: ''!
giveFocusToNextFrom: aMorph

	| focus |

	focus := self focusOrder.

	(focus includes: aMorph)
		ifTrue: [
			| index next |
			index := (focus indexOf: aMorph) + 1.
			(index <= focus size)
				ifTrue: [
					next := focus at: index.
					next takeKeyboardFocus.
					^ true ]].

	^ owner 
		ifNil: [ " I loop "
			| next |
			next := focus at: 1 ifAbsent: [ ^ false ].
			next takeKeyboardFocus.
			true ]
		ifNotNil: [ 
			owner giveFocusToNextFrom: self.
			true ]! !

!ComposableModel methodsFor: 'private-focus' stamp: 'BenjaminVanRyseghem 6/12/2012 19:28'!
giveFocusToPreviousFrom: aMorph 

	| focus |
	focus := self focusOrder.

	(focus includes: aMorph)
		ifTrue: [
			| index previous |
			index := (focus indexOf: aMorph) - 1.
			(index > 0)
				ifTrue: [
					previous := focus at: index.
					previous takeLastKeyboardFocus.
					^ true ]].

	^ owner 
		ifNil: [ " I loop "
			| next |
			next := focus at: focus size ifAbsent: [ ^ false ].
			next takeLastKeyboardFocus.
			true]
		ifNotNil: [ 
			owner giveFocusToPreviousFrom: self.
			true ]! !

!ComposableModel methodsFor: 'private-focus' stamp: ''!
handlesKeyboard: evt

	^ true! !

!ComposableModel methodsFor: 'Morphic-Widgets-should-be-an-extension' stamp: 'BenjaminVanRyseghem 7/10/2012 23:54'!
heightToDisplayInList: aList
	"Return the width of my representation as a list item"
	
	self extent ifNotNil: [:ex | ^ ex y ].
	self initialExtent ifNotNil: [:ex | ^ ex y ].
	
	self widget ifNil: [ self buildWithSpec ].
	^ self widget heightToDisplayInList: aList! !

!ComposableModel methodsFor: 'Morphic-Widgets-should-be-an-extension' stamp: 'BenjaminVanRyseghem 7/10/2012 23:56'!
heightToDisplayInTree: aTree
	"Return the width of my representation as a list item"
	
	self extent ifNotNil: [:ex | ^ ex y ].
	self initialExtent ifNotNil: [:ex | ^ ex y ].
	
	self widget ifNil: [ self buildWithSpec ].
	^ self widget heightToDisplayInTree: aTree! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/26/2012 00:47'!
hide

	self widget ifNotNil: [:widget |
		(widget respondsTo: #hide) ifTrue: [ widget hide ]].! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/10/2012 15:07'!
initialExtent

	^ nil! !

!ComposableModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/10/2012 14:19'!
initialize
	"Initialization code for ComposableModel"

	super initialize.

	bindings := BindingsHolder new.
	extentHolder := nil asValueHolder.
	needRebuild := true asValueHolder.
	isEventForNextFocusBlock := [ false ] asValueHolder.
	isEventForPreviousFocusBlock := [ false ] asValueHolder.
	self initializeWidgets.
	self initializePresenter.! !

!ComposableModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/10/2012 14:58'!
initializeDialogWindow: aWindow
	"used to initialize the model in the case of the use into a dialog window"! !

!ComposableModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/26/2012 00:19'!
initializePresenter
	"Used to specify the subwidgets, and/or to bind them together"
	"By default, do not do anything"
	
	extentHolder whenChangedDo: [:ex | 
		self widget ifNotNil: [:widget |
			(widget respondsTo: #extent:)
				ifTrue: [ widget extent: ex ]]].! !

!ComposableModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/10/2012 23:21'!
initializeWidgets
	
	self subclassResponsibility! !

!ComposableModel methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/10/2012 15:00'!
instantiate: aComposableModelClass
	"Instantiate a ComposableModel subclass and set its instance owner"
	^ aComposableModelClass owner: self! !

!ComposableModel methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/10/2012 15:02'!
instantiateModels: aCollectionOfPairs
	"Used to instantiate multiple sub widget at once. Take aCollectionOfPairs where each odd element is an inst var name and each even element is a class name, create an instance from the class name and store it into the inst var"
	
	aCollectionOfPairs pairsDo: [ :k :v |
		self instVarNamed: k asString put: (self createInstanceFor: v)]! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/12/2012 17:43'!
isDisplayed
	"Return true if the widget is currently displayed on screen"
	
	^ self window notNil and: [ self window isDisplayed ]! !

!ComposableModel methodsFor: 'protocol-focus' stamp: 'BenjaminVanRyseghem 7/10/2012 14:19'!
isEventForNextFocus: aKeyboardEvent
	"Return true if the event provided as argument corresponds to the shortcut used to switch to the next sub-widget"

	^ self isEventForNextFocusBlock cull: aKeyboardEvent! !

!ComposableModel methodsFor: 'protocol-focus' stamp: 'BenjaminVanRyseghem 7/10/2012 14:19'!
isEventForNextFocusBlock

	^ isEventForNextFocusBlock contents ! !

!ComposableModel methodsFor: 'protocol-focus' stamp: 'BenjaminVanRyseghem 7/10/2012 14:20'!
isEventForNextFocusBlock: aBlock

	isEventForNextFocusBlock contents: aBlock ! !

!ComposableModel methodsFor: 'protocol-focus' stamp: 'BenjaminVanRyseghem 7/10/2012 14:20'!
isEventForPreviousFocus
	
	^ isEventForPreviousFocusBlock contents! !

!ComposableModel methodsFor: 'protocol-focus' stamp: 'BenjaminVanRyseghem 7/10/2012 14:20'!
isEventForPreviousFocus: aKeyboardEvent 
	"Return true if the event provided as argument corresponds to the shortcut used to switch to the previous sub-widget"
	
	^ self isEventForPreviousFocusBlock cull: aKeyboardEvent! !

!ComposableModel methodsFor: 'protocol-focus' stamp: 'BenjaminVanRyseghem 7/10/2012 14:23'!
isEventForPreviousFocusBlock
	
	^ isEventForPreviousFocusBlock contents! !

!ComposableModel methodsFor: 'protocol-focus' stamp: 'BenjaminVanRyseghem 7/10/2012 14:20'!
isEventForPreviousFocusBlock: aBlock

	isEventForPreviousFocusBlock contents: aBlock ! !

!ComposableModel methodsFor: 'private-focus' stamp: 'BenjaminVanRyseghem 7/10/2012 14:26'!
keyStroke: anEvent fromMorph: aMorph

	((self isEventForNextFocus: anEvent) or: [ anEvent keyString = self eventStringForNextFocus])
		ifTrue: [ ^ self giveFocusToNextFrom: aMorph ].
		
	((self isEventForPreviousFocus: anEvent) or: [ anEvent keyString = self eventStringForPreviousFocus])
		ifTrue: [ ^ self giveFocusToPreviousFrom: aMorph ].
		
	^ false! !

!ComposableModel methodsFor: 'Morphic-Widgets-should-be-an-extension' stamp: 'BenjaminVanRyseghem 6/7/2012 12:26'!
listRenderOn: aCanvas atRow: aRow bounds: drawBounds color: drawColor from: aMorph
	"Specify how this object as a list item should be drawn"

	self widget ifNil: [ self buildWithSpec ].
	self widget listRenderOn: aCanvas atRow: aRow bounds: drawBounds color: drawColor from: aMorph! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/9/2012 14:00'!
needRebuild

	^ needRebuild contents! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/9/2012 14:00'!
needRebuild: aBoolean

	needRebuild contents: aBoolean! !

!ComposableModel methodsFor: 'private' stamp: ''!
okToChange

	^ owner 
		ifNil: [
			self canDiscardEdits ifTrue: [^ true].
			self changed: #wantToChange.  "Solicit cancel from view"
			^ self canDiscardEdits]
		ifNotNil: [ owner okToChange ]! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/26/2012 02:09'!
openDialogWithSpec
	"Build the widget using the default spec and display it into a window"

	^ self openDialogWithSpec: self defaultSpecSelector.! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 00:37'!
openDialogWithSpec: aSpec
	"Build the widget using the spec name provided as argument and display it into a window"

	(window notNil and: [ self needRebuild not ])
		ifTrue: [
			self needRebuild: true.
			window rebuildWithSpec: aSpec ]
		ifFalse: [
			window := DialogWindowModel new model: self.
			window openWithSpec: aSpec.
			self initializeDialogWindow: window.
			window updateTitle.
			self takeKeyboardFocus ].
	^ window! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 00:38'!
openDialogWithSpecLayout: aSpec
	"Build the widget using the spec name provided as argument and display it into a window"

	(window notNil and: [ self needRebuild not ])
		ifTrue: [
			self needRebuild: true.
			window rebuildWithSpec: aSpec ]
		ifFalse: [
			window := DialogWindowModel new model: self.
			window openWithSpecLayout: aSpec.
			self initializeDialogWindow: window.
			window updateTitle.
			self takeKeyboardFocus ].
		
	^ window! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/12/2012 14:57'!
openWithSpec
	"Build the widget using the default spec and display it into a window"

	^ self openWithSpec: self defaultSpecSelector.! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 00:29'!
openWithSpec: aSpec
	"Build the widget using the spec name provided as argument and display it into a window"

	(window notNil and: [ self needRebuild not ])
		ifTrue: [
			self needRebuild: true.
			window rebuildWithSpec: aSpec ]
		ifFalse: [ 
			window := WindowModel new model: self.
			window openWithSpec: aSpec.
			self takeKeyboardFocus ].
		
	^ window! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 00:17'!
openWithSpecLayout: aSpec
	"Build the widget using the spec name provided as argument and display it into a window"

	(window notNil and: [ self needRebuild not ])
		ifFalse: [ 
			window := WindowModel new model: self.
			window openWithSpecLayout: aSpec.
			self takeKeyboardFocus ]
		ifTrue: [
			self needRebuild: true.
			window rebuildWithSpecLayout: aSpec ].
		
	^ window! !

!ComposableModel methodsFor: 'accessing' stamp: ''!
owner: anObject
	
	owner ifNotNil: [owner removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	owner := anObject.! !

!ComposableModel methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/11/2012 10:00'!
resolveSymbol: aSymbol

	^ Smalltalk at: aSymbol! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/26/2012 00:47'!
show

	self widget ifNotNil: [:widget |
		(widget respondsTo: #show) ifTrue: [ widget show ]].! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/6/2012 18:25'!
spec

	^ spec! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/6/2012 18:26'!
spec: aSpec

	spec := aSpec! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/12/2012 14:58'!
specSelectors
	"Return all the spec names"
	
	^ self class specSelectors! !

!ComposableModel methodsFor: 'private-focus' stamp: 'StephaneDucasse 5/17/2012 17:57'!
takeKeyboardFocus

	self focusOrder ifNotEmpty:[:focus | ^ focus first takeKeyboardFocus ].
	^ self widget ifNotNil: [:m | m takeKeyboardFocus ]! !

!ComposableModel methodsFor: 'private-focus' stamp: ''!
takeLastKeyboardFocus

	self focusOrder
		ifEmpty: [ self takeKeyboardFocus ]
		ifNotEmpty: [:focus | focus last takeKeyboardFocus ].! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/12/2012 14:58'!
title
	"Return the window's title"

	^ self class title! !

!ComposableModel methodsFor: 'Morphic-Widgets-should-be-an-extension' stamp: 'BenjaminVanRyseghem 6/24/2012 23:11'!
treeRenderOn: aCanvas bounds: drawBounds color: drawColor font: aFont from: aMorph
	"Specify how this object as a list item should be drawn"

	self widget ifNil: [ self buildWithSpec ].
	self widget treeRenderOn: aCanvas bounds: drawBounds color: drawColor font: aFont from: aMorph! !

!ComposableModel methodsFor: 'private' stamp: ''!
update: aParameter

	self changed: aParameter! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/10/2012 15:35'!
updateTitle
	"Update the window title"

	self window ifNotNil: [:w | w updateTitle ]! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/7/2012 12:25'!
widget

	^ spec
		ifNil: [ nil ]
		ifNotNil: [:s | s instance ]! !

!ComposableModel methodsFor: 'Morphic-Widgets-should-be-an-extension' stamp: 'BenjaminVanRyseghem 7/10/2012 23:56'!
widthToDisplayInList: aList
	"Return the width of my representation as a list item"
	
	self extent ifNotNil: [:ex | ^ ex x ].
	self initialExtent ifNotNil: [:ex | ^ ex x ].

	self widget ifNil: [ self buildWithSpec ].
	^ self widget widthToDisplayInList: aList! !

!ComposableModel methodsFor: 'Morphic-Widgets-should-be-an-extension' stamp: 'BenjaminVanRyseghem 7/10/2012 23:56'!
widthToDisplayInTree: aTree
	"Return the width of my representation as a list item"
	
	self extent ifNotNil: [:ex | ^ ex x ].
	self initialExtent ifNotNil: [:ex | ^ ex x ].
	
	self widget ifNil: [ self buildWithSpec ].
	^ self widget widthToDisplayInTree: aTree! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 17:47'!
window

	^ window! !

ComposableModel subclass: #DropListExample
	instanceVariableNames: 'dropList container morph1 morph2 morph3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples-Widgets'!

!DropListExample commentStamp: '<historical>' prior: 0!
A DropListExample is a simple example of how to use drop lists.

DropListExample new openWithSpec!

!DropListExample class methodsFor: 'specs' stamp: 'bvr 6/4/2012 17:24'!
defaultSpec

	^ { #ComposableSpec.
			#add:.	{ self topSpec.
						#layout:. 	{#LayoutFrame.
										#fractions:offsets:.	(0@0 corner: 1@0).	(0@0 corner: 0@30). }}.
			#add:.	{{#model. #container.}.
						#layout:. 	{#LayoutFrame.
										#fractions:offsets:.	 (0@0 corner: 1@1).	(0@42 corner: 0@0). }}}! !

!DropListExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/5/2012 17:17'!
title

	^ 'Drop list'! !

!DropListExample class methodsFor: 'specs' stamp: 'bvr 6/4/2012 17:19'!
topSpec

	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#dropList.}.
			#hResizing:.	#spaceFill.
			#vResizing:.	#shrinkWrap.	}! !

!DropListExample methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 2/2/2012 15:38'!
blueMorphBlock

	^ [ 	container removeAllMorphs.
		container addMorph: morph2 ]! !

!DropListExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 15:20'!
container

	^ container! !

!DropListExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 15:36'!
dropList

	^ dropList! !

!DropListExample methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 2/2/2012 15:38'!
greenMorphBlock

	^ [ 	container removeAllMorphs.
		container addMorph: morph3 ]! !

!DropListExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:25'!
initialize
	"Initialization code for RadioButtonGroupExample"

	container := PanelMorph new.
	self instantiateMorphs.
	
	container
		changeTableLayout;
		listDirection: #bottomToLeft.
	
	super initialize.! !

!DropListExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:25'!
initializeWidgets 

	| item1 item2 item3 |

	self instantiateModels: #(dropList #DropListModel).
	
	item1 := DropListItem named: 'Red morph' do: self redMorphBlock.
	item2 := DropListItem named: 'Blue morph' do: self blueMorphBlock.
	item3 := DropListItem named: 'Green morph' do: self greenMorphBlock.
	
	dropList items: {item1. item2. item3}.
	self setFocus.! !

!DropListExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 15:20'!
instantiateMorphs

	morph1 := Morph new
					color: Color red;
					width: 60;
					height: 20.
	morph2 := Morph new
					color: Color blue;
					width: 20;
					height: 60.
	morph3 := Morph new
					color: Color green;
					width: 50;
					height: 50.! !

!DropListExample methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 2/2/2012 15:38'!
redMorphBlock

	^ [ 	container removeAllMorphs.
		container addMorph: morph1 ]! !

!DropListExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 15:26'!
setFocus
	
	self focusOrder
		add: dropList;
		add: container.
	! !

ComposableModel subclass: #DualChangeSorterApplication
	instanceVariableNames: 'model changeSorterLeft changeSorterRight isRefreshing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-ChangeSorter'!

!DualChangeSorterApplication commentStamp: '<historical>' prior: 0!
A DualChangeSorterApplication is a dual change sorter based on psec!

!DualChangeSorterApplication class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/31/2012 16:16'!
defaultSpec
	<spec>
	
	^ SpecLayout composed
			newRow: [:r |
					r 
						add: #changeSorterLeft;
						addSplitter;
						add: #changeSorterRight ]! !

!DualChangeSorterApplication class methodsFor: 'menu' stamp: 'StephaneDucasse 7/4/2012 19:57'!
menuCommandOn: aBuilder 
	<worldMenu> 
	(aBuilder group: #SystemChanges)
		parent: #Tools;  
		with: [
			(aBuilder item: #'Change Sorter (Spec)')
				action:[self new openWithSpec]; 
				icon: self taskbarIcon.
			(aBuilder item: #'Recover lost changes...') 
				action: [Smalltalk tools changeList browseRecentLog]]! !

!DualChangeSorterApplication class methodsFor: 'tools-registry' stamp: 'StephaneDucasse 7/4/2012 19:48'!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 
	registry register: self as: #dualChangeSorter! !

!DualChangeSorterApplication class methodsFor: 'specs' stamp: ''!
title

	^'Dual Change Sorter'! !

!DualChangeSorterApplication methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 6/13/2012 12:00'!
changeSet: src to: dest shortcuts: event from: aMorph

	event keyString = '<Cmd-c>' 	ifTrue: [ self copyAllFrom: src to: dest ].
	event keyString = '<Cmd-->' 	ifTrue: [ self subtractFrom: src to: dest ].
	
	^ src changeSetShortcuts: event from: aMorph.! !

!DualChangeSorterApplication methodsFor: 'accessing' stamp: ''!
changeSorterLeft

	^ changeSorterLeft! !

!DualChangeSorterApplication methodsFor: 'accessing' stamp: ''!
changeSorterRight

	^ changeSorterRight! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 6/13/2012 12:25'!
changesMenu: menu shifted: shifted from: src to: dest

	src changeSetMenu1: menu shifted: shifted.
	
	src selectedChangeSet
		ifNotNil:[
			menu 
				add: 'Copy all to the other change set (c)' 
				target: self
				selector: #copyAllFrom:to:
				argumentList: {src.dest}.
			menu 
				add: 'Submerge into the other change set' 
				target: self
				selector: #submerge:into:
				argumentList: {src.dest}.
			menu 
				add: 'Subtract the other change set (-)'
				target: self
				selector: #subtractFrom:to:
				argumentList: {src.dest}.
			menu addLine] .
	
	src changeSetMenu2: menu shifted: shifted.
	^ menu! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
checkThatSidesDiffer: escapeBlock
	"If the change sets on both sides of the dual sorter are the same, put up an error message and escape via escapeBlock, else proceed happily"

	changeSorterLeft selectedChangeSet == changeSorterRight selectedChangeSet
		ifTrue:
			[self inform: 
'This command requires that the
change sets selected on the two
sides of the change sorter *not*
be the same.'.
			^ escapeBlock value]
! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: 'tbn 7/5/2012 14:14'!
classMenu: aMenu shifted: shifted from: src to: dest
	"Fill aMenu with items appropriate for the class list"

	src selectedClass ifNil: [ ^ nil ].
	aMenu target: self.
	aMenu
			add: 'Copy class to the other change set(c)' 
			target: self
			selector: #copyClassFrom:to:
			argumentList: {src.dest}.
	aMenu
			add: 'Move class to the other change set' 
			target: self
			selector: #moveClassFrom:to:
			argumentList: {src.dest}.
	aMenu addLine.
						
	src classMenu: aMenu shifted: shifted.
	^ aMenu! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 6/13/2012 11:58'!
copyAllFrom: src to: dest

	self checkThatSidesDiffer: [ ^ self ].
	self model copyAllChangesFrom: (src selectedChangeSet) to: (dest selectedChangeSet).
	dest updateClassesList.! !

!DualChangeSorterApplication methodsFor: 'menu - class' stamp: 'BenjaminVanRyseghem 6/13/2012 12:13'!
copyClassFrom: src to: dest
	"Place these changes in the other changeSet also"

	| otherChangeSet |
	self checkThatSidesDiffer: [ ^ self ].
	self okToChange ifFalse: [ ^ Beeper beep ].
	src selectedClass ifNil: [ ^ Beeper beep ].
	otherChangeSet := dest selectedChangeSet.
	
	self model copyClass: src selectedClass from: src selectedChangeSet to: otherChangeSet.
	
	dest setSelectedChangeSet: otherChangeSet.! !

!DualChangeSorterApplication methodsFor: 'menu - method' stamp: 'BenjaminVanRyseghem 6/13/2012 12:18'!
copyMethodFrom: src to: dest
	"Place this change in the other changeSet also"	
	| other |
	
	self checkThatSidesDiffer: [^ self].
	other := dest selectedChangeSet.
	
	src selectedSelector ifNotNil: [:selector || class |
		class := src selectedClass.
		
		self model 
			copySelector: selector 
			inClass: class 
			from: src selectedChangeSet 
			to: other.
			
		dest updateClassesListAndMessagesList ].! !

!DualChangeSorterApplication methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/31/2012 16:17'!
initialExtent

	^  900@530! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:12'!
initialize
	"Initialization code for DualChangeSorterApplication"

	super initialize.

	model := ChangeSorterModel new.
	isRefreshing := false.
	
	self bindings: MorphicBindingsWithSplitters new.! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/13/2012 12:32'!
initializePresenter

	changeSorterLeft 	whenChangesListChanges: [ self refeshedChangeSet: changeSorterRight ].
	changeSorterRight	whenChangesListChanges: [ self refeshedChangeSet: changeSorterLeft ].
! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:22'!
initializeWidgets
	"Initialization code for DualChangeSorterApplication"

	self instantiateModels: #(
		changeSorterLeft  ChangeSorterApplication
		changeSorterRight  ChangeSorterApplication ).
		
	self menusRegistration.
	self shortcutsRegistration.
	self setFocusOrder! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/13/2012 12:30'!
menusRegistration

	self menusRegistrationFrom: changeSorterLeft to: changeSorterRight.
	self menusRegistrationFrom: changeSorterRight to: changeSorterLeft! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 6/13/2012 12:29'!
menusRegistrationFrom: src to: dest
	
	src changesMenu: [:menu :shifted | self changesMenu: menu shifted: shifted from: src to: dest ].
	src classesMenu: [:menu :shifted | self classMenu: menu shifted: shifted from: src to: dest ].
	src methodsMenu: [:menu :shifted | self messageMenu: menu shifted: shifted from: src to: dest ].! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: 'SeanDeNigris 7/16/2012 07:50'!
messageMenu: aMenu shifted: shifted from: src to: dest
	"Fill aMenu with items appropriate for the message list; could be for a single or double changeSorter"

	src selectedSelector ifNil: [ ^ nil ].	
	aMenu target: self.

	aMenu
			add: 'Copy method to the other change set'
			target: self
			selector: #copyMethodFrom:to:
			argumentList: {src.dest}.
	aMenu
			add: 'Move method to the other change set' 
			target: self
			selector: #moveMethodFrom:to:
			argumentList: {src.dest}.
	aMenu addLine.
					
	src messageMenu: aMenu shifted: shifted.
	
	^ aMenu! !

!DualChangeSorterApplication methodsFor: 'accessing' stamp: ''!
model

	^ model! !

!DualChangeSorterApplication methodsFor: 'menu - class' stamp: 'BenjaminVanRyseghem 6/13/2012 12:14'!
moveClassFrom: src to: dest

	self checkThatSidesDiffer: [^ self].
	(self okToChange and: [ src selectedClass notNil])
		ifFalse: [ ^ false ].

	self copyClassFrom: src to: dest.
	src forgetClass! !

!DualChangeSorterApplication methodsFor: 'menu - method' stamp: 'BenjaminVanRyseghem 6/13/2012 12:19'!
moveMethodFrom: src to: dest

	self copyMethodFrom: src to: dest.
	src forgetMessage.
	src updateClassesListAndMessagesList.! !

!DualChangeSorterApplication methodsFor: 'event' stamp: 'BenjaminVanRyseghem 6/13/2012 12:31'!
refeshedChangeSet: changeSet

	isRefreshing
		ifFalse: [
			isRefreshing := true.
			changeSet updateChangesList.
			isRefreshing := false ]! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: ''!
setFocusOrder

	self focusOrder
		add: changeSorterLeft;
		add: changeSorterRight.! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/13/2012 12:05'!
shortcutsRegistration

	self shortcutsRegistrationFrom: changeSorterLeft to: changeSorterRight.
	self shortcutsRegistrationFrom: changeSorterRight to: changeSorterLeft.! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/13/2012 12:03'!
shortcutsRegistrationFrom: src to: dest
	
	src changesShortcuts: [:event :source | self changeSet: src to: dest shortcuts: event from: source ].! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 6/13/2012 12:10'!
submergeFrom: src into: dest
	"Copy the contents of the receiver to the other side, then remove the receiver -- all after checking that all is well."
	| source destination index |

	source := src selectedChangeSet.
	destination := dest selectedChangeSet.
	index := src selectedChangeSetIndex.

	(self model submerge: source into: destination) ifFalse: [ ^ self ].
	
	src updateChangesList.
	src setSelectedChangeSetIndex: index.! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 6/13/2012 12:01'!
subtractFrom: src to: dest
	"Subtract the changes found on the other side from the requesting side."
	| source destination |
	source := src selectedChangeSet.
	destination := dest selectedChangeSet.
	
	self checkThatSidesDiffer: [^ self].
	
	self model substractFrom: source to: destination.
	
	changeSorterRight setSelectedChangeSet: source.! !

ComposableModel subclass: #DummyComposableModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!DummyComposableModel commentStamp: '<historical>' prior: 0!
A DummyComposableModel is a stupid ComposableSpec subclass used to uglyly retrieve the bindings

The bindings should be a class side inst var of SpecInterpreter!

!DummyComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 6/13/2012 16:35'!
defaultSpec

	^ SpecLayout composed! !

!DummyComposableModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:14'!
initializeWidgets 
	"Absorb"! !

ComposableModel subclass: #DynamicComposableModel
	instanceVariableNames: 'widgets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!DynamicComposableModel commentStamp: '<historical>' prior: 0!
A DynamicComposableModel is a model of spec with a dynamic binding for subwidgets!

!DynamicComposableModel methodsFor: 'error handling' stamp: 'BenjaminVanRyseghem 7/9/2012 16:01'!
doesNotUnderstand: aMessage

	^ widgets at: aMessage selector ifAbsent: [ super doesNotUnderstand: aMessage ]! !

!DynamicComposableModel methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/11/2012 03:29'!
initialize
	"Initialization code for DynamicComposableModel"

	widgets := OrderedIdentityDictionary new asValueHolder.
	super initialize.	! !

!DynamicComposableModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/10/2012 23:21'!
initializeWidgets! !

!DynamicComposableModel methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/9/2012 16:24'!
instantiateModels: aCollectionOfPairs

	aCollectionOfPairs pairsDo: [ :k :v |
		widgets at: k asSymbol put: (self createInstanceFor: v) ]! !

!DynamicComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/10/2012 21:51'!
needFullRebuild: aBoolean

	self needRebuild: aBoolean.
	self widgetsDo: [:e | e needRebuild: aBoolean ]! !

!DynamicComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 03:30'!
widgets

	^ widgets! !

!DynamicComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/10/2012 21:51'!
widgetsDo: aBlock

	self widgets do: aBlock ! !

DynamicComposableModel subclass: #SubwidgetItem
	instanceVariableNames: 'model initialExtent validated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!SubwidgetItem class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/11/2012 04:20'!
spec
	<spec>
	
	^ SpecLayout composed 
		newRow: [:r |
			r
				add: #instVarName;
				add: #classChooser;
				newColumn: [:c | c add: #ok ] width: 75 ] 
		height: 25;
		send: #borderWidth: withArguments: { 1 };
		yourself! !

!SubwidgetItem methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 02:23'!
addInLayout: aColumn

	aColumn 
		add: self text getText asSymbol
		origin: (self x0Field getText squeezeOutNumber @ self y0Field getText squeezeOutNumber)
		corner: (self x1Field getText squeezeOutNumber @ self y1Field getText squeezeOutNumber)! !

!SubwidgetItem methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/10/2012 22:31'!
buildClassItems

	^ AbstractBasicWidget allSubclasses collect: [:class |
		DropListItem 
			named: class name
			do: [ ]] ! !

!SubwidgetItem methodsFor: 'transformation' stamp: 'BenjaminVanRyseghem 7/11/2012 04:02'!
deleteMe
	| name |
	
	name := self text getText.
	self validated: false.
	self widgets removeAll.
	self initializeWidgets.
	self model ifNotNil: [:m | m removeInstVar: name ].
	self needFullRebuild: false.
	self buildWithSpec.
	! !

!SubwidgetItem methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 01:56'!
initialExtent 

	^ initialExtent! !

!SubwidgetItem methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/11/2012 03:36'!
initialize
	"Initialization code for SubwidgetItem"

	super initialize.
	
	model := nil asValueHolder.
	initialExtent := 400@25.
	validated := false asValueHolder.! !

!SubwidgetItem methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/10/2012 22:55'!
initializeWidgets 

	self instantiateModels: #(
		instVarName 	TextInputFieldModel
		classChooser	DropListModel
		ok 				ButtonModel ).
					
	self instVarName 
		ghostText: 'name';
		entryCompletion: nil;
		autoAccept: true;
		acceptBlock: [:t | self ok enabled: t isEmpty not ].
		
	self classChooser items: self buildClassItems.
	
	self ok 
		label: 'create';
		state: false;
		enabled: false;
		action: [ self transform ]! !

!SubwidgetItem methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/10/2012 22:39'!
model

	^ model contents! !

!SubwidgetItem methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/10/2012 22:39'!
model: anObject

	model contents: anObject! !

!SubwidgetItem methodsFor: 'transformation' stamp: 'BenjaminVanRyseghem 7/11/2012 04:09'!
newLayout

	^ SpecLayout composed 
		newColumn: [:c |
			c
				newRow: [:r | 
					r 
						add: #text;
						newColumn: [:c1 | c1 add: #remove ] 
						width: 30 ]
				height: 25;
				newRow: [:r | 
					r 
						newColumn: [:c1 | c1 add: #x0 ] 
						width: 30;
						add: #x0Field;
						newColumn: [:c1 | c1 add: #y0 ] 
						width: 30;
						add: #y0Field;
						newColumn: [:c1 | c1 add: #x1 ] 
						width: 30;
						add: #x1Field;
						newColumn: [:c1 | c1 add: #y1 ] 
						width: 30;
						add: #y1Field ]
				height: 25 ];
		yourself! !

!SubwidgetItem methodsFor: 'transformation' stamp: 'BenjaminVanRyseghem 7/11/2012 04:05'!
transform
	| name class |

	name := self instVarName getText asString.
	self validated: true.
	class := self classChooser selectedItem label asSymbol.

	self widgets removeAll.
	self instantiateModels: #(
		text 		TextInputFieldModel
		remove 	ButtonModel
		x0			LabelModel
		x0Field 		TextInputFieldModel
		y0			LabelModel
		y0Field 		TextInputFieldModel
		x1			LabelModel
		x1Field 		TextInputFieldModel
		y1			LabelModel
		y1Field 		TextInputFieldModel ).
			
	self text 
		text: name;
		enabled: false.
		
	self remove
		label: 'x';
		state: false;
		action: [ self deleteMe ].
		
	self x0 text: 'x0'.
	self y0 text: 'y0'.
	self x1 text: 'x1'.
	self y1 text: 'y1'.
		
	self x0Field 
		text: '0';
		autoAccept: true;
		acceptBlock: [ self model ifNotNil: [:m | m rebuild ]].
	self y0Field 
		text: '0';
		autoAccept: true;
		acceptBlock: [ self model ifNotNil: [:m | m rebuild ]].
	self x1Field 
		text: '1';
		autoAccept: true;
		acceptBlock: [ self model ifNotNil: [:m | m rebuild ]].
	self y1Field 
		text: '1';
		autoAccept: true;
		acceptBlock: [ self model ifNotNil: [:m | m rebuild ]].
	
	self needRebuild: false.
	initialExtent :=  400@50.
	self buildWithSpecLayout: self newLayout.
	self model ifNotNil: [:m | m addInstVarNamed: name forClassName: class ].! !

!SubwidgetItem methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 03:34'!
validated

	^ validated contents! !

!SubwidgetItem methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/11/2012 03:34'!
validated: aBoolean

	validated contents: aBoolean! !

ComposableModel subclass: #InstVarAdder
	instanceVariableNames: 'description nameField nameLabel toolbar typeField typeLabel typeChoice selectedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder-Tools'!

!InstVarAdder class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:45'!
defaultSpec
	<spec>
	| height width |
	height := 25.
	width := (StandardFonts defaultFont widthOfString: 'Name:') + 10.
	^ { #ComposableSpec.
			#add:. {{#model. #nameLabel.}.
							#layout:. 	{#FrameLayout.
											#fractions:offsets:.	 ( 0@0 corner: 0.5@1 ).	(0@0 corner: 0@(2*height) negated). }}.
			#add:. {{#model. #nameField.}.
							#layout:. {#FrameLayout.
											#fractions:offsets:.	( 0@0 corner: 1@1 ).	(width@0 negated corner: 0@(2*height) negated). }}.
			#add:. {{#model. #typeLabel.}.
							#layout:. 	{#FrameLayout.
											#fractions:offsets:.	 (0@1 corner: 0.5@1).	(0@(2*height negated) corner: 0@(height negated)). }}.										
			#add:.	{{#model. #typeChoice.}.
							#layout:. 	{#FrameLayout.
											#fractions:offsets:.	 (0@1 corner: 1@1).	(width@(2*height negated) corner: 0@(height negated)). }}.
																		
			#add:.	{{#model. #toolbar.}.
							#layout:. 	{#FrameLayout.
											#fractions:offsets:.	 (0@1 corner: 1@1).	(0@(height negated) corner: 0@0). }}}! !

!InstVarAdder class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/28/2012 21:54'!
title

	^ 'Add an inst var...'! !

!InstVarAdder methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/2/2012 05:54'!
accept
	| name cl |
	nameField accept.
	(name := nameField getText) isEmptyOrNil ifFalse: [
			cl := selectedClass contents.
			cl ifNil: [ cl := ComposableModel ].
			description contents addInstVarNamed: name kindOfComposablaeModel: cl.
			description contentsChanged ]! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 22:07'!
description
	^ description contents! !

!InstVarAdder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/28/2012 21:34'!
description: aDescription

	description contents: aDescription! !

!InstVarAdder methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/28/2012 21:55'!
initialExtent

	^ 260@115! !

!InstVarAdder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:08'!
initialize
	"Initialization code for InstVarAdder"	

	description := nil asValueHolder.
	selectedClass := nil asValueHolder.
	super initialize.! !

!InstVarAdder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:56'!
initializePresenter

	toolbar okAction: [ self accept ].! !

!InstVarAdder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:56'!
initializeWidgets


	self instantiateModels: #(
		nameField TextInputFieldModel
		nameLabel LabelModel
		toolbar OkCancelToolbar
		typeChoice DropListModel
		typeLabel LabelModel ).
	
	nameLabel text: 'Name:'.
	nameField 
		autoAccept: true;
		entryCompletion: nil.
	typeLabel text: 'Class:'.
	
	typeChoice items: ((ComposableModel subclasses sort: [:a :b | a name < b name ]) collect: [: e | DropListItem named: e name do: [ selectedClass contents: e ]]) .
	
	self setFocus! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:59'!
nameField
	^ nameField! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:59'!
nameLabel
	^ nameLabel! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:59'!
selectedClass
	^ selectedClass! !

!InstVarAdder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/1/2012 21:46'!
setFocus

	self focusOrder 
		add: nameField;
		add: typeChoice;
		add: toolbar.! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:59'!
toolbar
	^ toolbar! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:59'!
typeChoice
	^ typeChoice! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:59'!
typeField
	^ typeField! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:59'!
typeLabel
	^ typeLabel! !

!InstVarAdder methodsFor: 'protocol-events' stamp: 'bvr 5/31/2012 13:33'!
whenDescriptionChanged: aBlock

	description whenChangedDo: aBlock! !

ComposableModel subclass: #InstVarSetter
	instanceVariableNames: 'list picklist text okCancelToolbar descriptionHolder addButton removeButton textBindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder-Tools'!

!InstVarSetter class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 6/12/2012 19:11'!
defaultSpec
	<spec>
	| delta |
	delta := 25.
	^{ #ComposableSpec.
			#add:. {{#model. #list. }.
							#layout:. 	{#LayoutFrame.
											#fractions:offsets:.	 (0@0 corner: 0.33@1).	(0@0 corner: 0@((2*delta) negated)). }}.						
			#add:. {{#model. #addButton }.
							#layout:. 	{#LayoutFrame.
											#fractions:offsets:.	 (0@1 corner: 0.16@1).	(0@((2*delta) negated) corner: 0@(delta negated)). }}.
			#add:. {{#model. #removeButton }.
							#layout:. 	{#LayoutFrame.
											#fractions:offsets:.	 (0.16@1 corner: 0.33@1).	(0@((2*delta) negated) corner: 0@(delta negated)). }}.
			#add:. {{#model. #picklist }.
							#layout:. 	{#LayoutFrame.
											#fractions:offsets:.	 (0.33@0 corner: 0.66@1).	(0@0 corner: 0@(delta negated)). }}.															
			#add:. {{#model. #text }.
							#layout:. 	{#LayoutFrame.
											#fractions:offsets:.	 (0.66@0 corner: 1@1).		(0@0 corner: 0@(delta negated)). }}.
			#add:. {{#model. #okCancelToolbar }.
							#layout:. 	{#LayoutFrame.
											#fractions:offsets:.	 (0@1 corner: 1@1).		(0@(delta negated) corner: 0@0). }}}! !

!InstVarSetter class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/28/2012 01:40'!
title

	^'Inst var setter'! !

!InstVarSetter methodsFor: 'protocol' stamp: 'bvr 5/31/2012 13:42'!
accept
	| instVars desc |
	desc := descriptionHolder contents.
	desc ifNil: [ ^ self ].
	
	text accept.
	instVars := textBindings select: [:assoc | assoc notNil and: [ assoc values anySatisfy: [:v | v value ]]].
	instVars associations do: [:assoc || instVar source events |
		instVar := assoc key.
		source := String streamContents: [:s | s << 'register' << instVar name capitalized << 'Events'].
		desc addCodeToInitialize: 'self ', source order: 1.
		desc addMethodWithSource: source category: 'initialization'.
		events := assoc value select: [:a | a value ].
		events associations do: [:a || src |
			src := String streamContents: [:s | s << instVar name << ' ' << a key asString << ': '  << a value key  << '.'].
			desc addCodeTo: source source: src order: 1 ]].! !

!InstVarSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:32'!
addButton

	^ addButton! !

!InstVarSetter methodsFor: 'private' stamp: 'bvr 5/31/2012 13:33'!
addInstVar
	| adder |
	
	adder := InstVarAdder new.
	adder 
		description: descriptionHolder contents;
		openWithSpec.
		
	adder whenDescriptionChanged: [ self description: adder description ]! !

!InstVarSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/1/2012 21:43'!
defaultText
		
	^ '[:new :old :announcement :announcer |  ]'! !

!InstVarSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/28/2012 14:20'!
description

	^ descriptionHolder contents! !

!InstVarSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/28/2012 14:11'!
description: aDescription

	descriptionHolder contents: aDescription! !

!InstVarSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/28/2012 14:20'!
hasBindingOf: aString 
	
	^ self description
		ifNil: [ false ]
		ifNotNil: [:desc | (desc addInstVarDescriptions collect: #name) includes: aString ]! !

!InstVarSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/28/2012 14:21'!
hasBindingThatBeginsWith: aString
	
	^ self description
		ifNil: [ false ]
		ifNotNil: [:desc | (desc addInstVarDescriptions collect: #name) anySatisfy: [:name | name beginsWith: aString ]]! !

!InstVarSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/28/2012 03:38'!
initialExtent

	^ (700 min: (World extent x)) @ (300 min: (World extent y))! !

!InstVarSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:09'!
initialize
	"Initialization code for InstVarSetter"

	descriptionHolder := nil asValueHolder.
	textBindings := Dictionary new.
	super initialize.	! !

!InstVarSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/29/2012 11:54'!
initializeBindingsFrom: desc
	
	desc addInstVarDescriptions do: [:e || adds | 
		textBindings at: e put: Dictionary new.
		adds := desc addIntoMethodDescriptions select: [:d | d selector = ('register', e name capitalized, 'Events') ].
		 adds do: [:a || source item |
			source :=  a code substrings.
			item := source second allButLast asSymbol.
			(bindings at: e) at: item put: (((source allButFirst:2) joinUsing: ' ')->true) ]].! !

!InstVarSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:57'!
initializePresenter
	
	okCancelToolbar okAction: [ self accept ].
	addButton action: [ self addInstVar ].
	removeButton action: [ self removeInstVar ].
	
	self registerListEvents.
	self registerPickListEvents.
	self registerDescriptionEvents.
	self registerTextEvents! !

!InstVarSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:07'!
initializeWidgets

	self instantiateModels: #(
		list ListComposableModel
		picklist PickListModel
		text TextModel
		okCancelToolbar OkCancelToolbar
		addButton ButtonModel
		removeButton ButtonModel ).

	
	list displayBlock: [:e | e name ].
	picklist labelClickable: false.
	text aboutToStyle: true.
	text enabled: false.
	okCancelToolbar okAction: [ self accept ].

	addButton
		label: '+';
		state: false.
		
	removeButton
		label: '-';
		state: false.! !

!InstVarSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/28/2012 14:19'!
inspectedClass

	^ descriptionHolder contents addClassDescription! !

!InstVarSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 02:02'!
list
	^ list! !

!InstVarSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 03:22'!
okCancelToolbar
	^ okCancelToolbar! !

!InstVarSetter methodsFor: 'protocol' stamp: 'bvr 5/31/2012 13:42'!
openWithSpec

	super openWithSpec.
	text widget ifNotNil: [:m | m styler workspace: self ]! !

!InstVarSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 02:02'!
picklist
	^ picklist! !

!InstVarSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/5/2012 06:52'!
registerDescriptionEvents

	descriptionHolder whenChangedDo: [:desc|| items |
		self initializeBindingsFrom: desc.
		items := desc addInstVarDescriptions select: [:e | e type inheritsFrom: ComposableModel ].
		list items: (items sort: [:a :b | a name < b name ])]! !

!InstVarSetter methodsFor: 'initialization' stamp: 'bvr 5/31/2012 13:33'!
registerListEvents

	list whenSelectedItemChanged: [:instVarDesc |
		instVarDesc
			ifNil: [ picklist items: {} ]
			ifNotNil: [
				picklist items: (instVarDesc type possibleEvents).
				(instVarDesc type possibleEvents) do: [:e |
					(picklist checkboxFor: e) state: ((textBindings at: list selectedItem ifAbsentPut: [ Dictionary new ]) at: e ifAbsentPut: [ self defaultText->false ]) value ]].
		picklist resetSelection.
		text text: '' ]! !

!InstVarSetter methodsFor: 'initialization' stamp: 'bvr 5/31/2012 13:33'!
registerPickListEvents
	
	picklist whenPickedItemsChanged: [:item :old|
		item ifNotNil: [
			((textBindings at: list selectedItem ifAbsentPut: [ Dictionary new ]) at: item ifAbsentPut: [ self defaultText->false ]) value: old ]].
	
	picklist whenSelectedItemChanged: [:item || txt |
		item 
			ifNil: [ 
				text text: ''.
				text enabled: false ]
			ifNotNil: [
				txt := ((textBindings at: list selectedItem ifAbsentPut: [ Dictionary new ]) at: item ifAbsentPut: [ self defaultText->false ]) key.
				text text: txt.
				text enabled: true ]]! !

!InstVarSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/11/2012 11:46'!
registerTextEvents

	text acceptBlock: [:txt || item |
		item := picklist selectedItem.
		((textBindings at: list selectedItem ifAbsentPut: [ Dictionary new ]) at: item ifAbsentPut: [ self defaultText->false ]) key: txt .
		(picklist checkboxFor: item) state: true.]! !

!InstVarSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:32'!
removeButton

	^ removeButton! !

!InstVarSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/30/2012 17:10'!
removeInstVar
	
	descriptionHolder contents removeInstVar: list selectedItem.
	descriptionHolder contentsChanged.! !

!InstVarSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 02:02'!
text
	^ text! !

ComposableModel subclass: #IntegerEditor
	instanceVariableNames: 'integer slider text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!IntegerEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 19:33'!
buildWithSpec

	^ self buildWithSpecLayout: self layout! !

!IntegerEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 19:33'!
buildWithSpec: aSpec

	^ self buildWithSpecLayout: self layout! !

!IntegerEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 19:38'!
help: aString 
	
	slider help: aString ! !

!IntegerEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/12/2012 19:36'!
initialize
	"Initialization code for BlocEditor"

	super initialize.

	integer := 0 asValueHolder! !

!IntegerEditor methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/13/2012 05:34'!
initializeWidgets 

	self  instantiateModels: #( 
		slider 	SliderModel
		text 	LabelModel ).
			
	text 
		borderWidth: 4;
		borderColor: Color black;
		text: '0'.
	slider 
		quantum: 1;
		whenValueChangedDo: [:v | 
			integer contents: v.
			text text: v asString ].
			
	self focusOrder 
		add: slider;
		add: text! !

!IntegerEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 19:33'!
integer

	^ integer contents! !

!IntegerEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 19:33'!
integer: aBlock

	integer contents: aBlock ! !

!IntegerEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/12/2012 19:40'!
layout
	| width |
	width := StandardFonts defaultFont widthOfStringOrText: (slider max + slider quantum) asString.
	
	^ SpecLayout composed 
		newRow: [:r |
			r
				add: #slider;
				newColumn: [:c | c add: #text ] width: width ]
		 height: 25;
		yourself! !

!IntegerEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 19:38'!
max: aNumber

	slider max: aNumber! !

!IntegerEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 18:52'!
min: aNumber

	slider min: aNumber! !

!IntegerEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 19:34'!
slider
	^ slider! !

!IntegerEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 19:33'!
text
	^ text! !

!IntegerEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 19:38'!
value: aNumber

	slider value: aNumber! !

!IntegerEditor methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/12/2012 19:38'!
whenIntegerChangedDo: aBlock

	integer whenChangedDo: aBlock ! !

ComposableModel subclass: #ListSelectionModel
	instanceVariableNames: 'listModel textModel1 textModel2 textRefreshingProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples-Widgets'!

!ListSelectionModel commentStamp: '<historical>' prior: 0!
A ListSelectionModel is a basic example to show multi selection on lists

| l |
l := ListSelectionModel new.
l openWithSpec!

!ListSelectionModel class methodsFor: 'specs' stamp: 'bvr 6/4/2012 17:19'!
bottomSpec

	^ {#Panel.
			#changeTableLayout.
			#listDirection:.			#rightToLeft.
			#addMorph:.			{#model.	#textModel1.}.
			#addMorph:.			{#model.	#textModel2.}.
			#hResizing:.	#spaceFill.
			#vResizing:.	#spaceFill.}! !

!ListSelectionModel class methodsFor: 'specs' stamp: 'bvr 6/4/2012 17:24'!
defaultSpec

	^{#ComposableSpec.	
			#add:.			{{	#model.	#listModel.}.
									#layout:. {#FrameLayout.
													#fractions:.	 (0@0 corner: 1@0.5).}}.
			#add:.			{{	#model.	#textModel1.}.
									#layout:. {#FrameLayout.
													#fractions:.	 (0@0.5 corner: 0.5@1). }}.
			#add:.			{{	#model.	#textModel2.}.
									#layout:. {#FrameLayout.
													#fractions:.	 (0.5@0.5 corner: 1@1). }}}.! !

!ListSelectionModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:27'!
initializePresenter 

	listModel whenSelectionChanged: [ self updateText ]! !

!ListSelectionModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:27'!
initializeWidgets

	self instantiateModels: #(
		listModel ListComposableModel
		textModel1 TextModel
		textModel2 TextModel ).
	
	listModel beMultipleSelection.
	
	listModel items: Smalltalk allClasses.! !

!ListSelectionModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/9/2012 17:06'!
listModel

	^ listModel! !

!ListSelectionModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/9/2012 17:07'!
textModel1

	^ textModel1! !

!ListSelectionModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/9/2012 17:07'!
textModel2

	^ textModel2! !

!ListSelectionModel methodsFor: 'update' stamp: 'BenjaminVanRyseghem 2/9/2012 18:07'!
updateText
	"update the displayed list in a separate thread to avoid UI blocking"
	
	"if there is already a background thread running for the new list discard it"
	textRefreshingProcess ifNotNil: [
		textRefreshingProcess terminate].
	
	"fork off a possibly costly list calculation"
	textRefreshingProcess := [
		| indexes items |
		indexes := listModel selectedIndexes sort collect: [:i | i printString ].
		indexes :=  (indexes joinUsing: '; ').
		items := listModel selectedItems collect: [:i | i printString ].
		items := (items sort joinUsing: '; ').
		WorldState addDeferredUIMessage: [
			textModel1 text: indexes.
			textModel2 text: items]] fork.! !

ComposableModel subclass: #MessageBrowser
	instanceVariableNames: 'listModel textModel toolbarModel maxClassSize refreshingBlockHolder cachedHierarchy wrapper searchedStringHolder titleHolder model topologicSortHolder textConverterHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Senders'!

!MessageBrowser commentStamp: '<historical>' prior: 0!
A MessageBrowser is a UI to browse a list of method, regardless of what they could be.

example: 

MessageBrowser new
	openWithSpec;
	messages: (SystemNavigation new allSendersOf: #at:)
	yourself!

!MessageBrowser class methodsFor: 'instance creation' stamp: ''!
browseImplementors: aCollection of: aSymbol named: aName

	^ self new
		setRefreshingBlockForImplementorsOf: aSymbol;
		messages: aCollection;
		title: aName;
		yourself! !

!MessageBrowser class methodsFor: 'instance creation' stamp: ''!
browseMessages: aCollection refreshingBlock: aBlock named: anObject

	^ self new
		refreshingBlock: aBlock;
		messages: aCollection;
		yourself! !

!MessageBrowser class methodsFor: 'instance creation' stamp: ''!
browseSenders: aCollection of: aSymbol named: aName

	^ self new
		setRefreshingBlockForSendersOf: aSymbol;
		messages: aCollection;
		title: aName;
		autoSelect: aSymbol;
		yourself! !

!MessageBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 6/18/2012 06:09'!
defaultSpec
	<spec>
	| delta |
	delta := 13.
	^ SpecLayout composed 
			add: #listModel origin: 0@0 corner: 1@0.5 offsetOrigin: 0@0 offsetCorner: 0@(delta negated);
			add: #toolbarModel origin: 0@0.5 corner: 1@0.5 offsetOrigin: 0@(delta negated) offsetCorner: 0@delta;
			add: #textModel origin: 0@0.5 corner: 1@1 offsetOrigin: 0@delta offsetCorner: 0@0;
			yourself! !

!MessageBrowser class methodsFor: 'messageList interface' stamp: 'BenjaminVanRyseghem 5/14/2012 02:00'!
on: aMessageList named: aString

	^ self new
		messages: aMessageList methodReferenceList;
		title: aString;
		yourself! !

!MessageBrowser class methodsFor: 'instance creation' stamp: ''!
on: aList named: aString autoSelect: aSelector

	^ self new
		messages: aList;
		title: aString;
		autoSelect: aSelector;
		yourself! !

!MessageBrowser class methodsFor: 'protocolBrowser interface' stamp: 'BenjaminVanRyseghem 6/13/2012 10:51'!
openFullProtocolForClass: aClass
	"Open a browser on the methods understood by aClass including the methods from Object and ProtoObject"

	self new openFullProtocolForClass: aClass! !

!MessageBrowser class methodsFor: 'tool registration' stamp: ''!
openMessageList: messageList name: aString autoSelect: aSelector
	" Tool registry compitibility "

	| title |
	aString last = $]
			ifTrue: [ title := aString substrings allButLast joinUsing: ' ' ]
			ifFalse: [ title := aString ].
			
	(aString beginsWith: 'Senders')
		ifTrue: [ ^ (self browseSenders: messageList of: aSelector named: title) openWithSpec ].
	
	(aString beginsWith: 'Implementors')
		ifTrue: [ ^ (self browseImplementors: messageList of: aSelector named: title) openWithSpec ].
	
	^ (self on: messageList named: title autoSelect: aSelector) openWithSpec! !

!MessageBrowser class methodsFor: 'protocolBrowser interface' stamp: 'BenjaminVanRyseghem 6/13/2012 10:38'!
openSubProtocolForClass: aClass
	"Open a browser on the methods understood by aClass excluding the methods from Object and ProtoObject"

	self new openSubProtocolForClass: aClass! !

!MessageBrowser class methodsFor: 'tool registration' stamp: 'EstebanLorenzano 5/11/2012 11:42'!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 
	registry register: self as: #messageList! !

!MessageBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/31/2012 17:16'!
testSpec
	<spec: #default>
	
	^ SpecLayout composed
			newColumn: [:col |
				col 
					add: #listModel;
					addSplitter;
					add: #toolbarModel height: 25;
					add: #textModel ]
				! !

!MessageBrowser class methodsFor: 'specs' stamp: ''!
title

	^ 'Message Browser'! !

!MessageBrowser methodsFor: 'private' stamp: ''!
accept: text notifying: notifyer

	listModel selectedItem
		ifNotNil: [:message | message methodClass compile: text notifying: notifyer ]! !

!MessageBrowser methodsFor: 'text selection' stamp: ''!
autoSelect: aSelector

	textModel readSelectionBlock: [:text | self searchedString: aSelector in: text ]! !

!MessageBrowser methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 6/14/2012 10:12'!
buildHierarchyForMessages: messages
	| result classes |
	
	result := IdentityDictionary new.
	self topologicSort 
		ifFalse: [ 
			messages do: [:m | result at: m put: {} ].
			^ result ].
	
	classes := (messages collect: #methodClass) asSet.
	messages do: [:message || level class |
		class := message methodClass.
		level := OrderedCollection new.
		class allSuperclassesDo: [:superClass |
			(classes includes: superClass)
				ifTrue: [ level addFirst: superClass ]].
		level addLast: class.
		level addLast: message selector.
		result at: message put: level ].
	^ result! !

!MessageBrowser methodsFor: 'testing' stamp: ''!
cacheHierarchyForClasses: aCollection

	cachedHierarchy := self buildHierarchyForMessages: aCollection.! !

!MessageBrowser methodsFor: 'protocolBrowser interface' stamp: 'BenjaminVanRyseghem 6/13/2012 10:46'!
collectMethodsFrom: aClass til: superClass
	| methods class |

	methods := OrderedCollection new.
	class := aClass.
	methods addAll: class methods.
	
	[ class superclass = superClass ]
		whileFalse: [ 
			class := class superclass.
			methods addAll: class methods ].
	^ methods	! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/13/2012 10:48'!
displayBlock: aBlock

	^ listModel displayBlock: aBlock! !

!MessageBrowser methodsFor: 'private' stamp: ''!
highlightSearchedString: string
	
	| searchedString interval firstIndex |
	searchedString := searchedStringHolder contents.
	searchedString ifNil: [ ^ 0 to: 0 ].

	(searchedString includes: $:)
		ifTrue: [ | list |
			list := searchedString subStrings: ':'.
			list size = 1
				ifTrue: [" binary selector "
					firstIndex := string findString: searchedString.
					interval := firstIndex to: (firstIndex+searchedString size-1)]
				ifFalse: [| lastIndex |
					firstIndex := string findString: list first,':'.
					lastIndex := string findString: list last,':' startingAt: firstIndex+ (list first size -1).
					interval := firstIndex to: (lastIndex + list last size)]]
		ifFalse: [
			" unary selector "
			firstIndex := string findString: searchedString.
			interval := firstIndex to: (firstIndex+searchedString size-1)].
	^ interval! !

!MessageBrowser methodsFor: 'private' stamp: ''!
initialExtent

	^ (500 min: (World extent x)) @ (550 min: (World extent y))! !

!MessageBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/14/2012 10:32'!
initialize
	"Initialization code for MessageBrowser"

	textConverterHolder := SourceMethodConverter new asValueHolder.
	model := AbstractTool new.
	maxClassSize = nil.
	searchedStringHolder := '' asValueHolder.
	titleHolder := super title asValueHolder.
	topologicSortHolder := true asValueHolder.
	super initialize.
	
	self registerToAnnouncements.
	self bindings: MorphicBindingsWithSplitters new.! !

!MessageBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/20/2012 15:25'!
initializeDropList

	| item1 item2 item3 item4 |
	item1 := DropListItem 
					named: 'Source' 
					do: [ self textConverter: SourceMethodConverter new ].
	item2 := DropListItem 
					named: 'Byte Code' 
					do: [ self textConverter: ByteCodeMethodConverter new ].
	item3 := DropListItem
					named: 'Decompile' 
					do: [ self textConverter: DecompileMethodConverter new ].
	item4 := DropListItem
					named: 'Time stamp' 
					do: [ self textConverter: TimeStampMethodConverter new ].
	toolbarModel setDropListItems: {item1. item2. item3. item4}! !

!MessageBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/10/2012 15:32'!
initializePresenter

	listModel whenSelectedItemChanged: [:item |
			toolbarModel method: item.
			textModel behavior: (item ifNil: [ nil ] ifNotNil: [ item methodClass ]).
			textModel text: (self textConverter method: item; getText)].
		
	listModel whenListChanged: [ self updateTitle ].
		
	titleHolder whenChangedDo: [ self updateTitle ].
	textModel acceptBlock: [ :text :notifyer | self accept: text notifying: notifyer ].! !

!MessageBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 17:57'!
initializeWidgets

	self instantiateModels: #(
		listModel 		MultiColumnListModel
		textModel 		TextModel
		toolbarModel 	MethodToolbar ).
	
	listModel displayBlock: [ :item | self wrapItem: item ].
	textModel aboutToStyle: true.
	refreshingBlockHolder := [ :item | false ] asValueHolder.
				
	self
		setListMenu;
		setListShortcuts;	
		initializeDropList;
		setFocus.
! !

!MessageBrowser methodsFor: 'accessing' stamp: ''!
listModel
	
	^ listModel! !

!MessageBrowser methodsFor: 'initialization' stamp: 'CamilloBruni 5/8/2012 02:08'!
listShortcutsFor: event form: source message: method

	event keyString = '<Cmd-b>'			ifTrue: [ ^ Smalltalk tools browser fullOnClass: method methodClass selector: method selector ].
	event keyString = '<Cmd-i>'			ifTrue: [ ^ method inspect ].
	event keyString = '<Cmd-x>'			ifTrue: [ ^ model removeMethod: method inClass: method methodClass ].
	event keyString = '<Cmd-n>'			ifTrue: [ ^ model browseSendersOfMessagesFrom: method selector ].
	event keyString = '<Cmd-m>'			ifTrue: [ ^ model browseMessagesFrom: method selector ].
	event keyString = '<Cmd-N>'			ifTrue: [ ^ model browseClassRefsOf: method methodClass ].
	event keyString = '<Cmd-v>'			ifTrue: [ ^ model browseVersionsFrom: method compiledMethod ].
	^ false! !

!MessageBrowser methodsFor: 'private' stamp: ''!
maxClassSize

	^ maxClassSize ifNil:[| elt stm |
			elt := (listModel getList detectMax: [:e | e methodClass name size + (cachedHierarchy at: e) size]).
			stm := String streamContents: [:t | 
				3 to: (cachedHierarchy at: elt) size do: [:i | t << '    '].
				t << elt methodClass name ].
			maxClassSize := StandardFonts listFont widthOfString: stm ].
! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/14/2012 10:55'!
messages

	^ listModel listItems! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/7/2012 13:17'!
messages: aCollection

	self cacheHierarchyForClasses: aCollection.
	listModel items: (cachedHierarchy keys sort: [:a :b | self sortClassesInCachedHierarchy: a b: b]) asOrderedCollection.
	listModel listSize > 1
		ifTrue: [ 
			listModel setSelectedIndex: 1 ].! !

!MessageBrowser methodsFor: 'announcements' stamp: 'GuillermoPolito 8/3/2012 13:32'!
methodAdded: anAnnouncement
	| item |	
		
	self isDisplayed ifFalse: [ ^ self ].
	refreshingBlockHolder ifNil: [ ^ self ].
	item := anAnnouncement method.
	(refreshingBlockHolder contents cull: item cull: anAnnouncement cull: self) ifFalse: [ ^ self ].
	
	WorldState addDeferredUIMessage: [ 	| sel text boolean |
		boolean := textModel hasUnacceptedEdits.
		boolean ifTrue: [ text := textModel pendingText ].
		sel := listModel selectedItem.
		self messages: (listModel listItems add: item; yourself).
		listModel setSelectedItem: sel.
		boolean ifTrue: [ textModel pendingText: text ]
	]! !

!MessageBrowser methodsFor: 'announcements' stamp: 'GuillermoPolito 8/3/2012 13:34'!
methodModified: anAnnouncement
	| item oldItem sel index |
	
	self isDisplayed ifFalse: [ ^ self ].
	refreshingBlockHolder ifNil: [ ^ self ].
	item := anAnnouncement newMethod.
	oldItem := anAnnouncement oldMethod.
	sel := listModel selectedItem.
	sel ifNil: [ ^ self ].
	(sel notNil and: [(sel methodClass = oldItem methodClass and: [ sel selector = oldItem selector ])]) ifFalse: [ ^ self ].
	(refreshingBlockHolder contents cull: item cull: anAnnouncement cull: self) ifFalse: [ ^ self ].	
		index := listModel selectedIndex .
	WorldState addDeferredUIMessage: [	| text list edits |
		edits := textModel hasUnacceptedEdits.
		edits
			ifTrue: [ text := textModel pendingText ].
		list := listModel listItems 
				remove: sel ifAbsent: [];
				add: item asRingDefinition; "to ensure it's still as RGMethod"
				yourself. 
		self messages: list.
		listModel setSelectedIndex: index.
		edits
			ifTrue: [ 
				textModel pendingText: text.
				textModel hasEditingConflicts: true ].
		]! !

!MessageBrowser methodsFor: 'announcements' stamp: ''!
methodRecategorized: aMethod! !

!MessageBrowser methodsFor: 'announcements' stamp: 'GuillermoPolito 8/3/2012 13:34'!
methodRemoved: anAnnouncement
	| item |

	self isDisplayed ifFalse: [ ^ self ].
	refreshingBlockHolder ifNil: [ ^ self ].
	item := anAnnouncement methodRemoved.
	"Item is a compiled methed, where the list is populated with RGMethod"
	
	(refreshingBlockHolder contents cull: item cull: anAnnouncement cull: self)
		ifFalse: [ ^ self ].
	self okToChange ifFalse: [ ^ self ].
	WorldState addDeferredUIMessage:[ 	|  sel itm hasPendingText |
		sel := listModel selectedIndex.
		itm := listModel selectedItem.
		hasPendingText := false.
		(itm notNil and: [(itm methodClass = item methodClass and: [ itm selector = item selector ])])
			ifTrue: [ textModel hasUnacceptedEdits: false ].
		self messages: (listModel listItems remove: item asRingDefinition ifAbsent: [ nil ]; yourself).
		listModel setSelectedIndex: sel.
	]! !

!MessageBrowser methodsFor: 'messageList interface' stamp: 'BenjaminVanRyseghem 5/14/2012 02:00'!
open

	self openWithSpec! !

!MessageBrowser methodsFor: 'protocolBrowser interface' stamp: 'BenjaminVanRyseghem 6/13/2012 14:42'!
openFullProtocolForClass: aClass

	self messages: (self collectMethodsFrom: aClass til: nil).
	self title: 'Full protocol of ', aClass name.
	self openWithSpec.! !

!MessageBrowser methodsFor: 'protocolBrowser interface' stamp: 'BenjaminVanRyseghem 6/13/2012 14:42'!
openSubProtocolForClass: aClass

	self messages: (self collectMethodsFrom: aClass til: Object).
	self title: 'Sub protocol of ', aClass name.
	self openWithSpec.! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/10/2012 15:32'!
openWithSpec

	super openWithSpec.
	self updateTitle.
	textModel text: textModel getText.
	^ window! !

!MessageBrowser methodsFor: 'protocol' stamp: ''!
refreshingBlock: aBlock

	refreshingBlockHolder contents: aBlock! !

!MessageBrowser methodsFor: 'announcements-registration' stamp: 'EstebanLorenzano 8/3/2012 14:11'!
registerToAnnouncements

	SystemAnnouncer uniqueInstance weak		
		on: MethodAdded send: #methodAdded: to: self;
		on: MethodModified send: #methodModified: to: self;
		on: MethodRecategorized send: #methodRecategorized: to: self;
		on: MethodRemoved send: #methodRemoved: to: self! !

!MessageBrowser methodsFor: 'text selection' stamp: ''!
searchedString: searchedString in: aString
	| string interval firstIndex |
	
	searchedString ifNil: [ ^ 0 to: 0 ].
	aString isEmptyOrNil ifTrue: [ ^0 to: 0 ].
	string := aString asString.
	interval := 0 to: 0.
	
	(searchedString includes: $:)
		ifTrue: [ | list |
			list := searchedString subStrings: ':'.
			list size = 1
				ifTrue: [" binary selector "
					firstIndex := 1.
					[ firstIndex isZero not and: [ (string at: (firstIndex +1)) isAlphaNumeric ]]
						whileTrue: [
							firstIndex := string findString: searchedString startingAt: firstIndex+1.
							firstIndex isZero
								ifFalse: [ interval := firstIndex to: (firstIndex+searchedString size-1)]]]
				ifFalse: [| lastIndex |
					firstIndex := 1.
					[ firstIndex isZero not and: [ (string at: (firstIndex +1)) isAlphaNumeric ]]
						whileTrue: [
							firstIndex := string findString: list first,':' startingAt: firstIndex+1.
							firstIndex isZero
								ifFalse: [ 
									lastIndex := string findString: list last,':' startingAt: firstIndex+ (list first size -1).
									interval := firstIndex to: (lastIndex + list last size)]]]]
		ifFalse: [
			" unary selector "
			firstIndex := 1.
			[ firstIndex isZero not and: [ (string at: (firstIndex +1)) isAlphaNumeric ]]
				whileTrue: [
					firstIndex := string findString: searchedString startingAt: firstIndex +1.
					firstIndex isZero
						ifFalse: [ interval := firstIndex to: (firstIndex+searchedString size-1)]]].
	^ interval! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/14/2012 11:34'!
selectedItem

	^ listModel selectedItem! !

!MessageBrowser methodsFor: 'protocol' stamp: ''!
selectedMessage

	^ listModel selectedItem! !

!MessageBrowser methodsFor: 'protocol' stamp: ''!
selectedMessage: aMessage

	listModel setSelectedItem: aMessage.! !

!MessageBrowser methodsFor: 'initialization' stamp: ''!
setFocus

	self focusOrder
		add: listModel;
		add: toolbarModel;
		add: textModel! !

!MessageBrowser methodsFor: 'initialization' stamp: ''!
setListMenu

	listModel menu: [:menu || message |
		message := self selectedMessage.
		menu
			add: 'Browse full... (b)'
			target: Smalltalk tools browser
			selector: #fullOnClass:selector:
			argumentList: {message methodClass. message selector };
			add: 'Inspect method... (i)'
			target: message
			selector: #inspect;
			addLine;
			add: 'Remove method... (x)'
			target: model
			selector: #removeMethod:inClass:
			argumentList: {message. message methodClass.};
			add: 'Toggle Breakpoint'
			target: model
			selector: #toggleBreakOnEntryIn:
			argument: message;
			addLine;
			add: 'Senders of... (n)'
			target: model
			selector: #browseSendersOfMessagesFrom:
			argument: message selector;
			add: 'Implementors of... (m)'
			target: model
			selector: #browseMessagesFrom:
			argument: message selector ;
			add: 'Users of... (N)'
			target: model
			selector: #browseClassRefsOf:
			argument: message methodClass;
			add: 'Versions... (v)'
			target: model
			selector: #browseVersionsFrom:
			argument: message.
		menu]! !

!MessageBrowser methodsFor: 'initialization' stamp: ''!
setListShortcuts

	listModel shortcuts: [:event :source || message |
		message := self selectedMessage.
		self listShortcutsFor: event form: source message: message ]! !

!MessageBrowser methodsFor: 'protocol' stamp: ''!
setRefreshingBlockForImplementorsOf: aSelector

	self refreshingBlock: [:message | message selector = aSelector ].! !

!MessageBrowser methodsFor: 'protocol' stamp: ''!
setRefreshingBlockForSendersOf: aSelector
	| specialFlag specialByte |
	
	specialFlag := Smalltalk 
				hasSpecialSelector: aSelector
				ifTrueSetByte: [ :b | specialByte := b ].

	self refreshingBlock: [:method | (method refersToLiteral: aSelector) or: [ specialFlag and: [ method scanFor: specialByte ]]]! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/14/2012 11:41'!
setSelectedIndex: anIndex

	listModel setSelectedIndex: anIndex ! !

!MessageBrowser methodsFor: 'testing' stamp: ''!
sortClassesInCachedHierarchy: a b: b
	"Bullshitty name, Thanks Camillo"
	| index aa bb minSize|
	aa := cachedHierarchy at: a.
	bb := cachedHierarchy at: b.
	
	minSize := aa size min: bb size.
	
	1 to: minSize do: [ :i | |compare|
		compare := (aa at: i) name compare: (bb at: i) name.
		compare ~~ 2
			ifTrue: [  ^ compare == 1 ]].
	^  aa size < bb size! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/14/2012 10:15'!
sortingBlock: aBlock

	listModel sortingBlock: aBlock! !

!MessageBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/14/2012 10:32'!
textConverter
	
	^ textConverterHolder contents! !

!MessageBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/14/2012 10:32'!
textConverter: aTextConverter

	textConverterHolder contents: (aTextConverter method: self textConverter method).
	textModel aboutToStyle: self textConverter shouldShout .
	textModel text: self textConverter getText.! !

!MessageBrowser methodsFor: 'accessing' stamp: ''!
textModel
	
	^ textModel! !

!MessageBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/10/2012 15:31'!
title
		
	^ titleHolder contents , ' [' , listModel listSize printString , ']'! !

!MessageBrowser methodsFor: 'protocol' stamp: ''!
title: aString

	titleHolder contents: aString.! !

!MessageBrowser methodsFor: 'accessing' stamp: ''!
toolbarModel
	
	^ toolbarModel! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/14/2012 10:06'!
topologicSort
	
	^ topologicSortHolder contents! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/14/2012 10:07'!
topologicSort: aBoolean
	
	^ topologicSortHolder contents: aBoolean! !

!MessageBrowser methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 6/14/2012 11:47'!
whenSelectedItemChanged: aBlock 

	listModel whenSelectedItemChanged: aBlock ! !

!MessageBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/18/2012 15:58'!
wrapItem: anItem
	| s |
	
	s :=String streamContents: [:t | 
		3 to: (cachedHierarchy at: anItem) size do: [:i | t << '    '].
		t << anItem methodClass name<< ' ('<< (anItem category ifNil: ['']) <<')'].
	
	^ {s. anItem selector}.! !

ComposableModel subclass: #MethodBrowser
	instanceVariableNames: 'listModel textModel toolbarModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples-PolyWidgets'!

!MethodBrowser commentStamp: '<historical>' prior: 0!
A MethodBrowser is a simple browser using Spec to display a list of methods and their source code

	si := MethodBrowser new.
	si openWithSpec.
	si methods: Object methodDict values!

!MethodBrowser class methodsFor: 'specs' stamp: 'bvr 6/4/2012 17:24'!
defaultSpec

	^{ #ComposableSpec.
			#add:. {{#model. #listModel}.
											#layout:. {#FrameLayout.
												#fractions:offsets:. 	(0@0 corner: 1@0.5).	(0@0 corner: 0@(-15)). }}.
			#add:. {{#model. #toolbarModel}.
											#layout:. {#FrameLayout.
												#fractions:offsets:. 	(0@0.5 corner: 1@0.5).	(0@(-15) corner: 0@15). }}.															
			#add:. {{#model. #textModel}.
											#layout:. {#FrameLayout.
												#fractions:offsets:. 	(0@0.5 corner: 1@1).	(0@15 corner: 0@0). }}.}! !

!MethodBrowser class methodsFor: 'specs' stamp: 'bvr 6/4/2012 17:27'!
defaultSpec2
^{ #Panel.
		#changeTableLayout.
		#listDirection:. 	#bottomToTop.
		#addMorph:. 		{#model. #listModel.}.
		#addMorph:. 		{#model. #textModel.}.
		#vResizing:.		 #spaceFill.
		#hResizing:.		 #spaceFill.}! !

!MethodBrowser class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 1/16/2012 23:18'!
example

	| mb |
	mb := MethodBrowser new.
	mb openWithSpec.
	mb methods: Object methodDict values! !

!MethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/31/2012 13:36'!
title

	^ 'Method Browser'! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2012 19:35'!
acceptBlock: aBlock

	textModel acceptBlock: aBlock! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:42'!
action

	^ textModel actionToPerformHolder content! !

!MethodBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/12/2012 19:32'!
displayBlock: aBlock

	listModel displayBlock: aBlock! !

!MethodBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:33'!
initializePresenter

	listModel whenSelectedItemChanged: [:selection |
		selection
			ifNil: [
				textModel text: ''.
				textModel behavior: nil.
				toolbarModel method: nil ]
			ifNotNil: [:m | 
				textModel text: m sourceCode.
				textModel behavior: m methodClass.
				toolbarModel method: m ]].
	
	self acceptBlock: [:t | self listModel selectedItem inspect ].
	self wrapWith: [:item | item methodClass name,'>>#', item selector ].! !

!MethodBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:33'!
initializeWidgets

	self instantiateModels: #(
		listModel ListComposableModel
		textModel TextModel
		toolbarModel MethodToolbar ).
	
	self focusOrder
		add: listModel;
		add: toolbarModel;
		add: textModel.
	
	textModel aboutToStyle: true.! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 14:51'!
listModel

	^ listModel! !

!MethodBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/31/2012 13:10'!
methods: aList

	"Here I reroute my entry point to the list model's entry point"
	self listModel items: aList! !

!MethodBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/13/2012 16:24'!
sortingBlock: aBlock 

	listModel sortingBlock: aBlock ! !

!MethodBrowser methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/17/2012 03:16'!
takeKeyboardFocus

	^ self listModel takeKeyboardFocus! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 14:51'!
textModel

	^ textModel! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2012 01:58'!
toolbarModel

	^ toolbarModel! !

!MethodBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 20:46'!
wrapWith: aBlock

	listModel displayBlock: aBlock! !

ComposableModel subclass: #MethodToolbar
	instanceVariableNames: 'methodHolder browseModel sendersModel implementorsModel versionModel dropListModel model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets-PolyWidgets'!

!MethodToolbar commentStamp: '<historical>' prior: 0!
A MethodToolbar is xxxxxxxxx.

b := MethodToolbar new.
b openWithSpec.
b method: (ButtonModel>>#state:).
b method: nil!

!MethodToolbar class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:50'!
defaultSpec
	<spec>
	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#browseModel.}.
			#addMorph:. {#model.	#sendersModel.}.
			#addMorph:. {#model.	#implementorsModel.}.
			#addMorph:. {#model.	#versionModel.	}.
			#addMorph:. {#model.	#dropListModel.}.
			#hResizing:.	#spaceFill.
			#vResizing:.	#shrinkWrap.	}! !

!MethodToolbar class methodsFor: 'specs' stamp: ''!
title

	^ 'Toolbar'! !

!MethodToolbar methodsFor: 'private' stamp: ''!
addAll: aWindow  withSpec: aSpec

	aWindow
		addMorph: (self buildWithSpec: aSpec)
		fullFrame: (LayoutFrame 
			fractions: (0@0 corner: 1@0) 
			offsets: (0@0 corner: 0@30)).! !

!MethodToolbar methodsFor: 'private' stamp: ''!
browseMethod

	methodHolder contents
		ifNotNil: [:aMethod | aMethod browse ]! !

!MethodToolbar methodsFor: 'accessing' stamp: ''!
browseModel

	^ browseModel! !

!MethodToolbar methodsFor: 'accessing' stamp: ''!
dropListModel

	^ dropListModel! !

!MethodToolbar methodsFor: 'private' stamp: ''!
implementorsMethod

	methodHolder contents
		ifNotNil: [:aMethod | self model browseMessagesFrom: aMethod selector ]! !

!MethodToolbar methodsFor: 'accessing' stamp: ''!
implementorsModel

	^ implementorsModel! !

!MethodToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:00'!
initialize
	"Initialization code for MethodToolbar"

	methodHolder := nil asValueHolder.
	model := AbstractTool new.
	
	super initialize.! !

!MethodToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:00'!
initializeWidgets
	
	self instantiateModels: #(
		browseModel  			ButtonModel
		sendersModel  			ButtonModel
		implementorsModel  	ButtonModel
		versionModel  			ButtonModel
		dropListModel  		DropListModel ).
				
	self 
		setFocusOrder;
		setBrowseModel;
		setVersionModel;
		setSendersModel;
		setImplementorsModel
! !

!MethodToolbar methodsFor: 'protocol' stamp: ''!
method: aMethod

	methodHolder contents: aMethod! !

!MethodToolbar methodsFor: 'accessing' stamp: ''!
model

	^ model! !

!MethodToolbar methodsFor: 'initialization' stamp: ''!
registerForChanges

	methodHolder whenChangedDo: [:contents || boolean |
		boolean := contents
						ifNil: [ false ]
						ifNotNil: [ true ].
		browseModel state: boolean.
		sendersModel state: boolean.
		versionModel state: boolean.
		implementorsModel state: boolean]! !

!MethodToolbar methodsFor: 'private' stamp: ''!
sendersMethod

	methodHolder contents
		ifNotNil: [:aMethod | self model browseSendersOfMessagesFrom: aMethod selector ]! !

!MethodToolbar methodsFor: 'accessing' stamp: ''!
sendersModel

	^ sendersModel! !

!MethodToolbar methodsFor: 'initialization' stamp: ''!
setBrowseModel
	
	browseModel
		state: false;
		label: 'Browse';
		action: [ self browseMethod ].
	
! !

!MethodToolbar methodsFor: 'protocol' stamp: ''!
setDropListItems: aCollection

	dropListModel items: aCollection! !

!MethodToolbar methodsFor: 'initialization' stamp: ''!
setFocusOrder

	self focusOrder
		add: browseModel;
		add: sendersModel;
		add: implementorsModel;
		add: versionModel.
		! !

!MethodToolbar methodsFor: 'initialization' stamp: ''!
setImplementorsModel
	
	implementorsModel
		state: false;
		label: 'Implementors';
		action: [ self implementorsMethod ].
	
! !

!MethodToolbar methodsFor: 'initialization' stamp: ''!
setSendersModel
	
	sendersModel
		state: false;
		label: 'Senders';
		action: [ self sendersMethod ].
	
! !

!MethodToolbar methodsFor: 'initialization' stamp: ''!
setVersionModel
	
	versionModel
		state: false;
		label: 'Version';
		action: [ self versionMethod ].
	
! !

!MethodToolbar methodsFor: 'private' stamp: ''!
versionMethod

	methodHolder contents
		ifNotNil: [:aMethod | self model browseVersionsFrom: aMethod ]! !

!MethodToolbar methodsFor: 'accessing' stamp: ''!
versionModel

	^ versionModel! !

ComposableModel subclass: #MonticelloRepositoryBrowser
	instanceVariableNames: 'repositories workingCopies order'
	classVariableNames: 'Order'
	poolDictionaries: ''
	category: 'Spec-Tools-Monticello'!

!MonticelloRepositoryBrowser commentStamp: '<historical>' prior: 0!
MonticelloRepositoryBrowser example!

!MonticelloRepositoryBrowser class methodsFor: 'utils' stamp: 'StephaneDucasse 6/2/2012 20:29'!
allManagers 

	^ MCWorkingCopy allManagers ! !

!MonticelloRepositoryBrowser class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:51'!
defaultSpec

	^ {
		#ComposableSpec.
			#add: . {{#model . #workingCopies} . 
					#layout: . { #FrameLayout . #fractions:. 0@0 corner: 0.5@1.} 
					} . 
			#add: . {{#model . #repositories } . 
					#layout: . { #FrameLayout . #fractions:. 0.5@0 corner: 1@1.} 
					}
		}! !

!MonticelloRepositoryBrowser class methodsFor: 'example' stamp: 'StephaneDucasse 6/2/2012 20:29'!
example
	"self example"
	
	self new 
		openWithSpec ; 
		workingCopies: (self allManagers)! !

!MonticelloRepositoryBrowser class methodsFor: 'utils' stamp: 'StephaneDucasse 4/17/2012 18:41'!
order
	^ Order ifNil: [ Order := 1 ]! !

!MonticelloRepositoryBrowser class methodsFor: 'utils' stamp: 'StephaneDucasse 4/17/2012 18:42'!
order: anInteger
	Order := anInteger! !

!MonticelloRepositoryBrowser class methodsFor: 'spec' stamp: 'StephaneDucasse 4/17/2012 18:07'!
title

	^ 'Monticello Browser'! !

!MonticelloRepositoryBrowser methodsFor: 'accessing' stamp: 'StephaneDucasse 6/2/2012 20:29'!
allManagers

	^ self class allManagers 
	! !

!MonticelloRepositoryBrowser methodsFor: 'private' stamp: 'StephaneDucasse 4/17/2012 18:31'!
allRepositories

	^ MCRepositoryGroup default repositories! !

!MonticelloRepositoryBrowser methodsFor: 'actions' stamp: 'StephaneDucasse 4/19/2012 18:20'!
browseWorkingCopy
	| workingCopy |
	workingCopy := self workingCopy.
	workingCopy
		ifNotNil: [ 
			(MCSnapshotBrowser forSnapshot: workingCopy completeSnapshot)
				label: 'Snapshot Browser: ' , workingCopy packageName;
				show ]! !

!MonticelloRepositoryBrowser methodsFor: 'private' stamp: 'StephaneDucasse 4/17/2012 19:11'!
defaultOrderingBlock

	^ (self orderSpecs at: self class order) value! !

!MonticelloRepositoryBrowser methodsFor: 'initialize' stamp: 'StephaneDucasse 4/17/2012 18:06'!
initialExtent

	^ 600@200! !

!MonticelloRepositoryBrowser methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:41'!
initialize
	"Initialization code for MonticelloRepositoryBrowser"

	super initialize.
	order := self class order! !

!MonticelloRepositoryBrowser methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:41'!
initializePresenter

	workingCopies whenSelectedItemChanged: 
			[ :item | repositories items: (self repositoriesOfWorkingCopy: item) ].! !

!MonticelloRepositoryBrowser methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:41'!
initializeWidgets

	self instantiateModels: #(
		repositories  ListComposableModel
		workingCopies  ListComposableModel).
		
	workingCopies sortingBlock: self defaultOrderingBlock.
	workingCopies displayBlock: [ :item | item description ].
	workingCopies menu: [ :aMenu | self workingCopiesMenu: aMenu ].
		
	repositories displayBlock: [ :item | item description ].
	repositories items: self allRepositories.

	"so that when we tab we go from working copies to repositories"
	self focusOrder
		add: workingCopies;
		add: repositories! !

!MonticelloRepositoryBrowser methodsFor: 'actions' stamp: 'StephaneDucasse 4/19/2012 18:21'!
newRepository
	| types index |
	types := MCRepository allConcreteSubclasses asArray.
	index := UIManager default chooseFrom: (types collect: [:ea | ea description])
				title: 'Repository type:'.
	^ index = 0 ifFalse: [(types at: index) morphicConfigure]! !

!MonticelloRepositoryBrowser methodsFor: 'actions' stamp: 'StephaneDucasse 4/19/2012 18:19'!
openRepository
	self repository ifNotNil: [:repos | repos morphicOpen: self workingCopy ]! !

!MonticelloRepositoryBrowser methodsFor: 'menu' stamp: 'StephaneDucasse 4/17/2012 18:49'!
order

	^ order! !

!MonticelloRepositoryBrowser methodsFor: 'menu' stamp: 'SD 4/19/2012 16:16'!
order: anInteger

	order := anInteger.
	self workingCopies sortingBlock: (self orderSpecs at: order) value.
	self order = 4 "dirty only"
		ifTrue: [self workingCopies filteringBlock: [:col | col select: #modified]]
		ifFalse: [self workingCopies resetFilteringBlock]. ! !

!MonticelloRepositoryBrowser methodsFor: 'menu' stamp: 'StephaneDucasse 4/17/2012 18:35'!
orderSpecs
	^ {
		'Sort alphabetically' -> [ :a :b | a package name <= b package name ].
		'Sort dirty first' -> [ :a :b | 
			a needsSaving = b needsSaving
				ifTrue: [ a package name <= b package name ]
				ifFalse: [ a needsSaving ] ].
		'Sort dirty last' -> [ :a :b | 
			a needsSaving = b needsSaving
				ifTrue: [ a package name <= b package name ]
				ifFalse: [ b needsSaving ] ].
		'Only dirty' -> [ :a :b | a package name <= b package name ]}! !

!MonticelloRepositoryBrowser methodsFor: 'menu' stamp: 'StephaneDucasse 4/17/2012 18:48'!
orderString: anIndex
	^ String streamContents: [ :stream |
		order = anIndex
			ifTrue: [ stream nextPutAll: '<yes>' ]
			ifFalse: [ stream nextPutAll: '<no>' ].
		stream nextPutAll: (self orderSpecs at: anIndex) key ]! !

!MonticelloRepositoryBrowser methodsFor: 'accessing' stamp: 'StephaneDucasse 4/17/2012 18:04'!
repositories

	^ repositories! !

!MonticelloRepositoryBrowser methodsFor: 'private' stamp: 'StephaneDucasse 4/17/2012 18:20'!
repositoriesOfWorkingCopy: aWorkingCopy
	
	^ aWorkingCopy isNil
		ifFalse: [ aWorkingCopy repositoryGroup repositories]
		ifTrue: [ self allRepositories]	! !

!MonticelloRepositoryBrowser methodsFor: 'accessing' stamp: 'StephaneDucasse 4/17/2012 18:04'!
workingCopies

	^ workingCopies! !

!MonticelloRepositoryBrowser methodsFor: 'protocol' stamp: 'SD 4/19/2012 16:12'!
workingCopies: aCollection
	"Set the value of the list widget"
	
	workingCopies items: aCollection ! !

!MonticelloRepositoryBrowser methodsFor: 'menu' stamp: 'StephaneDucasse 6/2/2012 20:29'!
workingCopiesFromMC
	^ (self orderSpecs size = order
		ifTrue: [ self allManagers select: [ :each | each modified ] ]
		ifFalse: [ self allManagers ])
			asSortedCollection: (self orderSpecs at: order) value.! !

!MonticelloRepositoryBrowser methodsFor: 'menu' stamp: 'StephaneDucasse 4/19/2012 18:17'!
workingCopiesMenu: aMenu


	aMenu target: self;
		add: 'Browse working copy' action: #browseWorkingCopy.

	1 to: self orderSpecs size do: [ :index | 
		aMenu
			addUpdating: #orderString:
			target: self
			selector: #order:
			argumentList: {index} ].
	^ aMenu! !

!MonticelloRepositoryBrowser methodsFor: 'accessing' stamp: 'StephaneDucasse 4/19/2012 18:20'!
workingCopy
	^ workingCopies selectedItem! !

ComposableModel subclass: #OkToolbar
	instanceVariableNames: 'okButton okAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets-PolyWidgets'!

!OkToolbar commentStamp: '<historical>' prior: 0!
An OkCancelToolbar is a model for a basic Ok toolbar!

OkToolbar subclass: #OkCancelToolbar
	instanceVariableNames: 'cancelButton cancelAction cancelled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets-PolyWidgets'!

!OkCancelToolbar commentStamp: '<historical>' prior: 0!
An OkCancelToolbar is a model for a basic Ok-Cancel toolbar!

!OkCancelToolbar class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:51'!
defaultSpec
	<spec>
	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#add:. {#model.	#hFill}.
			#add:. {#model.	#hFill}.
			#add:. {#model.	#hFill}.
			#add:. {#model.	#hFill}.
			#add:. {#model.	#hFill}.
			#add:. {#model.	#hFill}.
			#add:. {#model.	#okButton.	}.
			#add:. {#model.	#cancelButton.}.
			#hSpaceFill.
			#vShrinkWrap.	}! !

!OkCancelToolbar class methodsFor: 'specs' stamp: ''!
title

	^ 'Ok Cancel'! !

!OkCancelToolbar methodsFor: 'protocol' stamp: ''!
cancelAction

	^ cancelAction contents! !

!OkCancelToolbar methodsFor: 'protocol' stamp: ''!
cancelAction: aBlock

	^ cancelAction contents: aBlock! !

!OkCancelToolbar methodsFor: 'accessing' stamp: ''!
cancelButton

	^ cancelButton! !

!OkCancelToolbar methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/11/2012 18:32'!
cancelled

	^ cancelled contents! !

!OkCancelToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:03'!
initialize
	"Initialization code for OkCancelToolbar"

	cancelled := false asValueHolder.
	cancelAction := [ true ] asValueHolder.
	super initialize.! !

!OkCancelToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:03'!
initializePresenter 

	super initializePresenter.
	cancelButton 
		action: [
			cancelAction contents value == false
					ifFalse: [
						cancelled contents: true.
						owner 
							ifNil: [ self delete ]
							ifNotNil: [ owner delete ]]].! !

!OkCancelToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:07'!
initializeWidgets

	super initializeWidgets.
	self instantiateModels: #( cancelButton ButtonModel ).

	self registerCancelButtonEvents.
	self focusOrder
		add: cancelButton! !

!OkCancelToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:03'!
registerCancelButtonEvents

	cancelButton 
		label: 'Cancel';
		enabled: true;
		state: false! !

!OkToolbar class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:51'!
defaultSpec
	<spec>
	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#add:. {#model.	#hFill}.
			#add:. {#model.	#hFill}.
			#add:. {#model.	#hFill}.
			#add:. {#model.	#hFill}.
			#add:. {#model.	#hFill}.
			#add:. {#model.	#hFill}.
			#add:. {#model.	#hFill}.
			#add:. {#model.	#hFill}.
			#add:. {#model.	#hFill}.
			#add:. {#model.	#okButton.}.
			#hSpaceFill.
			#vShrinkWrap.	}! !

!OkToolbar class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 5/10/2012 13:07'!
title

	^ 'Ok Toolbar'! !

!OkToolbar methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/10/2012 13:05'!
addAll: aWindow  withSpec: aSpec

	aWindow
		addMorph: (self buildWithSpec: aSpec)
		fullFrame: (LayoutFrame 
			fractions: (0@0 corner: 1@0) 
			offsets: (0@0 corner: 0@30)).! !

!OkToolbar methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/10/2012 13:05'!
hFill

	^ Morph new
		color: Color transparent;
		height: 0;
		vResizing: #rigid;
		hResizing: #spaceFill! !

!OkToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/11/2012 10:31'!
initialize
	"Initialization code for OkCancelToolbar"

	super initialize.
	okAction := [ true ] asValueHolder.! !

!OkToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:01'!
initializePresenter 

	okButton 
		action: [ 
				okAction contents value == false
					ifFalse: [
						owner 
							ifNil: [ self delete ]
							ifNotNil: [ owner delete ]]].! !

!OkToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:02'!
initializeWidgets
	
	
	self instantiateModels:  #( okButton ButtonModel ).
	self registerOkButtonEvents.
	
	self focusOrder
		add: okButton! !

!OkToolbar methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/10/2012 13:05'!
okAction

	^ okAction contents! !

!OkToolbar methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/10/2012 13:05'!
okAction: aBlock

	^ okAction contents: aBlock! !

!OkToolbar methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2012 13:05'!
okButton

	^ okButton! !

!OkToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:01'!
registerOkButtonEvents

	okButton 
		label: 'Ok';
		enabled: true;
		state: false! !

ComposableModel subclass: #PickListModel
	instanceVariableNames: 'defaultValueHolder labelClickableHolder listModel pickedItemsHolder wrapHolder associationsItemToWrapper associationsWrapperToItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets-PolyWidgets'!

!PickListModel commentStamp: '<historical>' prior: 0!
A PickList is a tick list done using spec.!

!PickListModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 6/12/2012 18:32'!
defaultSpec
	<spec>
	
	^ SpecLayout composed 
		add: #listModel;
		yourself! !

!PickListModel class methodsFor: 'example' stamp: ''!
example
	"self example"
	| instance |
	
	instance := self new.
	instance openWithSpec.
	instance items: { {1. 2. 4}. 'Foo'. 123}! !

!PickListModel class methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 2/28/2012 14:17'!
possibleEvents

	^ #(whenListChanges whenSelectionChanges whenSelectedItemChanges whenSelectedIndexChanges whenPickeItemsChanges)! !

!PickListModel class methodsFor: 'specs' stamp: ''!
title

	^ 'Pick List Example'! !

!PickListModel methodsFor: 'private' stamp: ''!
addPicked: item

	pickedItemsHolder contents add: item.
	pickedItemsHolder contentsChanged: true to: item.! !

!PickListModel methodsFor: 'protocol' stamp: ''!
checkboxFor: anItem

	^ associationsItemToWrapper at: anItem ifAbsent: [ nil ]! !

!PickListModel methodsFor: 'protocol' stamp: ''!
defaultValue

	^ defaultValueHolder contents! !

!PickListModel methodsFor: 'protocol' stamp: ''!
defaultValue: aBoolean

	defaultValueHolder contents: aBoolean! !

!PickListModel methodsFor: 'protocol' stamp: 'bvr 6/2/2012 12:44'!
displayBlock: aBlock

	wrapHolder contents: aBlock! !

!PickListModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:05'!
initialize
	"Initialization code for PickList"

	wrapHolder := [ :i | i printString ] asValueHolder. 
	pickedItemsHolder := Set new asValueHolder.
	associationsWrapperToItem := Dictionary new asValueHolder.
	associationsItemToWrapper := Dictionary new asValueHolder.
	labelClickableHolder := true asValueHolder.
	defaultValueHolder := false asValueHolder.
	
	super initialize.! !

!PickListModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:05'!
initializePresenter
	
	listModel whenListChanged: [ self focusOrder removeAll ].
	labelClickableHolder whenChangedDo: [:aBoolean | 
		associationsWrapperToItem keys do: [:e | e labelClickable: aBoolean ]].

	defaultValueHolder whenChangedDo: [:value | associationsWrapperToItem keysDo: [:cb | cb state: value ]].! !

!PickListModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:05'!
initializeWidgets
	
	self instantiateModels: #( listModel ListComposableModel ).
	listModel displayBlock: [ :item | item ].
	! !

!PickListModel methodsFor: 'protocol' stamp: ''!
itemFor: aCheckbox

	^ associationsWrapperToItem at: aCheckbox ifAbsent: [ nil ]! !

!PickListModel methodsFor: 'protocol' stamp: ''!
items: aCollection

	associationsWrapperToItem removeAll.
	pickedItemsHolder contents removeAll.
	pickedItemsHolder contentsChanged: false to: nil.
	listModel items: (aCollection collect: [:e | self wrap: e ]).! !

!PickListModel methodsFor: 'protocol' stamp: ''!
labelClickable
	
	^ labelClickableHolder contents! !

!PickListModel methodsFor: 'protocol' stamp: ''!
labelClickable: aBoolean

	labelClickableHolder contents: aBoolean! !

!PickListModel methodsFor: 'accessing' stamp: ''!
listModel

	^ listModel! !

!PickListModel methodsFor: 'protocol' stamp: ''!
pickedItems

	^ pickedItemsHolder contents! !

!PickListModel methodsFor: 'private' stamp: ''!
removePicked: item

	pickedItemsHolder contents remove: item ifAbsent: [ ^ self ].
	pickedItemsHolder contentsChanged: false to: item.! !

!PickListModel methodsFor: 'protocol' stamp: ''!
resetSelection

	listModel resetSelection! !

!PickListModel methodsFor: 'protocol' stamp: ''!
selectedIndex

	^ listModel selectedIndex! !

!PickListModel methodsFor: 'protocol' stamp: ''!
selectedItem

	^ associationsWrapperToItem 
		at: listModel selectedItem
		ifAbsent: [ nil ]! !

!PickListModel methodsFor: 'protocol-events' stamp: 'bvr 5/31/2012 13:34'!
whenListChanged: aBlock

	listModel whenListChanged: aBlock! !

!PickListModel methodsFor: 'protocol-events' stamp: 'bvr 5/31/2012 13:34'!
whenPickedItemsChanged: aBlock

	pickedItemsHolder whenChangedDo: aBlock! !

!PickListModel methodsFor: 'protocol-events' stamp: 'bvr 5/31/2012 13:34'!
whenSelectedItemChanged: aBlock
	| newBlock |
	
	newBlock := [ :item | aBlock cull: (associationsWrapperToItem at: item ifAbsent: [ nil ])].
	listModel whenSelectedItemChanged: newBlock! !

!PickListModel methodsFor: 'protocol-events' stamp: 'StephaneDucasse 5/17/2012 19:32'!
whenSelectionChanged: aBlock

	listModel whenSelectionChanged: aBlock! !

!PickListModel methodsFor: 'protocol-events' stamp: 'bvr 5/31/2012 13:34'!
whenSelectionIndexChanged: aBlock

	listModel whenSelectionIndexChanged: aBlock! !

!PickListModel methodsFor: 'private' stamp: 'StephaneDucasse 5/17/2012 18:14'!
wrap: item
	| checkBox |

	associationsItemToWrapper 
		at: item
		ifPresent: [:cb | ^ cb ].

	checkBox := self instantiate: CheckBoxModel.
	checkBox label: (wrapHolder contents cull: item cull: self).
	checkBox whenActivatedDo: [ 
		self addPicked: item.
		listModel setSelectedItem: checkBox.
		listModel takeKeyboardFocus ].
	checkBox whenDesactivatedDo: [ 
		self removePicked: item.
		listModel setSelectedItem: checkBox.
		listModel takeKeyboardFocus ].
	checkBox 
		state: self defaultValue;
		labelClickable: self labelClickable.
	associationsWrapperToItem at: checkBox put: item.
	associationsItemToWrapper at: item put: checkBox.
	^ checkBox! !

!PickListModel methodsFor: 'accessing' stamp: ''!
wrapHolder

	^ wrapHolder! !

ComposableModel subclass: #RadioButtonGroupExample
	instanceVariableNames: 'button1 button2 button3 container morph1 morph2 morph3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples-Widgets'!

!RadioButtonGroupExample commentStamp: '<historical>' prior: 0!
A RadioButtonGroupExample is an simple example about how to use RadioButtons and RadioGroup!

!RadioButtonGroupExample class methodsFor: 'specs' stamp: 'bvr 6/4/2012 17:24'!
defaultSpec

	^ { #Panel.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		self topSpec.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	(0@0 corner: 1@0).	(0@0 corner: 0@20). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #container.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0 corner: 1@1).	(0@22 corner: 0@0). }}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!RadioButtonGroupExample class methodsFor: 'specs' stamp: 'bvr 6/4/2012 17:27'!
defaultSpec2

	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#button1.}.
			#addMorph:. {#model.	#button2.}.
			#addMorph:. {#model.	#button3.}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!RadioButtonGroupExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/1/2012 17:51'!
title

	^ 'Radio Button Group Example'! !

!RadioButtonGroupExample class methodsFor: 'specs' stamp: 'bvr 6/4/2012 17:21'!
topSpec

	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#button1.}.
			#addMorph:. {#model.	#button2.}.
			#addMorph:. {#model.	#button3.}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!RadioButtonGroupExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 17:52'!
button1

	^ button1! !

!RadioButtonGroupExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 17:52'!
button2

	^ button2! !

!RadioButtonGroupExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 17:52'!
button3

	^ button3! !

!RadioButtonGroupExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 00:39'!
container

	^ container! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:30'!
initialize
	"Initialization code for RadioButtonGroupExample"

	super initialize.

	container := PanelMorph new.
	container
		changeTableLayout;
		listDirection: #bottomToLeft.
	
	self instantiateMorphs.! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:29'!
initializePresenter

	self setActions.
	! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:29'!
initializeWidgets
	"Initialization code for RadioButtonGroupExample"

	self instantiateModels: #(
		button1 RadioButtonModel
		button2 RadioButtonModel
		button3 RadioButtonModel ).
	
	button1 label: 'Button 1'.
	button2 label: 'Button 2'.
	button3 label: 'Button 3'.
	
	self setFocus.
	self setGroup.
	! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:29'!
instantiateButtons

	! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:00'!
instantiateMorphs

	morph1 := Morph new
					color: Color red;
					width: 60;
					height: 20.
	morph2 := Morph new
					color: Color blue;
					width: 20;
					height: 60.
	morph3 := Morph new
					color: Color green;
					width: 50;
					height: 50.! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:50'!
setActions

	self setActionsForButton1.
	self setActionsForButton2.
	self setActionsForButton3.	! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:56'!
setActionsForButton1

	button1 whenActivatedDo: [ container addMorph: morph1 ].
	button1 whenDesactivatedDo: [ container removeMorph: morph1 ]! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:56'!
setActionsForButton2

	button2 whenActivatedDo: [ container addMorph: morph2 ].
	button2 whenDesactivatedDo: [ container removeMorph: morph2 ]! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:56'!
setActionsForButton3

	button3 whenActivatedDo: [ container addMorph: morph3 ].
	button3 whenDesactivatedDo: [ container removeMorph: morph3 ]! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:47'!
setFocus
	
	self focusOrder
		add: button1;
		add: button2;
		add: button3.
	! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:49'!
setGroup

	RadioButtonGroup new 
		addRadioButton: button1;
		addRadioButton: button2;
		addRadioButton: button3;
		default: button1.
	! !

ComposableModel subclass: #STEditor
	instanceVariableNames: 'object ok text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!STEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 18:18'!
buildWithSpec

	^ self buildWithSpecLayout: self layout! !

!STEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 18:18'!
buildWithSpec: aSpec

	^ self buildWithSpecLayout: self layout! !

!STEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 18:18'!
help: aString 
	
	text help: aString ! !

!STEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/12/2012 18:18'!
initialize
	"Initialization code for BlocEditor"

	super initialize.

	object := nil asValueHolder! !

!STEditor methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/12/2012 18:25'!
initializeWidgets 

	self  instantiateModels: #( 
		text 	TextInputFieldModel
		ok 		ButtonModel ).

	text
		autoAccept: false;
		entryCompletion: nil;
		acceptBlock: [ self okAction ];
		ghostText: 'st code'.
		
	ok 
		label: 'ok';
		state: false;
		enabled: true;
		action: [ self okAction ].
		
	self focusOrder 
		add: text;
		add: ok! !

!STEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/12/2012 18:20'!
layout

	^ SpecLayout composed 
		newRow: [:r |
			r
				add: #text;
				newColumn: [:c | c add: #ok ] width: 25 ]
		 height: 25;
		yourself! !

!STEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 18:20'!
object

	^ object contents! !

!STEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 18:20'!
object: aBlock

	object contents: aBlock ! !

!STEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 18:20'!
ok

	^ ok! !

!STEditor methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/12/2012 18:19'!
okAction

	text accept.
	object contents: (Compiler evaluate: text getText).! !

!STEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 18:20'!
text
	^ text! !

!STEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 18:19'!
whenObjectChangedDo: aBlock

	object whenChangedDo: aBlock ! !

ComposableModel subclass: #SearchableList
	instanceVariableNames: 'listModel searchModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets-PolyWidgets'!

!SearchableList commentStamp: '<historical>' prior: 0!
SearchableList 
	new items: #( aaa abc axz bbb bfbg bof c);
	openWithSpec
	
should it be a subclass of LIstModel?
Because now I will have to delegate a lot? and I cannot plug a IconList

How do I make textModel react to every keystroke without an accept!

!SearchableList class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:52'!
defaultSpec

	^ {#ComposableSpec .
		#add: . {{#model . #searchModel.}.
				#layout: . {#FrameLayout . 
								#fractions:offsets: . (0@0 corner: 1@0). (0@0 corner: (0@25))}} .
		#add: . {{#model . #listModel.}.
				#layout: . {#FrameLayout . 
								#fractions:offsets: . (0@0 corner: 1@1). (0@25corner:  0@0)}}
		}! !

!SearchableList methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:06'!
initializePresenter

	searchModel whenTextChanged: [:newText || text |
		text :=  searchModel getText asLowercase.
		text isEmpty
			ifTrue: [ listModel resetFilteringBlock ]
			ifFalse: [
				listModel filteringBlock: [:col | col select: [:e | e asLowercase beginsWith: searchModel getText asLowercase ]]]]! !

!SearchableList methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:06'!
initializeWidgets

	self instantiateModels: #(	
		listModel 		ListComposableModel
		searchModel 	TextInputFieldModel ).
	searchModel 
		autoAccept: true;
		ghostText: 'filter'.! !

!SearchableList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2012 18:46'!
listModel
	^ listModel! !

!SearchableList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2012 18:46'!
searchModel
	^ searchModel! !

ComposableModel subclass: #SpecAdder
	instanceVariableNames: 'descriptionHolder fractionField fractionLabel instVars offsetField offsetLabel selectors toolbar selectedInstVar selectedSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder-Tools'!

!SpecAdder class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:53'!
defaultSpec
	<spec>
	| delta |
	delta := 25.
	^{#ComposableSpec.

			#add:.	{{#model.	#instVars.}.
								#layout:. {#LayoutFrame.
												#fractions:offsets:.	(0@0 corner: 1@0). (0@0 corner: 0@delta)}}.
			#add:.	{{#model.	#selectors.}.					
								#layout:. {#LayoutFrame.
												#fractions:offsets:.	(0@0 corner: 1@0). (0@(delta+4) corner: 0@(2*delta+4))}}.							
			#add:.	{{#model.	#fractionLabel.}.
								#layout:. {#LayoutFrame.
												#fractions:offsets:.	(0@0 corner: 1@0). (0@(2*delta+8) corner: 0@(3*delta+8))}}.
			#add:.	{{#model.	#fractionField.}.
								#layout:. {#LayoutFrame.
												#fractions:offsets:.	(0@0 corner: 1@0). (0@(3*delta+12) corner: 0@(4*delta+24))}}.
			#add:.	{{#model. 	#offsetLabel.}.
								#layout:. {#LayoutFrame.
												#fractions:offsets:.	(0@0 corner: 1@0). (0@(4*delta+28) corner: 0@(5*delta+28))}}.
			#add:.	{{#model. 	#offsetField.}.
								#layout:. {#LayoutFrame.
												#fractions:offsets:.	(0@0 corner: 1@0). (0@(5*delta+32) corner: 0@(6*delta+44))}}.		
			#add:.	{{#model.	#toolbar.}.
								#layout:. {#LayoutFrame.
												#fractions:offsets:.	(0@1 corner: 1@1). (0@(delta negated) corner: 0@0)}}}! !

!SpecAdder class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 3/2/2012 07:26'!
title

	^ 'Add a subspec'! !

!SpecAdder methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/2/2012 07:37'!
addInstVar: name spec: specName fraction: fraction offset: offset

	| spec f o |
	f := self class compilerClass evaluate: fraction.
	o := self class compilerClass evaluate: offset.

	spec := descriptionHolder contents specDescription.
	spec addInstVar: name spec: specName fraction: f offset: o! !

!SpecAdder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/2/2012 07:10'!
description: aDescription

	descriptionHolder contents: aDescription.! !

!SpecAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 07:19'!
fractionField
	^ fractionField! !

!SpecAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 07:19'!
fractionLabel
	^ fractionLabel! !

!SpecAdder methodsFor: 'display' stamp: 'BenjaminVanRyseghem 3/29/2012 11:49'!
initialExtent

	^  (400@250)! !

!SpecAdder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:09'!
initialize
	"Initialization code for SpecAdder"

	descriptionHolder := nil asValueHolder.
	selectedInstVar := nil.
	selectedSpec := nil.
	super initialize.! !

!SpecAdder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:04'!
initializePresenter

	self registerDescriptionEvents.
	self setOkAction! !

!SpecAdder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:04'!
initializeWidgets

	self instantiateModels: #(
		fractionField TextInputFieldModel
		fractionLabel LabelModel
		instVars DropListModel
		offsetField TextInputFieldModel
		offsetLabel LabelModel
		selectors DropListModel
		toolbar OkCancelToolbar).
	
	self setFieldsAndLabels.! !

!SpecAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 07:19'!
instVars
	^ instVars! !

!SpecAdder methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/29/2012 16:24'!
modifyAdd: anAdd

	| fractions name spec offsets |

	name := instVars selectedItem asString.
	spec := selectors selectedItem asString.
	fractions := self class compilerClass evaluate:  fractionField getText.
	offsets := self class compilerClass evaluate: offsetField getText.
	
	anAdd second first at: 2 put: name.
	anAdd second first at: 3 put: spec.
	anAdd second third at: 3 put: fractions.
	anAdd second third at: 4 put: offsets.! !

!SpecAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 07:19'!
offsetField
	^ offsetField! !

!SpecAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 07:19'!
offsetLabel
	^ offsetLabel! !

!SpecAdder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/2/2012 07:38'!
registerDescriptionEvents
	descriptionHolder
		whenChangedDo: [ :desc | 
			| items |
			instVars
				items: (desc addInstVarDescriptions collect: [ :e | DropListItem named: e name do: [ selectedInstVar := e ] ]).
			selectors
				items: (selectedInstVar type specSelectors collect: [ :e | DropListItem named: e do: [ selectedSpec := e ] ]) ]! !

!SpecAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 07:19'!
selectors
	^ selectors! !

!SpecAdder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/2/2012 07:39'!
setFieldsAndLabels
	offsetLabel text: 'Offset'.
	fractionLabel text: 'Fractions'.
	offsetField
		ghostText: 'offset';
		autoAccept: true;
		text: '0@0 corner: 0@0'.
	fractionField
		ghostText: 'fraction';
		autoAccept: true;
		text: '0@0 corner: 1@1'! !

!SpecAdder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/2/2012 07:38'!
setOkAction
	toolbar
		okAction: [ 
			(fractionField getText isEmptyOrNil or: [ offsetField getText isEmptyOrNil ])
				ifFalse: [ 
					self
						addInstVar: selectedInstVar name
						spec: selectedSpec
						fraction: fractionField getText
						offset: offsetField getText ] ]! !

!SpecAdder methodsFor: 'importing' stamp: 'BenjaminVanRyseghem 3/29/2012 16:15'!
showFor: anAdd
	"for now an add is badly an array, I should introduce a real object here"
	| fractions name spec offsets |

	name := anAdd second first second asString.
	spec := anAdd second first third asString.
	fractions := anAdd second third third.
	offsets := anAdd second third fourth.
	
	fractionField text: fractions asString.
	offsetField text: offsets asString.
	instVars setSelectedItem: name.
	selectors setSelectedItem: spec.
	
	toolbar okAction: [ self modifyAdd: anAdd ]! !

!SpecAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 07:19'!
toolbar
	^ toolbar! !

ComposableModel subclass: #SpecSetter
	instanceVariableNames: 'descriptionHolder list addButton removeButton toolbar editButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder-Tools'!

!SpecSetter class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:54'!
defaultSpec
	<spec>
	| delta |
	delta := 25.
	^{ #ComposableSpec.
				#add:.	{{#model. #list.}.
									#layout:. 	{#LayoutFrame.
														#fractions:offsets:.	 (0@0 corner: 1@1).	(0@0 corner: 0@(2*delta negated)). }}.
			#add:.	{{#model. #addButton.}.
									#layout:. 	{#LayoutFrame.
														#fractions:offsets:.	 (0@1 corner: 0.33@1).	(0@(2*delta negated) corner: 0@(delta negated)). }}.
																		
			#add:.	{{#model. #editButton.}.
									#layout:. 	{#LayoutFrame.
														#fractions:offsets:.	 (0.33@1 corner: 0.66@1).	(0@(2*delta negated) corner: 0@(delta negated)). }}.																													
			#add:.	{{#model. #removeButton.}.
									#layout:. 	{#LayoutFrame.
														#fractions:offsets:.	 (0.66@1 corner: 1@1).	(0@(2*delta negated) corner: 0@(delta negated)). }}.															
			#add:.	{{#model. #toolbar.}.
											#layout:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@1 corner: 1@1).	(0@(delta negated) corner: 0@0). }}}! !

!SpecSetter class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 3/2/2012 23:49'!
title

	^ 'Subspecs'! !

!SpecSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 23:04'!
addButton
	^ addButton! !

!SpecSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/30/2012 17:35'!
description: aDescription

	descriptionHolder contents: aDescription.
	! !

!SpecSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 23:04'!
descriptionHolder
	^ descriptionHolder! !

!SpecSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/29/2012 13:14'!
editButton
	^ editButton! !

!SpecSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:09'!
initialize
	"Initialization code for SpecSetter"

	descriptionHolder := nil asValueHolder.
	super initialize.! !

!SpecSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:06'!
initializePresenter
	
	addButton action: [ | sa |
			sa := SpecAdder new.
			
			sa description: descriptionHolder contents.
			sa openWithSpec. ].
	
	editButton action: [ | sa |
			sa := SpecAdder new.
			sa openWithSpec.
			sa description: descriptionHolder contents.
			sa showFor: list selectedItem ].
		
	removeButton action: [ self remove ].	
	
	descriptionHolder whenChangedDo: [:desc | list items: desc specDescription adds.
		desc specDescription addsHolder whenChangedDo: [:items | list items: items ] ].! !

!SpecSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:05'!
initializeWidgets

	self instantiateModels: #(
		addButton ButtonModel
		list ListComposableModel
		removeButton ButtonModel
		toolbar OkCancelToolbar
		editButton ButtonModel ).
	
	addButton label: '+'.		
	editButton label: 'Edit'.
	removeButton label: '-'.
		
	list displayBlock: [:e | e second first second ].! !

!SpecSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 23:04'!
list
	^ list! !

!SpecSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/29/2012 13:11'!
remove

	descriptionHolder contents specDescription adds remove: list selectedItem ifAbsent: [ ].
	list items: descriptionHolder contents specDescription adds! !

!SpecSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 23:04'!
removeButton
	^ removeButton! !

!SpecSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 23:04'!
toolbar
	^ toolbar! !

ComposableModel subclass: #TestingComposableModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tests'!

!TestingComposableModel commentStamp: '<historical>' prior: 0!
A TestingComposableModel is a stupid composable model used to test SpecInterpreter!

!TestingComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 6/14/2012 11:44'!
defaultSpec
	<spec>

	^ SpecLayout list
		send: #model: withArguments: {#model};
		yourself! !

!TestingComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 5/22/2012 15:05'!
testingSpec

	^ {#Text.
		#model:.	#model}.! !

!TestingComposableModel class methodsFor: 'specs' stamp: ''!
title

	^ 'You should not see me !!'! !

!TestingComposableModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2012 18:35'!
initializeWidgets ! !

ComposableModel subclass: #TextFieldExample
	instanceVariableNames: 'methodBrowser textField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples-Widgets'!

!TextFieldExample commentStamp: '<historical>' prior: 0!
A TextFieldExample is a simple example of how to use TextFields.!

!TextFieldExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 6/13/2012 16:22'!
defaultSpec
	| textFieldHeight |
	
	textFieldHeight := StandardFonts defaultFont height + 15.
	^ SpecLayout composed
	 	add: #textField origin: 0@0 corner: 1@0 offsetOrigin: 0@0 offsetCorner: 0@textFieldHeight;
	 	add: #methodBrowser origin: 0@0 corner: 1@1 offsetOrigin: 0@textFieldHeight offsetCorner: 0@textFieldHeight;
		yourself ! !

!TextFieldExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/4/2012 14:41'!
title

	^ 'Text Field Example'! !

!TextFieldExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:31'!
initializePresenter
	
	textField acceptBlock: [:text | Smalltalk globals at: text asSymbol
								ifPresent: [:class | methodBrowser methods: class methodDict values ]
								ifAbsent: [ methodBrowser methods: {} ]]! !

!TextFieldExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/13/2012 16:23'!
initializeWidgets

	self instantiateModels: #(
		methodBrowser MethodBrowser
		textField TextInputFieldModel ).
	
	textField 
		ghostText: 'Enter a class name';
		autoAccept: true;
		removeEntryCompletion.
	methodBrowser 
		sortingBlock: [:a :b | a selector < b selector ];
		displayBlock: [:m | m selector ]! !

!TextFieldExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:41'!
methodBrowser

	^ methodBrowser! !

!TextFieldExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:41'!
textField

	^ textField! !

ComposableModel subclass: #WidgetSetter
	instanceVariableNames: 'apiSetters model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

WidgetSetter subclass: #WidgetEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!WidgetSetter class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/11/2012 16:33'!
spec
	<spec>
		
	^ SpecLayout composed
		add: #apiSetters;
		yourself! !

!WidgetSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 16:32'!
apiSetters

	^ apiSetters! !

!WidgetSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/16/2012 19:41'!
buildBlockItemFor: anAPIMethod

	^ self buildItemFor: anAPIMethod kind: BlockApiSetter.! !

!WidgetSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/16/2012 19:41'!
buildBooleanItemFor: anAPIMethod

	^ self buildItemFor: anAPIMethod kind: BooleanApiSetter! !

!WidgetSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/16/2012 19:41'!
buildColorItemFor: anAPIMethod

	^ self buildItemFor: anAPIMethod kind: ColorApiSetter! !

!WidgetSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/12/2012 17:40'!
buildDoItemFor: anAPIMethod 

	^ nil! !

!WidgetSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/11/2012 17:21'!
buildEventItemFor: anAPIMethod 

	^ nil! !

!WidgetSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/11/2012 17:21'!
buildInspectItemFor: anAPIMethod 

	^ nil! !

!WidgetSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/16/2012 22:08'!
buildIntegerItemFor: anAPIMethod 
	| pragma arguments retrievingMethod item |
	
	pragma := anAPIMethod pragmas detect: [ :e | e keyword beginsWith: #api:min:max:getter: ] ifNone: [ nil ].
	
	pragma 
		ifNil: [  
			arguments := #().
			retrievingMethod  := nil ]
		ifNotNil: [ 
			arguments := pragma arguments.
			retrievingMethod := arguments fourth ].
		
	item := IntegerApiSetter new
				model: self model;
				method: anAPIMethod selector;
				retrievingMethod: retrievingMethod;
				yourself.
	
	arguments size > 5 ifTrue: [
		self model 
				perform: arguments fifth
				with: [:newValue | item updateWith: newValue ]].
	
	^ item ! !

!WidgetSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/16/2012 19:28'!
buildItemFor: anAPIMethod
	| args first |
	
	args := (anAPIMethod pragmas detect: [ :e | e keyword beginsWith: 'api:' ] ifNone: [ ^ nil ]) arguments.
	first := args first.

	first = #boolean
		ifTrue: [ ^ self buildBooleanItemFor: anAPIMethod ].
	first = #string
		ifTrue: [ ^ self buildStringItemFor: anAPIMethod ].
	first = #block
		ifTrue: [ ^ self buildBlockItemFor: anAPIMethod ].
	first = #inspect
		ifTrue: [ ^ self buildInspectItemFor: anAPIMethod ].
	first = #do
		ifTrue: [ ^ self buildDoItemFor: anAPIMethod ].
	first = #st
		ifTrue: [ ^ self buildStItemFor: anAPIMethod ].
	first = #integer
		ifTrue: [ ^ self buildIntegerItemFor: anAPIMethod ].
	first = #color
		ifTrue: [ ^ self buildColorItemFor: anAPIMethod  ].
	first = #event
		ifTrue: [ ^ self buildEventItemFor: anAPIMethod  ].
		
	^ self halt.! !

!WidgetSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/16/2012 22:08'!
buildItemFor: anAPIMethod kind: aClass
	| pragma arguments retrievingMethod item |
	
	pragma := anAPIMethod pragmas detect: [ :e | e keyword beginsWith: #api:getter: ] ifNone: [ nil ].
	
	pragma 
		ifNil: [  
			arguments := #().
			retrievingMethod  := nil ]
		ifNotNil: [ 
			arguments :=pragma arguments.
			retrievingMethod := arguments second ].
		
	item := aClass new
				model: self model;
				method: anAPIMethod selector;
				retrievingMethod: retrievingMethod;
				yourself.
				
	arguments size >2 
		ifTrue: [ 
			self model 
					perform: arguments third
					with: [:newValue | item updateWith: newValue ]].
	
	^ item ! !

!WidgetSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/16/2012 19:42'!
buildStItemFor: anAPIMethod 

	^ self buildItemFor: anAPIMethod kind: StApiSetter! !

!WidgetSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/16/2012 19:42'!
buildStringItemFor: anAPIMethod

	^ self buildItemFor: anAPIMethod kind: StringApiSetter! !

!WidgetSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/16/2012 18:31'!
initialize
	"Initialization code for WidgetSetter"

	model := nil asValueHolder.
	model whenChangedDo: [:m || max |
		self updateTitle.
		apiSetters items: self retrieveItems.
		max := (apiSetters listItems collect:[:e | self widthFor: e method ]) ifEmpty: [ 0 ] ifNotEmpty: [:l | l max ].
		apiSetters listItems do: [:e | e selectorWidth: max ]].
	
	super initialize.

! !

!WidgetSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/11/2012 16:33'!
initializeWidgets 
	
	self instantiateModels: #( apiSetters ListComposableModel ).
	
	apiSetters 
		allowToSelect: false;
		displayBlock: [:e | e ];
		items: self retrieveItems.! !

!WidgetSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 16:32'!
model

	^ model contents! !

!WidgetSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 16:32'!
model: anObject

	model contents: anObject! !

!WidgetSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 18:47'!
openWithSpec 

	super openWithSpec.
	apiSetters widget ifNotNil: [:w || wdw height |
		height := apiSetters listItems inject: 0 into: [:s :e | s + e widget height ].

		wdw := self window widget.
		wdw height: height + wdw labelArea height + 12.
		wdw width: 470 ]! !

!WidgetSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/16/2012 18:20'!
retrieveItems

	^ self model 
		ifNil: [ #() ]
		ifNotNil: [:m | ((m apiMethods sort: [:a :b | a selector < b selector ]) collect: [:e | self buildItemFor: e ]) reject: [:e | e isNil ]]! !

!WidgetSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 19:32'!
title

	^ self model
		ifNil: [ 'Widget Editor' ]
		ifNotNil: [:m | 'Widget Editor: ', m class name ]! !

!WidgetSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/11/2012 19:31'!
widthFor: selector
	
	apiSetters widget ifNil: [ ^ StandardFonts listFont widthOfString: selector ].
	^ selector widthToDisplayInList: apiSetters widget! !

ComposableModel subclass: #WorkingCopyToolBar
	instanceVariableNames: 'browseButton configButton packageButton sliceButton workingCopyHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Monticello'!

!WorkingCopyToolBar commentStamp: '<historical>' prior: 0!
WorkingCopyToolBar new openWithSpec!

!WorkingCopyToolBar class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:54'!
defaultSpec 

	^ {#ComposableSpec.
			#add: . {{#model . #packageButton.} .
						#layout: . {#FrameLayout  . #fractions:offsets: .  
											0@0 corner: 0.25@0 . 
											0@0 corner: 0@25 }} . 

#add: . {{#model . #configButton.} .
						#layout: . {#FrameLayout  . #fractions:offsets: .  
											0.25@0 corner: 0.50@0 . 
											0@0 corner: 0@25 }} . 
											
#add: . {{#model . #sliceButton.} .
						#layout: . {#FrameLayout  . #fractions:offsets: .  
											0.50@0 corner: 0.75@0 . 
											0@0 corner: 0@25 }} . 											

#add: . {{#model . #browseButton.} .
						#layout: . {#FrameLayout  . #fractions:offsets: .  
											0.75@0 corner: 1@0 . 
											0@0 corner: 0@25 }} 	
		}! !

!WorkingCopyToolBar methodsFor: 'accessing' stamp: 'StephaneDucasse 4/19/2012 17:33'!
browseButton
	^ browseButton! !

!WorkingCopyToolBar methodsFor: 'accessing' stamp: 'StephaneDucasse 4/19/2012 17:34'!
configButton
	
	^ configButton! !

!WorkingCopyToolBar methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:42'!
createPackage
	| name |
	
	name := UIManager default request: 'Name of package:' translated.
	name isEmptyOrNil ifFalse:
		[ PackageInfo registerPackageName: name.
		MCWorkingCopy forPackage: (MCPackage new name: name).]! !

!WorkingCopyToolBar methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:45'!
initialize
	"Initialization code for WorkingCopyToolBar"

	super initialize.
	workingCopyHolder := nil asValueHolder! !

!WorkingCopyToolBar methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:44'!
initializeWidgets

	self instantiateModels: #(
		browseButton  ButtonModel
		configButton  ButtonModel
		packageButton ButtonModel ).
		
	self setBrowseButton.
	self setConfigButton.
	self setPackageButton.
	self setSliceButton.! !

!WorkingCopyToolBar methodsFor: 'accessing' stamp: 'StephaneDucasse 4/19/2012 17:32'!
packageButton

	^ packageButton! !

!WorkingCopyToolBar methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:44'!
setBrowseButton

	browseButton
		state: false;
		enabled: false;
		label: 'Browse';
		help: 'Browse the working copy of the selected package';
		action: [ self browseWorkingCopy ]! !

!WorkingCopyToolBar methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:44'!
setConfigButton

	configButton
		state: false;
		label: '+Config';
		help: 'Add a new metacello configuration';
		action: [ self createConfiguration ]! !

!WorkingCopyToolBar methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:44'!
setPackageButton

	packageButton
		state: false;
		label: '+Package';
		help: 'Add a new package and make it the working copy';
		action: [ self createPackage ]! !

!WorkingCopyToolBar methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:44'!
setSliceButton
	sliceButton := self instantiate: ButtonModel.
	sliceButton
		state: false;
		label: '+Slice';
		help: 'Add a slice to cleaning and nicely propose a bug fix';
		action: [ self createSlice ]! !

!WorkingCopyToolBar methodsFor: 'accessing' stamp: 'StephaneDucasse 4/19/2012 17:34'!
sliceButton
	
	^ sliceButton! !

!SequenceableCollection methodsFor: '*Spec-Core' stamp: ''!
asValueHolder

	^ CollectionValueHolder contents: self! !

Announcement subclass: #ValueChanged
	instanceVariableNames: 'newContents oldContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!ValueChanged commentStamp: '<historical>' prior: 0!
A ValueChanged is an announcement raised when a value of a NewValueHolder is changed!

!ValueChanged class methodsFor: 'instance creation' stamp: ''!
newContents: newContents

	^ self new
		newContents: newContents;
		yourself! !

!ValueChanged class methodsFor: 'instance creation' stamp: ''!
oldContents: oldContent newContents: newContent

	^ self new
		newContents: newContent;
		oldContents: oldContent;
		yourself! !

!ValueChanged methodsFor: 'accessing' stamp: ''!
newContents

	^ newContents! !

!ValueChanged methodsFor: 'accessing' stamp: ''!
newContents: anObject
	
	newContents := anObject! !

!ValueChanged methodsFor: 'accessing' stamp: ''!
oldContents

	^ oldContents! !

!ValueChanged methodsFor: 'accessing' stamp: ''!
oldContents: anObject
	
	oldContents := anObject! !

AbstractTool subclass: #ChangeSorterModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-ChangeSorter'!

!ChangeSorterModel commentStamp: '<historical>' prior: 0!
A ChangeSorterModel is a model used by Change Sorter UIs for computation!

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
addPreambleTo: aChangeSet

	aChangeSet assurePreambleExists! !

!ChangeSorterModel methodsFor: 'environment' stamp: ''!
allChanges

	^ ChangeSet allChangeSets reverse! !

!ChangeSorterModel methodsFor: 'text' stamp: ''!
buildChangeSetDescriptionFor: changeSet
		
	^ changeSet
		ifNil: [ '' ] 
		ifNotNil: [ changeSet preambleString ifNil: ['']]! !

!ChangeSorterModel methodsFor: 'text' stamp: ''!
buildClassDescriptionFor: changeSet class: class
	| stream |

	stream := (String new: 100) writeStream.
		(changeSet classChangeAt: class name)
			do: [:each | 
				each = #remove
					ifTrue: [ stream nextPutAll: 'Entire class was removed.'; cr ].
				each = #addedThenRemoved
					ifTrue: [ stream nextPutAll: 'Class was added then removed.'; cr ].
				each = #rename
					ifTrue: [ stream nextPutAll: 'Class name was changed.'; cr ].
				each = #add
					ifTrue: [ stream nextPutAll: 'Class definition was added.'; cr ].
				each = #change
					ifTrue: [ stream nextPutAll: 'Class definition was changed.'; cr ].
				each = #reorganize
					ifTrue: [ stream nextPutAll: 'Class organization was changed.'; cr ].
				each = #comment 
					ifTrue: [ stream nextPutAll: 'New class comment.'; cr ]].
		^ stream contents! !

!ChangeSorterModel methodsFor: 'text' stamp: ''!
buildSelectorDescriptionFor: changeSet class: class selector: selector prettyPrint: prettyPrint showDiff: showDiff

	| changeType code |
	changeType := changeSet atSelector: selector class: class name.
	
	changeType == #remove
		ifTrue: [^ 'Method has been removed (see versions)'].
	changeType == #addedThenRemoved
		ifTrue: [^ 'Added then removed (see versions)']. 
	class
		ifNil: [^ 'Method was added, but cannot be found!!'].
	(class includesSelector: selector)
		ifFalse: [^ 'Method was added, but cannot be found!!'].
	code := class sourceCodeAt: selector.
	prettyPrint
		ifTrue: [ code := class prettyPrinterClass
							format: code
							in: class
							notifying: nil ].						
	showDiff
		ifTrue: [ code := self diffFromPriorSourceFor: code ].
		
	^ code asText makeSelectorBoldIn: class! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
copyAllChangesFrom: source to: destination

	destination assimilateAllChangesFoundIn: source! !

!ChangeSorterModel methodsFor: 'class' stamp: ''!
copyClass: aClass from: source to: destination

	destination absorbClass: aClass name from: source.! !

!ChangeSorterModel methodsFor: 'message' stamp: ''!
copySelector: selector inClass: class from: source to: destination

	destination
		absorbMethod: selector 
		class: class 
		from:source! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
createNewSet

	^ ChangeSet newChangeSet.! !

!ChangeSorterModel methodsFor: 'class' stamp: ''!
fileOutClass: aClass from: aChangeSet
	"this is a hack!!!! makes a new change set, called the class name, adds author initials to try to make a unique change set name, files it out and removes it. kfr 16 june 2000"
	"Method copied from ChangeSorter"
	| aSet |
	"File out the selected class set."
     aSet := ChangeSet newChangeSet: aClass name.
	aSet ifNil:[ ^self ].
	aSet absorbClass: aClass name from: aChangeSet.
	aSet fileOut.
	ChangeSet removeChangeSet: aSet.! !

!ChangeSorterModel methodsFor: 'message' stamp: ''!
fileOutSelector: selector from: aClass
	
	aClass fileOutMethod: selector! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
findChangeSetIn: aCollectionOfChangeSets
	"Search for a changeSet by name.  Pop up a menu of all changeSets whose name contains the string entered by the user.  If only one matches, then the pop-up menu is bypassed"
	| index pattern candidates nameList |
	self okToChange ifFalse: [^ self].
	pattern := UIManager default request: 'ChangeSet name or fragment?'.
	pattern isEmptyOrNil ifTrue: [^ self].
	nameList := aCollectionOfChangeSets collect: #name.
	candidates := aCollectionOfChangeSets select:
			[:c | (nameList includes: c name) and: 
				[c name includesSubstring: pattern caseSensitive: false]].
	candidates size = 0 ifTrue: [ ^ Beeper beep ].
	candidates size = 1 ifTrue: [ ^ candidates first ].
	index := UIManager default chooseFrom: (candidates collect: [:each | each name]).
	index = 0 ifFalse: [ ^ (candidates at: index) ].! !

!ChangeSorterModel methodsFor: 'message' stamp: ''!
forgetSelector: selector inClass: aClass fromChangeSet: aChangeSet

	aChangeSet
			removeSelectorChanges: selector 
			class: aClass! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
removeChangeSet: aChangeSet prompting: doPrompt
	"Completely destroy my change set.  Check if it's OK first, and if doPrompt is true, get the user to confirm his intentions first."

	| message aName changeSetNumber msg |
	aName := aChangeSet name.
	aChangeSet okayToRemove ifFalse: [^ self]. "forms current changes for some project"
	(aChangeSet isEmpty or: [doPrompt not]) ifFalse:
		[message := 'Are you certain that you want to 
remove (destroy) the change set
named  "', aName, '" ?'.
		(self confirm: message) ifFalse: [^ self]].

	doPrompt ifTrue:
		[msg := aChangeSet hasPreamble
			ifTrue:
				[aChangeSet hasPostscript
					ifTrue:
						['a preamble and a postscript']
					ifFalse:
						['a preamble']]
			ifFalse:
				[aChangeSet hasPostscript
					ifTrue:
						['a postscript']
					ifFalse:
						['']].
		msg isEmpty ifFalse:
			[(self confirm: 
'Caution!!  This change set has
', msg, ' which will be
lost if you destroy the change set.
Do you really want to go ahead with this?') ifFalse: [^ self]]].

	"Go ahead and remove the change set"
	changeSetNumber := aChangeSet name initialIntegerOrNil.
	changeSetNumber ifNotNil: [SystemVersion current unregisterUpdate: changeSetNumber].
	ChangeSet removeChangeSet: aChangeSet.! !

!ChangeSorterModel methodsFor: 'class' stamp: ''!
removeClass: class from: changeSet

	changeSet removeClassChanges: class.! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
removePostscriptFrom: aChange

	(aChange hasPostscript and: [ aChange postscriptHasDependents ]) ifTrue:
		[^ self inform:
'Cannot remove the postscript right
now because there is at least one
window open on that postscript.
Close that window and try again.'].

	aChange removePostscript.! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
rename: aChangeSet
	"Store a new name string into the selected ChangeSet.  reject duplicate name; allow user to back out"

	| newName |
	newName := UIManager default request: 'New name for this change set'
						initialAnswer: aChangeSet name.
						
	(newName = aChangeSet name or: [newName isEmptyOrNil]) ifTrue:
			[ ^ Beeper beep ].

	(ChangeSet named: newName) ifNotNil:
			[ ^ UIManager default inform: 'Sorry that name is already used' ].

	aChangeSet name: newName.
	^ aChangeSet! !

!ChangeSorterModel methodsFor: 'text' stamp: ''!
setContentsOfChangeSet: changeSet forClass: class andSelector: selector prettyPrint: prettyPrint showDiff: showDiff 
	"return the source code that shows in the bottom pane"
	| strm changeType code |

	
	class
		ifNil: [
			"Only the change set is currently selected"
			^ self buildChangeSetDescriptionFor: changeSet ].
	selector isNil
		ifTrue: [ 
			"class is selected but not the selector"
			^ self buildClassDescriptionFor: changeSet class: class ]
		ifFalse: [
			"a class and a selector are selected"
			^ self buildSelectorDescriptionFor: changeSet class: class selector: selector prettyPrint: prettyPrint showDiff: showDiff ]! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
setCurrentChangeSet: aChangeSet

	ChangeSet newChanges: aChangeSet! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
submerge: source into: destination
	"Copy the contents of the receiver to the other side, then remove the receiver -- all after checking that all is well."
	|   message |
	source == destination
		ifTrue: [ ^ false ].
	source isEmpty
		ifTrue: [ 
			self inform: 'Nothing to copy.  To remove,
simply choose "remove".'.
			^ false ].

	source okayToRemove ifFalse: [^ false].
	message := 'Please confirm:  copy all changes
in "', source name, '" into "', destination name, '"
and then destroy the change set
named "', source name, '"?'.
 
	(self confirm: message) ifFalse: [^ false].

	(source hasPreamble or: [source hasPostscript]) ifTrue:
		[(self confirm: 
'Caution!!  This change set has a preamble or
a postscript or both.  If you submerge it into
the other side, these will be lost.
Do you really want to go ahead with this?') ifFalse: [^ false]].

	self copyAllChangesFrom: source to: destination.
	self removeChangeSet: source prompting: false.
	^ true! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
substractFrom: source to: destination

	source forgetAllChangesFoundIn: destination.! !

TestCase subclass: #SpecInterpreterTest
	instanceVariableNames: 'specInterpreter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tests'!

!SpecInterpreterTest commentStamp: '<historical>' prior: 0!
A SpecInterpreterTest is a test class for testing the behavior of SpecInterpreter!

!SpecInterpreterTest methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/6/2012 18:26'!
setUp
	"Setting up code for SpecInterpreterTest"


	specInterpreter := SpecInterpreter new.
	specInterpreter model: TestingComposableModel new! !

!SpecInterpreterTest methodsFor: 'initialization' stamp: ''!
tearDown
	"Tearing down code for SpecInterpreterTest"


	specInterpreter := nil.! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 6/6/2012 18:26'!
testBuildMorphFor

	| model morph |
	model := TestingComposableModel new.
	morph := specInterpreter buildMorphFor: model.
	
	self assert: (morph model == model).
	self assert: (model widget class = PluggableListMorph).! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'StephaneDucasse 5/17/2012 17:57'!
testBuildMorphForWithSpec

	| model morph |
	model := TestingComposableModel new.
	morph := specInterpreter buildMorphFor: model withSpec: #testingSpec.
	
	self assert: (morph model == model).
	self assert: (model widget class = PluggableTextMorph).! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 5/22/2012 14:57'!
testBuildWindowFor

	| model widget |
	model := TestingComposableModel new.
	widget := specInterpreter buildWindowFor: model.
	
	self assert: ( model widget = widget).
	self assert: (widget submorphs anySatisfy: [:e | e class = PluggableListMorph ])! !

!SpecInterpreterTest methodsFor: 'tests' stamp: ''!
testConvertRandomSymbolOfClassToInstance
	
	| symbol instance |
	symbol := #PluggableListMorph.
	
	instance := specInterpreter convertSymbolOfClassToInstance: symbol.
	self assert: (instance class name = symbol)! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 6/12/2012 18:38'!
testInterpretASpecModelMorphAssociation

	| spec model morph |
	model := DummyComposableModel new.
	spec := {#PluggableListMorph. #model:. #model}.
	morph := specInterpreter interpretASpec: spec model: model.
	
	self assert: (model widget == morph).! !

DiffMethodReferenceConverter subclass: #DiffChangeRecordConverter
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-VersionBrowser'!

!DiffChangeRecordConverter commentStamp: '<historical>' prior: 0!
A DiffChangeRecordConverter is a converter used to show the diff between two methodreferences!

!DiffChangeRecordConverter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/3/2012 14:30'!
priorVersionOfAMethod: aChangeRecord
	| index |
	
	list := referencesList sorted: [:a :b | a timeStamp > b timeStamp ].
	index := list indexOf: aChangeRecord .
	^ list at: index+1 ifAbsent: [ aChangeRecord ]! !

!Dictionary methodsFor: '*Spec-Core' stamp: ''!
asValueHolder

	^ DictionaryValueHolder contents: self! !

!PanelMorph methodsFor: '*Spec-Layout' stamp: 'BenjaminVanRyseghem 7/31/2012 18:08'!
checkSplitters
	| size |
	
	size := submorphs size.
	(self submorphsSatisfying: [:e | e isKindOf: ProportionalSplitterMorph ]) do: [:e || index idx |
		index := submorphs identityIndexOf: e.
		idx := index + 1.
		"above"
		[ idx <= size and: [ ((submorphs at: idx) isKindOf: ProportionalSplitterMorph) not ]] whileTrue: [
			e addLeftOrTop: (submorphs at: idx).
			idx := idx +1 ].
		
		idx := index - 1.
		
		"below"
		[ idx > 0 and: [ ((submorphs at: idx) isKindOf: ProportionalSplitterMorph) not ]] whileTrue: [
			e addRightOrBottom: (submorphs at: idx).
			idx := idx -1 ]]! !

!PanelMorph methodsFor: '*Spec-Layout' stamp: 'BenjaminVanRyseghem 7/31/2012 15:47'!
newHSplitter

	^ ProportionalSplitterMorph new
			beSplitsTopAndBottom;
			setProperty: #model toValue: self.! !

!PanelMorph methodsFor: '*Spec-Layout' stamp: 'BenjaminVanRyseghem 7/31/2012 18:05'!
newHSplitterAt: anIndex
	| above frame splitter index size |

	size := submorphs size.
	index := size - anIndex + 2.
	above := self submorphs at: index.
	frame := above layoutFrame.
	
	splitter := self newHSplitter.
	splitter 
		layoutFrame: (LayoutFrame
							fractions: ((frame leftFraction @ frame bottomFraction) corner: (frame rightFraction @ frame bottomFraction))
							offsets: (0@0 corner: 0@4)).
								
	self privateAddMorph: splitter atIndex: (size - anIndex + 2)! !

!PanelMorph methodsFor: '*Spec-Layout' stamp: 'BenjaminVanRyseghem 7/31/2012 15:47'!
newVSplitter

	^ ProportionalSplitterMorph new
			setProperty: #model toValue: self.! !

!PanelMorph methodsFor: '*Spec-Layout' stamp: 'BenjaminVanRyseghem 7/31/2012 18:05'!
newVSplitterAt: anIndex
	| left frame splitter index size |

	size := submorphs size.
	index := size - anIndex + 2.
	left := self submorphs at: index.
	frame := left layoutFrame.
	
	splitter := self newVSplitter.
	splitter 
		layoutFrame: (LayoutFrame
							fractions: ((frame rightFraction @ frame topFraction) corner: (frame rightFraction @ frame bottomFraction))
							offsets: (0@0 corner: 4@0)).

	self privateAddMorph: splitter atIndex: (size - anIndex + 2)! !

PanelMorph subclass: #PanelMorphWithSplitters
	instanceVariableNames: 'paneMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets-Utilities'!

!PanelMorphWithSplitters commentStamp: '<historical>' prior: 0!
A PanelMorphWithSplitters is which add splitters the way SystemWindow do it!

!PanelMorphWithSplitters methodsFor: 'submorphs-add/remove' stamp: 'BenjaminVanRyseghem 3/23/2012 17:00'!
addMorph: aMorph

	paneMorphs add: aMorph.
	^ super addMorph: aMorph! !

!PanelMorphWithSplitters methodsFor: 'submorphs-add/remove' stamp: ''!
addMorph: aMorph fullFrame: aLayout

	paneMorphs add: aMorph.
	super addMorph: aMorph fullFrame: aLayout! !

!PanelMorphWithSplitters methodsFor: 'private' stamp: ''!
addPaneHSplitterBetween: topMorphs and: bottomMorphs
	"Add a horizontal splitter for the given morphs that share a common bottom fraction.
	If there is a horizontal discontinuity apply the splitter to the first contiguous group.
	Answer the morphs to which the splitter was applied."
	
	|targetY fixed rightFraction leftFrame rightFrame sorted morph topGroup bottomGroup splitter offset|
	topMorphs ifEmpty: [^self].
	targetY := topMorphs first layoutFrame bottomFraction.
	fixed := topMorphs select: [:m | m layoutFrame topFraction = m layoutFrame bottomFraction].
		"fixed morphs appear in both top and bottom"
	sorted := ((topMorphs reject: [:m | m layoutFrame topFraction = m layoutFrame bottomFraction])
		asSortedCollection: [:a :b | a layoutFrame rightFraction = b layoutFrame rightFraction
			ifTrue: [a layoutFrame leftFraction <= b layoutFrame leftFraction]
			ifFalse: [a layoutFrame rightFraction <= b layoutFrame rightFraction]]) readStream.
	sorted contents ifEmpty: [^fixed].
	topGroup := OrderedCollection new.
	rightFraction := sorted contents first layoutFrame leftFraction.
	[sorted atEnd or: [morph := sorted next.
			(morph layoutFrame leftFraction ~= rightFraction and: [
				morph layoutFrame rightFraction ~= rightFraction])]] whileFalse: [
		topGroup add: morph.
		rightFraction := morph layoutFrame rightFraction].
	leftFrame := topGroup first layoutFrame.
	rightFrame := topGroup last layoutFrame.
	bottomGroup := (bottomMorphs 
			reject: [:m | m layoutFrame topFraction = m layoutFrame bottomFraction])
			select: [:m |
		(m layoutFrame leftFraction
			between: leftFrame leftFraction
			and: rightFrame rightFraction) or: [
		m layoutFrame rightFraction
			between: leftFrame leftFraction
			and: rightFrame rightFraction]].
	offset := (topGroup collect: [:m | m layoutFrame bottomOffset ifNil: [0]]) max.
	splitter := ProportionalSplitterMorph new
		beSplitsTopAndBottom.
	splitter layoutFrame: (LayoutFrame
		fractions: (leftFrame leftFraction @ targetY
					corner: rightFrame rightFraction @ targetY)
		offsets: (((leftFrame leftOffset ifNil: [0]) @ 0 corner: ((rightFrame rightOffset ifNil: [0])@ 4))
		 	translateBy: 0 @ offset)).
	topGroup := topGroup, fixed.
	topGroup do: [:m | splitter addLeftOrTop: m].
	bottomGroup do: [:m | splitter addRightOrBottom: m].
	self addMorphBack: splitter.
	^topGroup! !

!PanelMorphWithSplitters methodsFor: 'private' stamp: ''!
addPaneHSplitters
	"Add the horizontal pane splitters."

	|remaining targetBottom sameBottom sameTop|
	remaining := paneMorphs reject: [:each |
			each layoutFrame bottomFraction = 1 or: [
				each layoutFrame bottomFraction = 0]].
	[remaining notEmpty] whileTrue: [
		targetBottom := remaining first layoutFrame bottomFraction.
		sameBottom := remaining select: [:each |
			each layoutFrame bottomFraction = targetBottom].
		sameTop := paneMorphs select: [:each |
			each layoutFrame topFraction = targetBottom].
		remaining := remaining
			copyWithoutAll: (self addPaneHSplitterBetween: sameBottom and: sameTop)]! !

!PanelMorphWithSplitters methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/23/2012 17:01'!
addPaneSplitters
	"Add the vertical and horizontal pane splitters."

	self removePaneSplitters.
	self addPaneVSplitters.
	self addPaneHSplitters.
	self linkSplittersToSplitters! !

!PanelMorphWithSplitters methodsFor: 'private' stamp: ''!
addPaneVSplitterBetween: leftMorphs and: rightMorphs
	"Add a vertical splitter for the given morphs that share a common right fraction.
	If there is a vertical discontinuity apply the splitter to the first contiguous group.
	Answer the morphs to which the splitter was applied."
	
	|targetX fixed bottomFraction topFrame bottomFrame sorted morph leftGroup rightGroup splitter offset|
	leftMorphs ifEmpty: [^self].
	targetX := leftMorphs first layoutFrame rightFraction.
	fixed := leftMorphs select: [:m | m layoutFrame leftFraction = m layoutFrame rightFraction].
		"fixed morphs appear in both top and bottom"
	sorted := ((leftMorphs reject: [:m | m layoutFrame leftFraction = m layoutFrame rightFraction])
		asSortedCollection: [:a :b | a layoutFrame bottomFraction = b layoutFrame bottomFraction
			ifTrue: [a layoutFrame topFraction <= b layoutFrame topFraction]
			ifFalse: [a layoutFrame bottomFraction <= b layoutFrame bottomFraction]]) readStream.
	sorted contents ifEmpty: [^fixed].
	leftGroup := OrderedCollection new.
	bottomFraction := sorted contents first layoutFrame topFraction.
	[sorted atEnd or: [morph := sorted next.
			morph layoutFrame topFraction ~= bottomFraction and: [
				morph layoutFrame bottomFraction ~= bottomFraction]]] whileFalse: [
		leftGroup add: morph.
		bottomFraction := morph layoutFrame bottomFraction].
	topFrame := leftGroup first layoutFrame.
	bottomFrame := leftGroup last layoutFrame.
	rightGroup := (rightMorphs
			reject: [:m | m layoutFrame leftFraction = m layoutFrame rightFraction])
			select: [:m |
		m layoutFrame topFraction
			between: topFrame topFraction
			and: bottomFrame bottomFraction].
	offset := (leftGroup collect: [:m | m layoutFrame rightOffset ifNil: [0]]) max.
	splitter := ProportionalSplitterMorph new.
	splitter layoutFrame: (LayoutFrame
		fractions: (targetX @ topFrame topFraction
					corner: targetX @ bottomFrame bottomFraction)
		offsets: ((0 @ (topFrame topOffset ifNil: [0]) corner: (4@ (bottomFrame bottomOffset ifNil: [0])))
		 	translateBy: offset @ 0)).
	leftGroup := leftGroup, fixed.
	leftGroup do: [:m | splitter addLeftOrTop: m].
	rightGroup do: [:m | splitter addRightOrBottom: m].
	self addMorphBack: splitter.
	^leftGroup! !

!PanelMorphWithSplitters methodsFor: 'private' stamp: ''!
addPaneVSplitters
	"Add the vertical pane splitters."

	|remaining targetRight sameRight sameLeft |
	remaining := paneMorphs reject: [:each |
			each layoutFrame rightFraction = 1 or: [
				each layoutFrame rightFraction = 0]].
	[remaining notEmpty] whileTrue: [
		targetRight := remaining first layoutFrame rightFraction.
		sameRight := remaining select: [:each |
			each layoutFrame rightFraction = targetRight].
		sameLeft := paneMorphs select: [:each |
			each layoutFrame leftFraction = targetRight and: [
				each layoutFrame rightFraction ~= targetRight]].
		remaining := remaining
			copyWithoutAll: (self addPaneVSplitterBetween: sameRight and: sameLeft)]! !

!PanelMorphWithSplitters methodsFor: 'initialization' stamp: ''!
initialize
	"Initialization code for PanelMorphWithSplitter"

	super initialize.

	paneMorphs := OrderedCollection new.! !

!PanelMorphWithSplitters methodsFor: 'layout-properties' stamp: ''!
layoutFrame: aFrame

	self activate.
	super layoutFrame: aFrame! !

!PanelMorphWithSplitters methodsFor: 'private' stamp: ''!
linkSplittersToSplitters
	"The pane morphs are already linked. Cross link the splitters as appropriate."
	
	self splitters do: [:each |
		each splitsTopAndBottom
			ifTrue: [self splitters do: [:eachMorph |
					eachMorph splitsTopAndBottom ~= each splitsTopAndBottom ifTrue: [
						eachMorph layoutFrame bottomFraction = each layoutFrame topFraction
							ifTrue: [each addLeftOrTop: eachMorph].
						eachMorph layoutFrame topFraction = each layoutFrame bottomFraction
							ifTrue: [each addRightOrBottom: eachMorph]]]]
			ifFalse: [self splitters do: [:eachMorph |
					eachMorph splitsTopAndBottom ~= each splitsTopAndBottom ifTrue: [
						eachMorph layoutFrame rightFraction = each layoutFrame leftFraction
							ifTrue: [each addLeftOrTop: eachMorph].
						eachMorph layoutFrame leftFraction = each layoutFrame rightFraction
							ifTrue: [each addRightOrBottom: eachMorph]]]].
				
		each comeToFront.]! !

PanelMorph subclass: #TabContainerMorph
	instanceVariableNames: 'container tab'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples-PolyWidgets'!

!TabContainerMorph commentStamp: '<historical>' prior: 0!
A TabContainerMorph is a morph (which should be pluggable soon) which handle a first bar for tabs button and a container which is used to display the morph corresponding to the selected tab!

!TabContainerMorph class methodsFor: 'example' stamp: 'bvr 6/4/2012 17:26'!
example

	| tc testMorph model model2 model3 anotherMorph anotherMorph2 associations classes |
	
	model := ClassMethodBrowser new.
	model2 := ClassMethodBrowser new.
	model3 := ClassMethodBrowser new.
	
	testMorph := model buildWithSpec.
	anotherMorph := model2 buildWithSpec.
	anotherMorph2 := model3 buildWithSpec.
	
	associations := {'Test' -> testMorph. 'Another'-> anotherMorph. 'Again' -> anotherMorph2}.
	tc := self withTabs: associations.
	classes := Smalltalk allClasses.
	model classes: classes .
	model2 classes: classes.
	model3 classes: classes.
	
	( tc embeddedInMorphicWindowLabeled: 'test') openInWorld.
	^ tc! !

!TabContainerMorph class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 1/7/2012 06:04'!
withTabs: associations

	^ self new
		addTabs: associations;
		yourself.! !

!TabContainerMorph methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/7/2012 06:09'!
addAll
	
	self
		addMorph: tab
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ 0 corner: 0 @ 35)).
				
	self
		addMorph: container
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 35 corner: 0 @ 0)).! !

!TabContainerMorph methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/7/2012 06:02'!
addTabs: associations

	associations do: [:each |
		self tab 
			addTab: (Text fromString: each key) 
			withAction: [ self setContent: each value ].
		container submorphs isEmpty ifTrue: [ container addMorph: each value ]]! !

!TabContainerMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/7/2012 06:08'!
container

	^ container! !

!TabContainerMorph methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/7/2012 06:14'!
initialize
	"Initialization code for TabContainerMorph"

	super initialize.
	
	self changeProportionalLayout.
	container := PanelMorph new changeTableLayout; listDirection: #bottomToTop; color: Color white; yourself.
	
	tab := PluggableTabBarMorph on: self.
	tab width: 150.
	tab color: Color white darker darker.
	
	self addAll.! !

!TabContainerMorph methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/9/2012 18:43'!
setContent: aMorph

	container removeAllMorphs.
	container addMorph: aMorph.
	aMorph color: Color white.
	aMorph takeKeyboardFocus.! !

!TabContainerMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/7/2012 06:08'!
tab

	^ tab! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
getIndexSelector: aSelector

	getIndexSelector := aSelector! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
getSelectionListSelector: getListSel.

	getSelectionListSelector := getListSel! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
initialize

	super initialize.
	self initForKeystrokes.! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
setIndexSelector: aSelector

	setIndexSelector := aSelector! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
setMultipleSelection: aBoolean

	multipleSelection := aBoolean! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
setSelectionListSelector: getListSel.

	setSelectionListSelector := getListSel! !

!ClassDescription methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 2/27/2012 07:50'!
compileWithoutReturn: code classified: heading

	self compile: code classified: heading! !

!Class methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 3/5/2012 05:50'!
addInstVarNamed: aName type: aClass

	^ self addInstVarNamed: aName! !

!Class methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 2/28/2012 20:27'!
addSourceCode: source into: selector
	| method newSource |
	method := self methodDict at: selector asSymbol ifAbsent: [ ^ self ].
	newSource := String streamContents: [:s |
		s << method sourceCode << '.' ; cr ; tab ;<< source ].
	self compileWithoutReturn: newSource classified: method category! !

!Class methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 2/27/2012 07:45'!
subclass: newName category: newCategory

	| result |
	result := self subclass: newName
					instanceVariableNames: ''
					classVariableNames: ''
					poolDictionaries: ''
					category: newCategory.
	^ result 
		ifNil: [ Smalltalk at: name ifAbsent: [ nil ]]
		ifNotNil: [ result ]! !

Object subclass: #AbstractBindings
	instanceVariableNames: 'classSymbols selectorSymbols'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Bindings'!

!AbstractBindings commentStamp: '<historical>' prior: 0!
AbstractHolder is an abstract class which handle two dictionaries: one for classes symbol, and one for selectors symbols.!

!AbstractBindings methodsFor: 'protocol' stamp: ''!
classSymbolFor: aSymbol

	^ classSymbols at: aSymbol! !

!AbstractBindings methodsFor: 'protocol' stamp: ''!
classSymbolFor: aSymbol ifAbsent: aBlock

	^ classSymbols at: aSymbol ifAbsent: aBlock! !

!AbstractBindings methodsFor: 'protocol' stamp: ''!
classSymbolFor: aSymbol is: aClassSymbol

	^ classSymbols at: aSymbol put: aClassSymbol! !

!AbstractBindings methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/23/2012 14:55'!
initialize
	"Initialization code for AbstractHolder"

	super initialize.

	classSymbols := self initializeClassesDictionary.
	selectorSymbols := self initializeSelectorsDictionary! !

!AbstractBindings methodsFor: 'initialization' stamp: ''!
initializeClassesDictionary

	^ IdentityDictionary new! !

!AbstractBindings methodsFor: 'initialization' stamp: ''!
initializeSelectorsDictionary

	^ IdentityDictionary new! !

!AbstractBindings methodsFor: 'protocol' stamp: ''!
selectorSymbolFor: aSymbol

	^ selectorSymbols at: aSymbol! !

!AbstractBindings methodsFor: 'protocol' stamp: ''!
selectorSymbolFor: aSymbol ifAbsent: aBlock

	^ selectorSymbols at: aSymbol ifAbsent: aBlock! !

!AbstractBindings methodsFor: 'protocol' stamp: ''!
selectorSymbolFor: aSymbol is: aSelector

	^ selectorSymbols at: aSymbol put: aSelector! !

AbstractBindings subclass: #MorphicBindings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Bindings'!

!MorphicBindings commentStamp: '<historical>' prior: 0!
MorphicBindings is the class holding the bindings between Spec and Morphic!

!MorphicBindings methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/31/2012 15:26'!
initializeClassesDictionary

	^ IdentityDictionary new
		at: #List 				put: #PluggableListMorph;
		at: #IconList 			put: #PluggableIconListMorph;
		at: #Text 				put: #PluggableTextMorph;
		at: #Button 			put: #PluggableButtonMorph;
		at: #Panel 				put: #PanelMorph;
		at: #Checkbox 			put: #CheckboxMorph;
		at: #DropList 			put: #DropListMorph;
		at: #TextField 			put: #PluggableTextFieldMorph;
		at: #Label 				put: #LabelMorph;
		at: #MultiColumnList 	put: #PluggableMultiColumnListMorph;
		at: #Tree				put: #PluggableTreeMorph;
		at: #Slider 				put: #PluggableSliderMorph;
		at: #FrameLayout		put: #LayoutFrame;
		at: #Window 			put: #StandardWindow;
		at: #DialogWindow 		put: #SpecDialogWindow;
		yourself! !

!MorphicBindings methodsFor: 'initialization' stamp: 'bvr 6/1/2012 17:05'!
initializeSelectorsDictionary

	^ IdentityDictionary new
		at: #addSplitters	 			put: #yourself;
		at: #add:						put: #ensureLayoutAndAddMorph:;
		at: #layout:						put: #layoutFrame:;
		at: #fractions:offsets:			put: #fractions:offsets:;
		at: #useProportionalLayout	put: #changeProportionalLayout;
		at: #vSpaceFill					put: {#vResizing:. #spaceFill};
		at: #hSpaceFill					put: {#hResizing:. #spaceFill};
		at: #vShrinkWrap				put: {#vResizing:. #shrinkWrap};
		at: #hShrinkWrap				put: {#hResizing:. #shrinkWrap};
		at: #vRigid						put: {#vResizing:. #rigid};
		at: #hRigid						put: {#hResizing:. #rigid};
		yourself! !

AbstractBindings subclass: #MorphicBindingsWithSplitters
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Bindings'!

!MorphicBindingsWithSplitters commentStamp: '<historical>' prior: 0!
MorphicBindingsWithSplitters is like MorphicBindings with splitters support in addition!

!MorphicBindingsWithSplitters methodsFor: 'initialization' stamp: ''!
initializeClassesDictionary

	^ IdentityDictionary new
		at: #Panel put: #PanelMorphWithSplitters;
		yourself! !

!MorphicBindingsWithSplitters methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/23/2012 16:58'!
initializeSelectorsDictionary

	^ IdentityDictionary new
		at: #addSplitters	 put: #addPaneSplitters;
		yourself! !

Object subclass: #AbstractDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!AbstractDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:35'!
generate

	^ self generateSpec asOrderedCollection addFirst: #model; asArray! !

!AbstractDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:44'!
generateSpec

	^ self subclassResponsibility! !

AbstractDescription subclass: #AddClassDescription
	instanceVariableNames: 'category name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!AddClassDescription class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/27/2012 07:38'!
category: ctgr name: newClassName

	^ self new
		category: ctgr;
		newClassName: newClassName;
		yourself! !

!AddClassDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:12'!
category
	^ category! !

!AddClassDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:12'!
category: anObject
	category := anObject! !

!AddClassDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:45'!
generateSpec

	^ {	#subclass:category:.
		self newClassName asSymbol.
		self category}
		! !

!AddClassDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:13'!
newClassName

	^ name! !

!AddClassDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:13'!
newClassName: anObject

	name := anObject! !

AbstractDescription subclass: #AddInstVarDescription
	instanceVariableNames: 'name type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!AddInstVarDescription class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/28/2012 13:56'!
name: newName

	^ self 
		name: newName
		type: Object! !

!AddInstVarDescription class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/28/2012 13:56'!
name: newName type: type

	^ self new
		name: newName;
		type: type;
		yourself! !

!AddInstVarDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 3/5/2012 05:51'!
generateSpec

	^ { #addInstVarNamed:type:.	self name. self type }! !

!AddInstVarDescription methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/27/2012 06:48'!
initialize
	"Initialization code for AddInstVarDescription"

	super initialize.

	name := ''.! !

!AddInstVarDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:41'!
name
	^ name! !

!AddInstVarDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:40'!
name: anObject
	name := anObject! !

!AddInstVarDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 13:55'!
type
	^ type! !

!AddInstVarDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 13:55'!
type: anObject
	type := anObject! !

AbstractDescription subclass: #AddIntoMethodDescription
	instanceVariableNames: 'code order selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!AddIntoMethodDescription class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/27/2012 07:09'!
code: code order: order selector: selector

	^ self new
		code: code;
		order: order;
		selector: selector;
		yourself! !

!AddIntoMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:09'!
code
	^ code! !

!AddIntoMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:09'!
code: anObject
	code := anObject! !

!AddIntoMethodDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 2/27/2012 08:00'!
generateSpec
	
	^ { #addSourceCode:into:. self code. self selector }! !

!AddIntoMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:09'!
order
	^ order! !

!AddIntoMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:09'!
order: anObject
	order := anObject! !

!AddIntoMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:09'!
selector
	^ selector! !

!AddIntoMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:09'!
selector: anObject
	selector := anObject! !

AbstractDescription subclass: #AddMethodDescription
	instanceVariableNames: 'category selector source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!AddMethodDescription class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/27/2012 07:00'!
category: category source: source

	^ self new
		category: category;
		source: source;
		yourself! !

!AddMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:47'!
category
	^ category! !

!AddMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:47'!
category: anObject
	category := anObject! !

!AddMethodDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:50'!
generateSpec
	
	^ { #compileWithoutReturn:classified:.	self source.	self category.}! !

!AddMethodDescription methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/27/2012 07:07'!
initialize
	"Initialization code for AddMethodDescription"

	super initialize.

	category := ''.
	selector := ''.
	source := ''.! !

!AddMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:41'!
selector
	^ selector! !

!AddMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:41'!
selector: anObject
	selector := anObject! !

!AddMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:41'!
source
	^ source! !

!AddMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:41'!
source: anObject
	source := anObject! !

AbstractDescription subclass: #ComposableModelDescription
	instanceVariableNames: 'addClassDescription addInstVarDescriptions addMethodDescriptions addIntoMethodDescriptions specDescription superclass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 14:07'!
addClassDescription

	^ addClassDescription! !

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/5/2012 05:43'!
addClassDescription: aDescription

	addClassDescription := aDescription! !

!ComposableModelDescription methodsFor: 'protocol-basic' stamp: 'BenjaminVanRyseghem 2/28/2012 20:18'!
addClassNamed: name categorized: category

	addClassDescription := AddClassDescription
								category: category
								name: name.
								
	self addMethodWithSource: 'initialize
	
	super initialize' category: 'initialize'.! !

!ComposableModelDescription methodsFor: 'protocol-basic' stamp: 'BenjaminVanRyseghem 2/27/2012 08:01'!
addCodeTo: selector source: source order: order

	addIntoMethodDescriptions add: (AddIntoMethodDescription 
													code: source
													order: order
													selector: selector).! !

!ComposableModelDescription methodsFor: 'protocol-basic' stamp: 'BenjaminVanRyseghem 2/27/2012 07:56'!
addCodeToInitialize: source order: order

	addIntoMethodDescriptions add: (AddIntoMethodDescription 
													code: source
													order: order
													selector: #initialize).! !

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:58'!
addInstVarDescriptions
	^ addInstVarDescriptions! !

!ComposableModelDescription methodsFor: 'protocol-basic' stamp: 'BenjaminVanRyseghem 3/1/2012 21:45'!
addInstVarNamed: aString

	addInstVarDescriptions add: (AddInstVarDescription name: aString).
	self addMethodWithSource: aString, '
	
	^ ', aString category: 'accessing'! !

!ComposableModelDescription methodsFor: 'protocol-basic' stamp: 'BenjaminVanRyseghem 3/1/2012 21:53'!
addInstVarNamed: aString kindOf: aClass

	addInstVarDescriptions add: (AddInstVarDescription name: aString type: aClass).
	self addMethodWithSource: aString, '
	
	^ ', aString category: 'accessing'! !

!ComposableModelDescription methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/28/2012 14:01'!
addInstVarNamed: aString kindOf: aClass order: order

	self addInstVarNamed: aString kindOf: aClass.
	self addCodeToInitialize: aString, ' := ', aClass name, ' new' order: order! !

!ComposableModelDescription methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/27/2012 08:09'!
addInstVarNamed: aString kindOfComposablaeModel: aComposableModelClass

	self addInstVarNamed: aString kindOfComposablaeModel: aComposableModelClass order: 0! !

!ComposableModelDescription methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/28/2012 14:01'!
addInstVarNamed: aString kindOfComposablaeModel: aComposableModelClass order: order

	self addInstVarNamed: aString kindOf: aComposableModelClass.
	self addCodeToInitialize: aString, ' := self instantiate: ', aComposableModelClass name order: order! !

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:55'!
addIntoMethodDescriptions
	^ addIntoMethodDescriptions! !

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:58'!
addMethodDescriptions
	^ addMethodDescriptions! !

!ComposableModelDescription methodsFor: 'protocol-basic' stamp: 'BenjaminVanRyseghem 2/27/2012 07:48'!
addMethodWithSource: source category: category

	addMethodDescriptions add: (AddMethodDescription
										category: category
										source: source)! !

!ComposableModelDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 3/29/2012 10:14'!
finalize

	^ SpecInterpreter interpretASpec: self generate model: self superclass! !

!ComposableModelDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 3/2/2012 06:06'!
generateSpec
	| spec |
	spec := OrderedCollection new 
		addAll: (addClassDescription generateSpec);
		addAll: (addInstVarDescriptions gather: #generateSpec);
		addAll: (addMethodDescriptions gather: #generateSpec);
		addAll: ((addIntoMethodDescriptions sort: [:a :b | a order < b order ]) gather: #generateSpec);
		add: #theMetaClass;
		addAll: specDescription generate;
		add: #theNonMetaClass;
		yourself.
		
	^ spec addAll: {#theMetaClass. #compileWithoutReturn:classified:. 'generatingSpec
	
	^ ', (spec copy addFirst: #model;yourself) asArray storeString. 'generating'};yourself! !

!ComposableModelDescription methodsFor: 'initialization' stamp: 'bvr 5/31/2012 13:40'!
initialize
	"Initialization code for ComposableModelDescription"

	super initialize.
	
	addClassDescription := AddClassDescription new.
	addInstVarDescriptions := OrderedCollection new.
	addIntoMethodDescriptions := OrderedCollection new.
	addMethodDescriptions := OrderedCollection new.
	specDescription := SpecDescription new.
	
	superclass := ComposableModel.! !

!ComposableModelDescription methodsFor: 'protocol-basic' stamp: 'BenjaminVanRyseghem 3/30/2012 17:10'!
removeInstVar: anInstVar

	addInstVarDescriptions remove: anInstVar.! !

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2012 05:56'!
specDescription

	^ specDescription! !

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/5/2012 06:22'!
specDescription: aDescription

	specDescription := aDescription! !

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/29/2012 10:14'!
superclass
	^ superclass! !

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/29/2012 10:14'!
superclass: anObject
	superclass := anObject! !

AbstractDescription subclass: #SpecDescription
	instanceVariableNames: 'selector adds extra'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!SpecDescription methodsFor: 'protocol' stamp: 'bvr 6/4/2012 14:54'!
addInstVar: name fraction: fraction offset: offset
	
	self addInstVar: name spec: #defaultSpec fraction: fraction offset: offset! !

!SpecDescription methodsFor: 'protocol' stamp: 'bvr 6/4/2012 12:18'!
addInstVar: name spec: spec fraction: fraction offset: offset
	| col sub |
	
	spec
		ifNil: [ sub := {#model. name asSymbol} ]
		ifNotNil: [ sub := {#model. name asSymbol. spec asSymbol.} ].
	
	col := {#add:.	{sub.
											#layout:. 	{#LayoutFrame.
																#fractions:offsets:.	 fraction.	offset. }}}.
	adds add: col.! !

!SpecDescription methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/29/2012 10:22'!
addInstVarWrapper: wrapper

	adds add:  {#add:.	wrapper}.! !

!SpecDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/3/2012 01:35'!
adds

	^ adds contents! !

!SpecDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/3/2012 01:42'!
addsHolder

	^ adds! !

!SpecDescription methodsFor: 'private' stamp: 'bvr 6/4/2012 17:10'!
beginSpec

	^ #(ComposableSpec)! !

!SpecDescription methodsFor: 'private' stamp: 'bvr 6/4/2012 17:10'!
endSpec

	^ #()! !

!SpecDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 3/2/2012 06:21'!
generate
	| source |
	source := String streamContents: [:s | 
		s << self selector; cr;tab; << '<spec>';cr;tab;<<'^ ' ;<< self generateSpec printString ].
	
	^ { #compileWithoutReturn:classified:. source.	 'specs'.}! !

!SpecDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 3/2/2012 06:07'!
generateSpec
	| spec |
	spec := OrderedCollection new.
	spec addAll: self beginSpec.
	adds do: [:source | spec addAll: source ].
	spec addAll: self endSpec.
	^ spec asArray! !

!SpecDescription methodsFor: 'initialization' stamp: 'bvr 6/4/2012 14:54'!
initialize
	"Initialization code for SpecDescription"

	super initialize.

	adds := OrderedCollection new asValueHolder.
	selector := #defaultSpec.
	extra := ''.! !

!SpecDescription methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/2/2012 05:42'!
selector

	^ selector! !

!SpecDescription methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/2/2012 05:36'!
selector: aSelector

	selector := aSelector! !

!SpecDescription methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/2/2012 05:32'!
setExtra: source

	extra := source! !

Object subclass: #AbstractSpec
	instanceVariableNames: 'instance bindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!AbstractSpec commentStamp: '<historical>' prior: 0!
An AbstractSpec is a basic wrapper which describe a spec.

For now it can seems useless, but structural info will be stored thanks to those wrappers!

!AbstractSpec methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 18:39'!
addAsSubSpecTo: anotherSpec

	anotherSpec addSubSpec: self.! !

!AbstractSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 00:51'!
bindings

	^ bindings! !

!AbstractSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 00:51'!
bindings: anObject

	bindings := anObject! !

!AbstractSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 01:22'!
classSymbol

	self subclassResponsibility! !

!AbstractSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 10:47'!
defaultReceiver

	^ Smalltalk at: (self bindings retrieveClassSymbolFor: (self classSymbol))! !

!AbstractSpec methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 4/24/2012 10:47'!
initialize
	"Initialization code for AbstractSpec"

	super initialize.

	bindings := BindingsHolder new.! !

!AbstractSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 01:20'!
initializeInstance

	^ self defaultReceiver new.! !

!AbstractSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 01:19'!
instance

	^ instance ifNil: [ instance := self initializeInstance. ]! !

!AbstractSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 02:24'!
instance: anObject

	instance := anObject! !

!AbstractSpec methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 03:14'!
model: aModel

	"nothing by default"! !

!AbstractSpec methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 20:42'!
subSpecs

	^ #()! !

AbstractSpec subclass: #ButtonSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!ButtonSpec commentStamp: '<historical>' prior: 0!
A ButtonSpec is a spec used to describe a button!

!ButtonSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 02:48'!
classSymbol

	^ #Button! !

AbstractSpec subclass: #CheckboxSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!CheckboxSpec commentStamp: '<historical>' prior: 0!
A CheckboxSpec is a spec used to describe a CheckboxButton and a RadionButton!

!CheckboxSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 03:10'!
classSymbol

	^ #Checkbox! !

AbstractSpec subclass: #ComposableSpec
	instanceVariableNames: 'subSpecs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!ComposableSpec commentStamp: '<historical>' prior: 0!
A ComposableSpec is a spec used to combine other specs!

!ComposableSpec methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 19:43'!
addSubSpec: aSpec

	subSpecs add: aSpec! !

!ComposableSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 01:42'!
classSymbol

	^ #Panel! !

!ComposableSpec methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/6/2012 18:14'!
initialize
	"Initialization code for ComposableSpec"

	super initialize.

	subSpecs := OrderedCollection new.! !

!ComposableSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 6/11/2012 10:44'!
initializeInstance

	^ SpecInterpreter
		interpretASpec: 
			{ self classSymbol.
				#useProportionalLayout.
				#addSplitters.
				#vSpaceFill.
				#hSpaceFill.} 
		model: DummyComposableModel new! !

!ComposableSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/6/2012 19:17'!
subSpecs

	^ subSpecs! !

AbstractSpec subclass: #DropListSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!DropListSpec commentStamp: '<historical>' prior: 0!
A DropListSpec is a spec to describe a drop list!

!DropListSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 03:14'!
classSymbol

	^ #DropList! !

AbstractSpec subclass: #FrameLayoutSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!FrameLayoutSpec commentStamp: '<historical>' prior: 0!
A FrameLayoutSpec is for a FrameLayout!

!FrameLayoutSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/13/2012 03:08'!
classSymbol

	^ #FrameLayout! !

AbstractSpec subclass: #LabelSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!LabelSpec commentStamp: '<historical>' prior: 0!
A LabelSpec is a spec used to describe a label!

!LabelSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 03:14'!
classSymbol

	^ #Label! !

AbstractSpec subclass: #ListSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!ListSpec commentStamp: '<historical>' prior: 0!
A ListSpec is a spec used to describe a list!

ListSpec subclass: #IconListSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!IconListSpec commentStamp: '<historical>' prior: 0!
An IconListSpec is a spec use to describe a list with icons!

!IconListSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 03:15'!
classSymbol

	^ #IconList! !

!ListSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 01:21'!
classSymbol

	^ #List! !

ListSpec subclass: #MultiColumnListSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!MultiColumnListSpec commentStamp: '<historical>' prior: 0!
A MultiColumnListSpec is a spec used to describe a multi column list!

!MultiColumnListSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 03:15'!
classSymbol

	^ #MultiColumnList! !

AbstractSpec subclass: #NullObjectSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!NullObjectSpec commentStamp: '<historical>' prior: 0!
A NullObjectSpec is a NullPattern object spec!

!NullObjectSpec methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 18:40'!
addAsSubSpecTo: anotherSpec
! !

!NullObjectSpec methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 18:37'!
addSubSpec: anObject
	"absorb the message"! !

AbstractSpec subclass: #RawSpec
	instanceVariableNames: 'defaultReceiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

RawSpec class
	instanceVariableNames: 'counter'!

!RawSpec commentStamp: '<historical>' prior: 0!
A RawSpec is a spec used to describe whatever you want.

It simply works as a stack of interpreted symbols!

RawSpec class
	instanceVariableNames: 'counter'!

RawSpec subclass: #ModelSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!ModelSpec commentStamp: '<historical>' prior: 0!
A ModelSpec is a spec to describe a call to model!

!ModelSpec methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/13/2012 03:14'!
model: aModel

	self instance: aModel ! !

!RawSpec class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/13/2012 03:17'!
counter

	^ counter! !

!RawSpec class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/13/2012 03:18'!
counter: aNumber

	counter := aNumber ! !

!RawSpec class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/13/2012 03:17'!
new

	counter ifNil: [ counter := 1 ] ifNotNil: [ counter := counter +1 ].
	^ super new.! !

!RawSpec methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 18:40'!
addAsSubSpecTo: anotherSpec
! !

!RawSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 01:40'!
defaultReceiver

	^ defaultReceiver! !

!RawSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 01:40'!
defaultReceiver: anObject

	defaultReceiver := anObject! !

!RawSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/6/2012 18:27'!
defaultReceiver: aSymbol model: aModel

	defaultReceiver := SpecInterpreter interpretASpec: aSymbol model: aModel.! !

!RawSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 01:41'!
initializeInstance

	^ self defaultReceiver! !

AbstractSpec subclass: #SliderSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!SliderSpec commentStamp: '<historical>' prior: 0!
A SliderSpec is the spec used to describe a slider!

!SliderSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/12/2012 18:50'!
classSymbol

	^ #Slider! !

AbstractSpec subclass: #TextFieldSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!TextFieldSpec commentStamp: '<historical>' prior: 0!
A TextFieldSpec is a spec used to describe a text field!

!TextFieldSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 03:16'!
classSymbol

	^ #TextField! !

AbstractSpec subclass: #TextSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!TextSpec commentStamp: '<historical>' prior: 0!
A TextSpec is a spec used to describe a text area!

!TextSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 01:53'!
classSymbol

	^ #Text! !

AbstractSpec subclass: #TreeSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!TreeSpec commentStamp: '<historical>' prior: 0!
A TreeSpec is a spec used to describe a tree!

!TreeSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 03:17'!
classSymbol

	^ #Tree! !

AbstractSpec subclass: #WindowSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!WindowSpec commentStamp: '<historical>' prior: 0!
A WindowSpec is a spec used to describe a window!

WindowSpec subclass: #DialogWindowSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!DialogWindowSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/10/2012 15:55'!
classSymbol

	^ #DialogWindow! !

!DialogWindowSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/10/2012 16:07'!
initializeInstance

	^ self defaultReceiver basicNew.! !

!WindowSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/10/2012 15:10'!
classSymbol

	^ #Window! !

Object subclass: #AbstractSpecLayoutAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!AbstractSpecLayoutAction commentStamp: '<historical>' prior: 0!
AbstractSpecLayoutAction is an abstract class representing a spec layout action.!

!AbstractSpecLayoutAction methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/18/2012 04:47'!
asSpecElements

	self subclassResponsibility ! !

!AbstractSpecLayoutAction methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 15:10'!
generateArguments

	! !

AbstractSpecLayoutAction subclass: #SpecLayoutSend
	instanceVariableNames: 'arguments selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecLayoutSend commentStamp: '<historical>' prior: 0!
A SpecLayoutSend is a spec layout action used when a selector is sent to the layout!

SpecLayoutSend subclass: #SpecLayoutAdd
	instanceVariableNames: 'fractions offsets subwidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecLayoutAdd commentStamp: '<historical>' prior: 0!
A SpecLayoutAdd represents the action to add a subwidget into a spec layout!

!SpecLayoutAdd class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 04:42'!
subwidget: subwidget fractions: fractions offsets: offsets

	^ self new
		subwidget: subwidget 
		fractions: fractions 
		offsets: offsets;
		yourself! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:03'!
bottomFraction

	^ self fractions bottom! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:19'!
bottomFraction: aNumber

	^ self fractions: (self fractions bottom: aNumber)! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:03'!
bottomOffset

	^ self offsets bottom! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:19'!
bottomOffset: aNumber

	^ self offsets: (self offsets bottom: aNumber)! !

!SpecLayoutAdd methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:31'!
fractions
	^ fractions! !

!SpecLayoutAdd methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:31'!
fractions: anObject
	fractions := anObject! !

!SpecLayoutAdd methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/13/2012 03:16'!
generateArguments

	self arguments: {{subwidget .#layout:. {#FrameLayoutSpec. #fractions:offsets:. fractions. offsets}}}.! !

!SpecLayoutAdd methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/18/2012 04:50'!
initialize
	"Initialization code for SpecLayoutAdd"

	super initialize.
	
	self selector: #add:.

	fractions := nil.
	offsets := nil.
	subwidget := nil.! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:04'!
leftFraction

	^ self fractions left! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:19'!
leftFraction: aNumber

	^ self fractions: (self fractions left: aNumber)! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:03'!
leftOffset

	^ self offsets left! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:19'!
leftOffset: aNumber

	^ self offsets: (self offsets left: aNumber)! !

!SpecLayoutAdd methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:31'!
offsets
	^ offsets! !

!SpecLayoutAdd methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:31'!
offsets: anObject
	offsets := anObject! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:04'!
rightFraction

	^ self fractions right! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:19'!
rightFraction: aNumber

	^ self fractions: (self fractions right: aNumber)! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:03'!
rightOffset

	^ self offsets right! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:49'!
rightOffset: aNumber

	^ self offsets: (self offsets right: aNumber)! !

!SpecLayoutAdd methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:31'!
subwidget
	^ subwidget! !

!SpecLayoutAdd methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:31'!
subwidget: anObject
	subwidget := anObject! !

!SpecLayoutAdd methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 05:36'!
subwidget: aSpec fractions: frac offsets: off

	subwidget := aSpec isSymbol
				ifTrue: [{#model. aSpec}]
				ifFalse: [
					aSpec isCollection
						ifTrue: [
							aSpec isEmpty 
								ifTrue: [ "should raise an error" ]
								ifFalse: [ aSpec first == #model 
											ifTrue: [ aSpec ]
											ifFalse: [ {#model}, aSpec ]]]
						ifFalse: [ 
							"Not a symbol or a collection. We assume it's an object to add directly (like a morph by example)"
							aSpec ]].
	self fractions: frac.
	self offsets: off.
	
	self generateArguments! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:03'!
topFraction

	^ self fractions top! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:19'!
topFraction: aNumber

	^ self fractions: (self fractions top: aNumber )! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:03'!
topOffset

	^ self offsets top! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 18:23'!
topOffset: aNumber

	^ self offsets: (self offsets top: aNumber)! !

SpecLayoutAdd subclass: #SpecLayoutAddColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecLayoutAddColumn commentStamp: '<historical>' prior: 0!
A SpecLayoutAddColumn is an action representing the addition of a column to a layout!

!SpecLayoutAddColumn class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 05:21'!
block: aBlock fractions: frac offsets: off

	^ self new
			block: aBlock 
			fractions: frac
			offsets: off;
			yourself! !

!SpecLayoutAddColumn methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 06:06'!
block: aBlock fractions: frac offsets: off
	| column |
	
	column := SpecColumnLayout composed.
	aBlock value: column.
	subwidget := column asArray.
	self fractions: frac.
	self offsets: off.
	
	self generateArguments! !

SpecLayoutAdd subclass: #SpecLayoutAddRow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecLayoutAddRow commentStamp: '<historical>' prior: 0!
A SpecLayoutAddRow is an action representing the addition of a row to a layout
!

!SpecLayoutAddRow class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 06:37'!
block: aBlock fractions: frac offsets: off

	^ self new
			block: aBlock 
			fractions: frac
			offsets: off;
			yourself! !

!SpecLayoutAddRow methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/18/2012 18:00'!
block: aBlock fractions: frac offsets: off
	| row |
	
	row := SpecRowLayout composed.
	aBlock value: row.
	subwidget := row asArray.
	self fractions: frac.
	self offsets: off.
	
	self generateArguments! !

SpecLayoutAdd subclass: #SpecSplitterHorizontal
	instanceVariableNames: 'commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecSplitterHorizontal commentStamp: '<historical>' prior: 0!
A SpecSplitterHorizontal is a description of the addition of a horizontal splitter!

!SpecSplitterHorizontal class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/31/2012 15:11'!
commands: commands

	^ self new
		commands: commands;
		yourself! !

!SpecSplitterHorizontal methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/31/2012 15:11'!
commands
	
	^ commands! !

!SpecSplitterHorizontal methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/31/2012 15:11'!
commands: anObject
	
	commands := anObject! !

!SpecSplitterHorizontal methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 17:11'!
generateArguments
	| index |

	index := self commands identityIndexOf: self.

	self arguments: { index }! !

!SpecSplitterHorizontal methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/31/2012 16:10'!
initialize
	"Initialization code for SpecSplitterHorizontal"

	super initialize.

	selector := #newHSplitterAt:.
	fractions := 0@0 corner: 0@0.
	offsets := 0@0 corner: 0@1.
	commands := nil.! !

!SpecSplitterHorizontal methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 7/31/2012 15:38'!
isSplitter

	^ true! !

SpecLayoutAdd subclass: #SpecSplitterVertical
	instanceVariableNames: 'commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecSplitterVertical commentStamp: '<historical>' prior: 0!
A SpecSplitterVertical is the description of the addition of a vertical splitter!

!SpecSplitterVertical class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/31/2012 16:05'!
commands: commands

	^ self new
		commands: commands;
		yourself! !

!SpecSplitterVertical methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/31/2012 16:05'!
commands
	
	^ commands! !

!SpecSplitterVertical methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/31/2012 16:05'!
commands: anObject
	
	commands := anObject! !

!SpecSplitterVertical methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 16:05'!
generateArguments
	| index |

	index := self commands identityIndexOf: self.

	self arguments: { index }! !

!SpecSplitterVertical methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/31/2012 16:09'!
initialize
	"Initialization code for SpecSplitterHorizontal"

	super initialize.

	selector := #newVSplitterAt:.
	fractions := 0@0 corner: 0@0.
	offsets := 0@0 corner: 1@0.
	commands := nil.! !

!SpecSplitterVertical methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 7/31/2012 16:05'!
isSplitter

	^ true! !

SpecLayoutSend subclass: #SpecLayoutAddWithSpec
	instanceVariableNames: 'fractions offsets subwidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecLayoutAddWithSpec commentStamp: '<historical>' prior: 0!
A SpecLayoutAddWithSpec is an action representing an add in the spec layout with a spec selector precised!

!SpecLayoutAddWithSpec class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 04:59'!
subwidget: subwidget spec: aSpecSelector fractions: fractions offsets: offsets

	^ self new
		subwidget: subwidget 
		spec: aSpecSelector 
		fractions: fractions 
		offsets: offsets;
		yourself! !

!SpecLayoutAddWithSpec methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/13/2012 03:16'!
generateArguments

	self arguments: {{subwidget .#layout:. {#FrameLayoutSpec. #fractions:offsets:. fractions. offsets}}}.! !

!SpecLayoutAddWithSpec methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 05:37'!
subwidget: sub spec: aSpecSelector fractions: frac offsets: off

	self subwidget: (sub isArray 
						ifTrue: [ #(model), sub , {aSpecSelector} ]
						ifFalse: [ {#model. sub . aSpecSelector } ]).
						
	self fractions: frac.
	self offsets: off.
	self generateArguments! !

!SpecLayoutSend class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 04:49'!
selector: selector arguments: arguments

	^ self new
		arguments: arguments;
		selector: selector;
		yourself! !

!SpecLayoutSend methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:49'!
arguments
	
	^ arguments! !

!SpecLayoutSend methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:49'!
arguments: anObject
	
	arguments := anObject! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/18/2012 05:07'!
asSpecElements

	^ {self selector.}, self arguments! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
bottomFraction

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:10'!
bottomFraction: aNumber

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
bottomOffset

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:10'!
bottomOffset: aNumber

	^ 0! !

!SpecLayoutSend methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 7/31/2012 15:52'!
isSplitter

	^ false! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
leftFraction

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:10'!
leftFraction: aNumber

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
leftOffset

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:10'!
leftOffset: aNumber

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
rightFraction

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:10'!
rightFraction: aNumber

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
rightOffset

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
rightOffset: aNumber

	^ 0! !

!SpecLayoutSend methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:49'!
selector
	
	^ selector! !

!SpecLayoutSend methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:49'!
selector: anObject
	
	selector := anObject! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
topFraction

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
topFraction: aNumber

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
topOffset

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:10'!
topOffset: aNumber

	^ 0! !

Object subclass: #BindingsHolder
	instanceVariableNames: 'bindings'
	classVariableNames: 'Bindings'
	poolDictionaries: ''
	category: 'Spec-Bindings'!

!BindingsHolder commentStamp: '<historical>' prior: 0!
A BindingsHolder is a simple wrapper to manage the bindings!

!BindingsHolder class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 10:36'!
bindings

	^ Bindings ifNil: [ Bindings := self defaultBindings ]! !

!BindingsHolder class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 10:37'!
defaultBindings

	^ MorphicBindings new! !

!BindingsHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 10:30'!
bindings

	^ bindings! !

!BindingsHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 10:30'!
bindings: anObject

	bindings := anObject! !

!BindingsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/24/2012 10:36'!
classSymbolFor: aSymbol ifAbsent: aBlock

	^ bindings classSymbolFor: aSymbol ifAbsent: aBlock! !

!BindingsHolder methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 4/24/2012 10:34'!
initialize
	"Initialization code for BindingsHolder"

	super initialize.

	bindings := MorphicBindings new.! !

!BindingsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/24/2012 10:29'!
retrieveClassSymbolFor: aSymbol

	^ self bindings
		ifNil: [ self retrieveDefaultClassSymbolFor: aSymbol ]
		ifNotNil: [:bdg | bdg classSymbolFor: aSymbol ifAbsent: [ self retrieveDefaultClassSymbolFor: aSymbol ]]! !

!BindingsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/24/2012 10:29'!
retrieveDefaultClassSymbolFor: aSymbol

	^ self class bindings classSymbolFor: aSymbol ifAbsent: [ aSymbol ]! !

!BindingsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/24/2012 10:29'!
retrieveDefaultSelectorSymbolFor: aSymbol

	^ self class bindings selectorSymbolFor: aSymbol ifAbsent: [ aSymbol ]! !

!BindingsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/24/2012 10:29'!
retrieveSelectorSymbolFor: aSymbol

	^ self bindings
		ifNil: [ self retrieveDefaultSelectorSymbolFor: aSymbol ]
		ifNotNil: [:binding | binding selectorSymbolFor: aSymbol ifAbsent: [ self retrieveDefaultSelectorSymbolFor: aSymbol ]]! !

!BindingsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/24/2012 10:35'!
selectorSymbolFor: aSymbol ifAbsent: aBlock

	^ bindings selectorSymbolFor: aSymbol ifAbsent: aBlock! !

Object subclass: #ConfigurationGenerator
	instanceVariableNames: 'repository workingCopy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Monticello'!

!ConfigurationGenerator commentStamp: '<historical>' prior: 0!
Probably to be removed to use metacello toolbox!

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:00'!
addMetacelloBaseline
	| baselineNumber existingBaselines msg selectorName  addedPackages package stream packagePattern |
	
	"0 -- must have a repository selected"
	repository isNil 
		ifTrue: [ 
			UIManager default inform: 'Please select a repository and try again'. 
			^self ].
	"1 -- Selecting baseline name"
	existingBaselines := self baseLines. 
	
	existingBaselines size > 0  
		ifTrue: [msg := 'Current baselines:', String cr, (existingBaselines inject: '' into: [:sum :el | sum, el, String cr]), 'Enter a new baseline number']
		ifFalse: [msg := 'Enter a new baseline number ("-baseline" will be automatically added)'].
		
	baselineNumber := UIManager default request: msg initialAnswer: '1.0'.
	baselineNumber ifNil: [ ^ self ].
	
	"2 -- add package names"
	addedPackages := OrderedCollection new.
	packagePattern := UIManager default request: 'Please enter a pattern to filter package names' initialAnswer: '*'.
	[ | packageNames workingCopies |
	 packageNames := OrderedCollection new.
	workingCopies := OrderedCollection new.
	self workingCopies do: [:pkg | 
		((packagePattern match: pkg package name) and: [ (addedPackages includes: pkg package name) not ])
			ifTrue: [ 
				packageNames add: pkg package name.
				workingCopies add: pkg ]].
	 package := 
		UIManager default 
			chooseFrom: packageNames
			values: workingCopies
			title: 'Add dependent package (cancel to stop)'.
	 package ifNotNil: [addedPackages add: package package name ]
	] doWhileTrue: [ package notNil ].

	
	"3 -- Creating baseline"
	selectorName := baselineNumber copyWithoutAll: '.-'.
	stream := WriteStream on: String new.
	stream nextPutAll: 'baseline'.
	stream nextPutAll: selectorName.
	stream nextPutAll: ': spec 
        <version: '''.
	stream nextPutAll: baselineNumber.
	stream nextPutAll: '-baseline''>
        
        spec for: #common do: [
                spec blessing: #baseline.
                spec repository: '''.

	stream nextPutAll: repository description.
	stream nextPutAll: '''.    
                "spec 
                        package: ''Example-Core'';
                        package: ''Example-Tests'' with: [ spec requires: ''Example-Core'' ]"
'.
	addedPackages 
		do: [:pName | stream nextPutAll: '			spec package: ''', pName, '''.', String cr].
	stream nextPutAll: '                ].'.

	self configurationClass compile: stream contents classified: 'baselines'.
! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
baseLines 
	| existingBaselines |
	existingBaselines := self configurationClass methods select: [:cm | cm selector beginsWith: 'baseline'].
	existingBaselines := (existingBaselines collect: [:m | m pragmas first argumentAt: 1]) asSortedCollection.
	^ existingBaselines! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
browseConfiguration
	self configurationClass browse! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
configurationClass
	^ Smalltalk globals at: workingCopy package name asSymbol ! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
createDevelopmentVersion
	self hasAnyBaseline 
		ifFalse: [ UIManager default inform: 'Please, define a baseline first'. ^ self ].
	^ self createVersionForBlessing: #development! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
createReleaseVersion
	self hasAnyBaseline 
		ifFalse: [ UIManager default inform: 'Please, define a baseline first'. ^ self ].
		
	^ self createVersionForBlessing: #release! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
createVersionForBlessing: blessingSelector
	"blessingSelector = #release or #development"
	 
	| existingVersions msg initialAnswer newVersionNumber selectorName stream dependentPackages mcWorkingCopy |
	existingVersions := self configurationClass methods select: [:cm | cm selector beginsWith: 'version'].
	existingVersions := (existingVersions collect: [:m | m pragmas first argumentAt: 1]) asSortedCollection.
	
	msg := ''.
	existingVersions size > 4
		ifTrue: [ 
			msg := 'Last 4 versions: ', 
			(existingVersions copyFrom: (existingVersions size - 4) to: existingVersions size)
				 asArray printString, String cr ].
	
	existingVersions size > 0
		ifTrue: [ initialAnswer := existingVersions last, '.1' ]
		ifFalse: [ initialAnswer := '1.0' ].
	
	newVersionNumber := UIManager default request: msg initialAnswer: initialAnswer.
	newVersionNumber ifNil: [ ^ self ].

	selectorName := newVersionNumber copyWithoutAll: '.-'.
	stream := WriteStream on: String new.
	stream nextPutAll: 'version'.
	stream nextPutAll: selectorName.
	stream nextPutAll: ': spec 
        <version: '''.
	stream nextPutAll: newVersionNumber.
	stream nextPutAll: ''' imports: #(''', self lastBaseLine,''')>

        spec for: #common do: [
                spec blessing: ',blessingSelector printString,'.
'.

	self dependentPackages 
		do: [:pName | 
				stream nextPutAll: '			spec package: ''', pName, ''' with: '''.
							
				mcWorkingCopy := (MCPackage named: pName) workingCopy.
				mcWorkingCopy needsSaving ifTrue: [ self inform: 'The configuration you want to save depends on the package ', pName, '. You first need to save this package in order to create the version'. ^ self ].
				stream nextPutAll: (mcWorkingCopy ancestry ancestors first name).
			
				stream nextPutAll: '''.', String cr ].
	stream nextPutAll: '                ].'.

	self configurationClass compile: stream contents classified: 'versions'.

! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
dependentPackages
	"Return the list of dependent packages for the last baseline"

	"This method must be rewritten. It is a shame..."
	
	| lastBaseLineName lastBaseLineMethod versionConstructor versionSpec possiblePackageNames packageInfos packageNames |
	lastBaseLineName := self lastBaseLine.

	packageNames := OrderedCollection new.
	(self configurationClass project version: lastBaseLineName)
		record loadDirective packageDirectivesDo: [:directive |
			packageNames add: directive file ].
		
	^ packageNames collect: [:p | 
		(p includes: $.)
			ifTrue: [ (p includes: $-)
						ifTrue: [ (p copyUpToLast: $-) ]
						ifFalse: [ (p copyUpTo: $.) ] ]
			ifFalse: [ p ]
		]

"	lastBaseLineMethod := (self configurationClass methods 
							select: [:cm | cm selector beginsWith: 'baseline'])
								select: [:cm | cm pragmas first arguments first = lastBaseLineName].
	lastBaseLineMethod := lastBaseLineMethod first.
"	
	"This does not work!! No idea why!!"
"	versionConstructor := (Smalltalk at: #MetacelloVersionConstructor) new.
	self configurationClass new perform: lastBaseLineMethod selector with: versionConstructor.
	versionSpec := (Smalltalk at: #MetacelloVersionSpec) new.
	versionConstructor root: versionSpec
"
	"This is probably the ugliest piece of code I ever wrote. There is really nothing to be proud of."
"	possiblePackageNames := 
		((lastBaseLineMethod literals select: [ :l | l class == ByteString ])
			reject: [:l | l beginsWith: 'http']).
	packageInfos := PackageInfo allPackages select: [ :pi | possiblePackageNames includes: pi packageName ].
"
	"packageInfos now contains the package that the lastest baseline depends on"
	"^ packageInfos collect: #packageName"

	! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
hasAnyBaseline 
	^ self baseLines notEmpty! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
lastBaseLine
	^ self baseLines last! !

Object subclass: #MorphWrapper
	instanceVariableNames: 'layout morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets-Utilities'!

!MorphWrapper commentStamp: '<historical>' prior: 0!
A MorphWrapper is used to wrap a morph with a layout in the goal to be easily added to another morph!

!MorphWrapper class methodsFor: 'instance creation' stamp: ''!
morph: morph layout: layout 

	^ self new
		layout: layout;
		morph: morph;
		yourself! !

!MorphWrapper methodsFor: 'adding' stamp: ''!
addIn: aContainer
		
	aContainer
		addMorph: morph
		fullFrame: layout! !

!MorphWrapper methodsFor: 'accessing' stamp: ''!
frame: relFrame
	| frame |
	frame := LayoutFrame new.
	frame 
		leftFraction: relFrame left; 
		rightFraction: relFrame right; 
		topFraction: relFrame top; 
		bottomFraction: relFrame bottom.
	layout := frame! !

!MorphWrapper methodsFor: 'accessing' stamp: ''!
fullFrame: anObject
	
	layout := anObject! !

!MorphWrapper methodsFor: 'accessing' stamp: ''!
morph: anObject
	
	morph := anObject! !

Object subclass: #NewValueHolder
	instanceVariableNames: 'announcer contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!NewValueHolder commentStamp: '<historical>' prior: 0!
A NewValueHolder is a new implementation of ValueHolder based on Announcements!

NewValueHolder subclass: #CollectionValueHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!CollectionValueHolder commentStamp: '<historical>' prior: 0!
A CollectionValueHolder is s a value holder designed for collections!

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
add: newObject

	| result |
	result := contents add: newObject.
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
add: newObject after: oldObject 
	
	| result |
	result := contents add: newObject after: oldObject.
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
add: newObject afterIndex: index 
	
	| result |
	result := contents add: newObject afterIndex: index.
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
add: newObject before: oldObject
	
	| result |
	result := contents add: newObject before: oldObject.
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
add: newObject beforeIndex: index 
	
	| result |
	result := contents add: newObject beforeIndex: index.
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addAll: aCollection 
	
	| result |
	result := contents addAll: aCollection.
	self contentsChanged: aCollection.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addAllFirst: anOrderedCollection
	
	| result |
	result := contents addAllFirst: anOrderedCollection.
	self contentsChanged: anOrderedCollection.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addAllFirstUnlessAlreadyPresent: anOrderedCollection
	
	| result |
	result := contents addAllFirstUnlessAlreadyPresent: anOrderedCollection.
	self contentsChanged: anOrderedCollection.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addAllLast: aCollection 
	
	| result |
	result := contents addAllLast: aCollection.
	self contentsChanged: aCollection.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addFirst: newObject 

	| result |
	result := contents addFirst: newObject .
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addLast: newObject 

	| result |
	result := contents addLast: newObject .
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
at: index ifAbsentPut: block

	| result |
	result := contents at: index ifAbsentPut: block.
	self contentsChanged: block value.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
at: index put: value

	| result |
	result := contents at: index put: value.
	self contentsChanged: value.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
atAll: aCollection put: anObject 
	
	| result |
	result := contents atAll: aCollection put: anObject .
	self contentsChanged: anObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
atAll: indexArray putAll: valueArray
	
	| result |
	result := contents atAll: indexArray putAll: valueArray.
	self contentsChanged: valueArray.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
atAllPut: anObject 
	
	| result |
	result := contents atAllPut: anObject.
	self contentsChanged: anObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
atLast: indexFromEnd put: obj
	
	| result |
	result := contents atLast: indexFromEnd put: obj.
	self contentsChanged: obj.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
atWrap: index put: value
	
	| result |
	result := contents atWrap: index put: value.
	self contentsChanged: value.
	^ result! !

!CollectionValueHolder methodsFor: 'private' stamp: ''!
doesNotUnderstand: aMessage

	^ (contents respondsTo: aMessage selector)
		ifTrue: [ contents perform: aMessage selector withEnoughArguments: aMessage arguments ]
		ifFalse: [ super doesNotUnderstand: aMessage ]! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
insert: anObject before: spot

	| result |
	result := contents insert: anObject before: spot.
	self contentsChanged: anObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
remove: oldObject ifAbsent: absentBlock

	| result |
	result := contents remove: oldObject ifAbsent: absentBlock.
	self contentsChanged: oldObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeAll

	contents removeAll.
	self contentsChanged! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeAt: index

	| result |
	result := contents removeAt: index.
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeFirst

	| result |
	result := contents removeFirst.
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeFirst: n 

	| result |
	result := contents removeFirst: n .
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeIndex: removedIndex

	| result |
	result := contents removeIndex: removedIndex.
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeLast

	| result |
	result := contents removeLast.
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeLast: n

	| result |
	result := contents removeLast: n.
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
replace: aBlock 

	contents replace: aBlock .
	self contentsChanged! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
replaceAll: oldObject with: newObject 

	contents replaceAll: oldObject with: newObject .
	self contentsChanged: oldObject! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
reset

	contents reset.
	self contentsChanged! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
resetTo: index

	contents resetTo: index.
	self contentsChanged! !

!CollectionValueHolder methodsFor: 'override' stamp: ''!
size 

	^ contents size! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
sort: aSortBlock 

	contents sort: aSortBlock .
	self contentsChanged! !

NewValueHolder subclass: #DictionaryValueHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!DictionaryValueHolder commentStamp: '<historical>' prior: 0!
A DictionaryValueHolder is a value holder designed for dictionaries!

!DictionaryValueHolder methodsFor: 'override' stamp: ''!
at: anObject

	^ contents at: anObject! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 20:29'!
at: key ifAbsentPut: aBlock 

	^ self at: key ifAbsent: [self at: key put: aBlock value]! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
at: key put: value

	contents at: key put: value.
	self contentsChanged: value! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
atNewIndex: index put: anObject
	
	contents atNewIndex: index put: anObject.
	self contentsChanged: anObject.! !

!DictionaryValueHolder methodsFor: 'initialization' stamp: ''!
contents

	self error: 'The contents should be accessed directly or you could break the mechanism of events'.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
doesNotUnderstand: aMessage

	^ (contents respondsTo: aMessage selector)
		ifTrue: [ contents perform: aMessage selector withEnoughArguments: aMessage arguments ]
		ifFalse: [ super doesNotUnderstand: aMessage ]! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
fillFrom: aCollection with: aBlock
	"Evaluate aBlock with each of aCollections's elements as the argument.  
	Collect the resulting values into self. Answer self."

	aCollection keysAndValuesDo: [ :key :value |
		self at: key put: (aBlock value: value) ]! !

!DictionaryValueHolder methodsFor: 'initialization' stamp: ''!
initialize
	"Initialization code for DictionaryValueHolder"

	super initialize.
	self contents: Dictionary new.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
initialize: n
	
	contents initialize: n.
	self contentsChanged.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
removeAll
	
	contents removeAll.
	self contentsChanged.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
removeKey: key 
	"Remove key from the receiver.
	If key is not in the receiver, notify an error."
	
	^ self removeKey: key ifAbsent: [self errorKeyNotFound: key].! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
removeKey: key ifAbsent: aBlock 
	| result |
	
	result := contents removeKey: key ifAbsent: aBlock.
	self contentsChanged.
	^ result! !

!DictionaryValueHolder methodsFor: 'override' stamp: ''!
size 

	^ contents size! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
valueAtNewKey: aKey put: anObject atIndex: index declareFrom: aDictionary 
	
	contents valueAtNewKey: aKey put: anObject atIndex: index declareFrom: aDictionary.
	self contentsChanged.! !

!NewValueHolder class methodsFor: 'instance creation' stamp: ''!
contents: contents

	^ self new
		contents: contents;
		yourself! !

!NewValueHolder methodsFor: 'announcements' stamp: ''!
addDependent: aDependent

	self halt: 'Former API, should be changed'.! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
contents

	^ contents! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
contents: anObject
	
	| oldValue |
	oldValue := contents.
	contents := anObject.
	self contentsChanged: oldValue.! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
contentsChanged
	
	announcer announce: (ValueChanged newContents: contents)! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
contentsChanged: oldValue
	
	announcer announce: (ValueChanged oldContents: oldValue newContents: contents)! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
contentsChanged: oldValue to: newValue
	
	announcer announce: (ValueChanged oldContents: oldValue newContents: newValue)! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
initialize

	super initialize.
	
	announcer := Announcer new! !

!NewValueHolder methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 7/13/2012 01:46'!
whenChangedDo: aBlock

	| block |
	block := [:announcement :ann | aBlock cull: announcement newContents cull: announcement oldContents cull: announcement cull: ann ].
	announcer weak on: ValueChanged do: block! !

!NewValueHolder methodsFor: 'announcements' stamp: ''!
whenChangedSend: aSelector to: aReceiver

	announcer on: ValueChanged send: aSelector to: aReceiver! !

NewValueHolder subclass: #SelectionValueHolder
	instanceVariableNames: 'index selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!SelectionValueHolder commentStamp: '<historical>' prior: 0!
A SelectionValueHolder is a value holder especially designed to contains a list selection (an index + an object)!

!SelectionValueHolder class methodsFor: 'as yet unclassified' stamp: ''!
index: indexValueHolder selection: selectionValueHolder

	^ self new
		index: indexValueHolder;
		selection: selectionValueHolder;
		yourself! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
contents

	^ {index. selection}! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
index

	^ index! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
index: anIndex

	index := anIndex.
	self changed: #index! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
initialize

	super initialize.
	index := 0 asValueHolder.
	selection := nil asValueHolder.
	
	index whenChangedSend: #contentsChanged to: self.
	selection whenChangedSend: #contentsChanged to: self.! !

!SelectionValueHolder methodsFor: 'protocol' stamp: ''!
reset

	self index contents: 0.
	self selection contents: nil.
	self contentsChanged! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
selection

	^ selection! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
selection: aSelection

	selection := aSelection.
	self changed: #selection! !

Object subclass: #NewVersionBrowser
	instanceVariableNames: 'list class selector browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-VersionBrowser'!

!NewVersionBrowser commentStamp: '<historical>' prior: 0!
A NewVersionBrowser is a tool made for browsing the several versions of the provided method.!

!NewVersionBrowser class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/14/2012 09:56'!
browseVersionsOf: method class: class meta: meta category: msgCategory selector: selector 
	
	^ self new 
			browseVersionsOf: method 
			class: class 
			meta: meta 
			category: msgCategory 
			selector: selector! !

!NewVersionBrowser methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/14/2012 11:50'!
browseVersionsOf: method class: aClass meta: meta category: msgCategory selector: aSelector

	class := meta 
		ifTrue: [ aClass theMetaClass ]
		ifFalse: [ aClass  theNonMetaClass ].

	selector := aSelector.
	
	^ self buildBrowser! !

!NewVersionBrowser methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/3/2012 13:55'!
browserForList: aList

	browser:=  MessageBrowser new.
	browser
		textConverter: DiffMethodReferenceConverter new;
		topologicSort: false;
		sortingBlock: [:a :b | a timeStamp > b timeStamp ];
		displayBlock: [:changeRecord | {	changeRecord stamp firstWord. 
											changeRecord timeStamp asString.
											changeRecord class name.
											changeRecord methodSelector.
											'{',changeRecord  category,'}'} ].
	browser toolbarModel setDropListItems: {	DropListItem named: 'Diff' do: [ browser textConverter: (DiffChangeRecordConverter methodReference: browser textConverter method referencesList: aList) ].
									DropListItem named: 'Source' do: [ browser textConverter: (SourceMethodConverter method: browser textConverter method) ]}.
									
	browser toolbarModel versionModel 
		label: 'Revert';
		action: [ self revert: browser selectedItem ].
										
	^ browser.! !

!NewVersionBrowser methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/14/2012 11:40'!
buildBrowser
	| changeList |
	
	changeList := self buildChangeList.
	self browserForList: changeList.
	
	^ browser
		messages: changeList;
		title: 'Versions of ' , class name , '>>' , selector;
		openWithSpec! !

!NewVersionBrowser methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/14/2012 11:50'!
buildChangeList
	| method |
	
	(class isNil or: [ selector isNil ])	ifTrue: [ ^ #() ].
	method := (class>>selector).
		
	^ self
		scanVersionsOf: method
		class: class theNonMetaClass
		meta: class isMeta
		category: method category
		selector: selector.! !

!NewVersionBrowser methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/14/2012 11:44'!
revert: aChangeRecord

	aChangeRecord 
		ifNil: [self inform: 'nothing selected, so nothing done']
		ifNotNil: [ class ifNotNil: [ class compile: aChangeRecord string ]].
	
	browser 
		messages: self buildChangeList;
		setSelectedIndex: 1.! !

!NewVersionBrowser methodsFor: 'copy and paste' stamp: 'BenjaminVanRyseghem 6/14/2012 10:00'!
scanVersionsOf: method class: class meta: meta category: cat selector: selector

	^ ChangeSet scanVersionsOf: method class: class meta: meta category: cat selector: selector! !

!Object methodsFor: '*Spec-Core' stamp: ''!
asValueHolder

	^ NewValueHolder contents: self! !

!Object methodsFor: '*Spec-Core' stamp: 'BenjaminVanRyseghem 6/18/2012 05:26'!
isSpecLayout

	^ false! !

Object subclass: #RadioButtonGroup
	instanceVariableNames: 'buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Widgets-Utilities'!

!RadioButtonGroup commentStamp: '<historical>' prior: 0!
A RadioButtonGroup is a group for radio buttons which ensure that only radio button of this group is activated at the same time.!

!RadioButtonGroup methodsFor: 'protocol' stamp: ''!
addRadioButton: aButton

	buttons do: [:b | 
		aButton whenActivatedDo: [ b privateSetState: false ].
		b whenActivatedDo: [ aButton privateSetState: false ]].
		
	buttons add: aButton.
	aButton privateSetState: false! !

!RadioButtonGroup methodsFor: 'protocol' stamp: ''!
default: aButton

	aButton privateSetState: true.
	aButton takeKeyboardFocus.! !

!RadioButtonGroup methodsFor: 'initialization' stamp: ''!
initialize
	"Initialization code for RadioButtonGroup"

	super initialize.

	buttons := OrderedCollection new.! !

Object subclass: #SpecBinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

SpecBinder class
	instanceVariableNames: 'bindings'!

!SpecBinder commentStamp: '<historical>' prior: 0!
A SpecBinder is a stupid dictionary where keys are spec symbolic name and values are corresponding spec class!

SpecBinder class
	instanceVariableNames: 'bindings'!

!SpecBinder class methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 4/27/2012 09:59'!
initialize

	self initializeBindings! !

!SpecBinder class methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/13/2012 03:19'!
initializeBindings
	"self initializeBindings"
	bindings := IdentityDictionary new.
	bindings
		at: #ListSpec put: ListSpec;
		at: #MultiColumnListSpec put: MultiColumnListSpec;
		at: #IconListSpec put: IconListSpec;
		at:#model put: ModelSpec;
		at: #RawSpec put: RawSpec;
		at: #ComposableSpec put: ComposableSpec;
		at: #TextSpec put: TextSpec;
		at: #ButtonSpec put: ButtonSpec;
		at: #CheckboxSpec put: CheckboxSpec;
		at: #DropListSpec put: DropListSpec;
		at: #LabelSpec put: LabelSpec;
		at: #FrameLayoutSpec put: FrameLayoutSpec;
		at: #TextFieldSpec put: TextFieldSpec;
		at: #TreeSpec put: TreeSpec;
		at: #WindowSpec put: WindowSpec;
		at:#DialogWindowSpec put: DialogWindowSpec;
		at: #SliderSpec put: SliderSpec! !

!SpecBinder class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/24/2012 01:55'!
specFor: aSymbol

	^ bindings at: aSymbol ! !

!SpecBinder class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/24/2012 01:56'!
specFor: aSymbol ifAbsent: aBlock

	^ bindings at: aSymbol ifAbsent: aBlock! !

!SpecBinder methodsFor: 'see class side' stamp: 'BenjaminVanRyseghem 4/24/2012 03:37'!
seeClassSide! !

Object subclass: #SpecBuilder
	instanceVariableNames: 'toto titi'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!SpecBuilder class methodsFor: 'experimentation' stamp: 'BenjaminVanRyseghem 2/28/2012 14:04'!
example
	| cmd |
	cmd := ComposableModelDescription new.
	cmd addClassNamed: #SpecTest categorized: 'Spec-Builder'.
	cmd addInstVarNamed: 'toto' kindOfComposablaeModel: TextModel.
	cmd addInstVarNamed: 'titi' kindOf: NewValueHolder.
	cmd addMethodWithSource: 'test1 ^1' category: 'test'.
	cmd addMethodWithSource: 'test2 ^2' category: 'test'.
	cmd addCodeToInitialize: 'self test2.' order: 2.
	cmd addCodeToInitialize: 'self test1' order: 1.

	SpecInterpreter interpretASpec: cmd generate model: ComposableModel.


! !

!SpecBuilder class methodsFor: 'experimentation' stamp: 'SeanDeNigris 6/26/2012 16:57'!
example2
	| d spec desc |
	d := ComposableModelDescription new addClassNamed: 'NewClass2' categorized: 'Spec-Builder'.

	InstVarSetter new
		description: d;
		openWithSpec.
		
	SpecSetter new
		description: d;
		openWithSpec.
		
	d finalize.
	spec := (Smalltalk at: #NewClass2) generatingSpec.
	desc := (SpecImporter import: spec).

	desc finalize! !

!SpecBuilder class methodsFor: 'experimentation' stamp: 'BenjaminVanRyseghem 2/27/2012 06:36'!
exp1

	^{#model.
		#addInstVarNamed:. 'toto'.
		#compile:classified:. 	'method	^ true'. 'test'}! !

!SpecBuilder methodsFor: 'test' stamp: 'BenjaminVanRyseghem 2/27/2012 06:57'!
iAmATest

	^ 'I am a test'! !

!SpecBuilder methodsFor: 'test' stamp: 'BenjaminVanRyseghem 2/27/2012 06:36'!
method	^ true! !

Object subclass: #SpecImporter
	instanceVariableNames: 'desc order'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder-Importer'!

SpecImporter subclass: #SpecDescriptionImporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder-Importer'!

!SpecDescriptionImporter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/5/2012 06:21'!
defaultDescription

	^ SpecDescription new! !

!SpecDescriptionImporter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/29/2012 10:22'!
import: aSpec

	| copy first |
	copy := aSpec asOrderedCollection copy.
	first := copy removeFirst.
	first = #Panel
		ifTrue: [
			copy removeFirst.
			^ self import: copy ].
	first = #add:
		ifTrue: [ 
				desc addInstVarWrapper: copy removeFirst.
				^ self import: copy ].
	^ desc! !

!SpecImporter class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/5/2012 06:21'!
import: aSpec

	^ self new
		import: aSpec! !

!SpecImporter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/5/2012 06:21'!
defaultDescription

	^ ComposableModelDescription new! !

!SpecImporter methodsFor: 'importing' stamp: 'BenjaminVanRyseghem 3/29/2012 10:08'!
import: aSpec

	| copy first |
	copy := aSpec asOrderedCollection copy.
	first := copy removeFirst.
	first = #model
		ifTrue: [ ^ self import: copy ].
	first = #subclass:category:
		ifTrue: [ | category name | 
			name := copy removeFirst.
			category := copy removeFirst.
			desc addClassDescription: (AddClassDescription category: category name: name).
			^ self import: copy ].
	first = #addInstVarNamed:type:
		ifTrue: [ 
			desc addInstVarDescriptions add: (AddInstVarDescription name: copy removeFirst type: copy removeFirst).
			^ self import: copy ].
	first = #compileWithoutReturn:classified:
		ifTrue: [ | category source |
			source := copy removeFirst.
			category := copy removeFirst.
			desc addMethodDescriptions add: (AddMethodDescription category: category source: source).
			^ self import: copy ].
	first = #addSourceCode:into:
		ifTrue: [
			desc addIntoMethodDescriptions add: (AddIntoMethodDescription code: copy removeFirst order: order selector: copy removeFirst).
			order := order +1.
			^ self import: copy ].
	first = #theMetaClass
		ifTrue: [ | source index newSpec |
			"for now I only compile method on class side"
			copy removeFirst.
			source := copy removeFirst.
			index := source indexOf: ${.
			source := source copyFrom: index to: source size.
			newSpec := self class compilerClass evaluate: source.
			desc specDescription: (SpecDescriptionImporter import: newSpec).
			^ self import: copy ].
	^ desc.! !

!SpecImporter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/5/2012 06:21'!
initialize
	"Initialization code for SpecImporter"

	super initialize.
	desc := self defaultDescription.
	order := 0! !

Object subclass: #SpecInterpreter
	instanceVariableNames: 'model spec superSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!SpecInterpreter commentStamp: '<historical>' prior: 0!
A SpecInterpreter is a interpreter for spec presenters!

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
buildMorphFor: aComposableModel
	
	^ self new buildMorphFor: aComposableModel! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
buildMorphFor: aComposableModel withSpec: aSymbol
	
	^ self new buildMorphFor: aComposableModel withSpec: aSymbol! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
buildWindowFor: aComposableModel
	
	^ self new buildWindowFor: aComposableModel! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
interpretASpec: aSpec model: aModel
	
	^ self new
		interpretASpec: aSpec
		model: aModel! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 18:25'!
interpretASpec: aPresenter model: aModel superSpec: aSpec
	
	^ self new
		interpretASpec: aPresenter
		model: aModel
		superSpec: aSpec! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
actionToPerformWithSelector: selector arguments: args
	^ spec instance perform: selector withArguments: args! !

!SpecInterpreter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
bindings
	
	^ model bindings! !

!SpecInterpreter methodsFor: 'building' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
buildMorphFor: aComposableModel
	
	^ self buildMorphFor: aComposableModel withSpec: aComposableModel defaultSpecSelector! !

!SpecInterpreter methodsFor: 'building' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
buildMorphFor: aComposableModel withSpec: aSymbol
	
	^ self interpretASpec: (aComposableModel class perform: aSymbol) model: aComposableModel! !

!SpecInterpreter methodsFor: 'building' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
buildWindowFor: aComposableModel
	
	^ self interpretASpec: aComposableModel class windowSpec model: aComposableModel! !

!SpecInterpreter methodsFor: 'bindings' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
convertSymbolOfClassToInstance: aSymbol
	| symbol |
	
	symbol := self retrieveClassSymbolFor: aSymbol.
	
	^ (Smalltalk 
		at: symbol
		ifAbsent: [ ^ aSymbol ]) new! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 7/31/2012 17:05'!
interpretASpec: aPresenter
	| index anArray specToProvide |

	aPresenter ifNil: [ ^ nil ].
	
	anArray := aPresenter.
	aPresenter isSpecLayout ifTrue: [ anArray := aPresenter asArray ].
	
	(anArray isCollection and: [anArray isSequenceable]) ifFalse: [ ^ anArray ].
	(aPresenter isString or: [ aPresenter isText ]) ifTrue: [ 
			^ aPresenter == #model
				ifTrue: [ model ]
				ifFalse: [ self convertSymbolOfClassToInstance: aPresenter ]].

	" aPresenter is an Array "
	"First element is a symbol describing the spec type"
	spec := self retreiveSpecFrom: anArray first.
	(spec isKindOf: RawSpec)
		ifTrue: [ specToProvide := superSpec ]
		ifFalse: [ specToProvide := spec ].
	spec addAsSubSpecTo: superSpec.
	index := 2.	
	
	[ index <= anArray size ]
		whileTrue: [ | selector numArgs args newInstance |
			selector := spec bindings retrieveSelectorSymbolFor: (anArray at: index).
			selector isArray not
				ifTrue: [ 
					selector := selector asSymbol.
					numArgs := selector numArgs.
					args := anArray copyFrom: index + 1 to: index + numArgs ]
				ifFalse: [| array |
					"Here I assume that if it's not a symbol, it's a collection"
					array := selector.
					selector := array first.
					numArgs := 0.
					args := array allButFirst ].
				args := args collect: [:each | self class interpretASpec: each model: model superSpec: specToProvide ].
				index := index + numArgs + 1.
				newInstance := self actionToPerformWithSelector: selector arguments: args.
			index > anArray size
				ifTrue: [
					| result |
					(model respondsTo: #spec:)
						ifTrue: [ model spec: spec ].
					result := self class interpretASpec: newInstance model: spec instance superSpec: specToProvide.
					(result isKindOf: ComposableModel)
						ifTrue: [| return | 
							return := result buildWithSpec.
							result spec addAsSubSpecTo: superSpec.
							^ return ]
						ifFalse: [ ^ result ]].
			spec instance: newInstance ].
			
	"If you get here, there is a problem. Must probably it comes from the Spec which is wrongly defined"
	self assert: (anArray size < 2).
	(model respondsTo: #spec:)
		ifTrue: [ model spec: spec ].
	^ spec instance! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
interpretASpec: aPresenter model: aModel
	
	^ self interpretASpec: aPresenter model: aModel superSpec: NullObjectSpec new! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 6/6/2012 19:24'!
interpretASpec: aPresenter model: aModel superSpec: aSpec
	
	self model: aModel.
	superSpec := aSpec.
	^ self interpretASpec: aPresenter! !

!SpecInterpreter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
model
	^ model! !

!SpecInterpreter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
model: anObject
	model := anObject! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 7/13/2012 03:19'!
retreiveSpecFrom: aSymbol
	| instance aSpec |
	aSpec := ComposableSpec new.
	self class interpretASpec: aSymbol model: model superSpec: aSpec.
	aSpec subSpecs do: [:sub |
		sub addAsSubSpecTo: superSpec  ].
	instance :=  (SpecBinder 
			specFor: aSymbol 
			ifAbsent: [ ^ RawSpec new
							bindings: self bindings;
							defaultReceiver: aSymbol 
							model: model ]) new.
	^ instance 
		model: model;
		bindings: model bindings;
		yourself! !

!SpecInterpreter methodsFor: 'bindings' stamp: 'BenjaminVanRyseghem 6/6/2012 18:23'!
retrieveClassSymbolFor: aSymbol

	^ self bindings retrieveClassSymbolFor: aSymbol! !

Object subclass: #SpecLayout
	instanceVariableNames: 'type commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecLayout commentStamp: '<historical>' prior: 0!
A SpecPresenter is a object used to describe a user interface!

SpecLayout subclass: #SpecColumnLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecColumnLayout commentStamp: '<historical>' prior: 0!
A SpecColumnLayout is the layout used to specify a new column!

!SpecColumnLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 05:43'!
add: aSpec height: aNumber
	
	self add: aSpec origin: 0@0 corner: 1@1 offsetOrigin: 0@0 offsetCorner: 0@aNumber ! !

!SpecColumnLayout methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 7/31/2012 15:10'!
addSplitter

	self commands add: (SpecSplitterHorizontal commands: self commands)! !

!SpecColumnLayout methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 7/31/2012 18:08'!
asArray
	| size result currentOffset  numberOfProportionals currentProportional delta lastFractionIndex height |
	
	currentOffset := 0.
	currentProportional := 0.
	result := OrderedCollection new.
	result add: self type.
	size := self commands size.
	numberOfProportionals := 0.
	lastFractionIndex := 0.
	
	self commands do: [:e |
		e offsets = (0@0 corner: 0@0)
			ifTrue: [ numberOfProportionals := numberOfProportionals +1 ]].
	
	numberOfProportionals isZero
		ifTrue: [ delta := 0 ]
		ifFalse: [ delta := 1/numberOfProportionals ].
	
	self commands doWithIndex: [:e :idx || x0 x1 |
		e offsets = (0@0 corner: 0@0)
			ifTrue: [ "fractions"
				e fractions: (0@currentProportional corner: 1@(currentProportional +delta)).
				e offsets: (0@currentOffset corner: 0@0).
				currentOffset := 0.
				currentProportional := currentProportional +delta.
				lastFractionIndex := idx ]
			ifFalse: [ "offsets"
				height := e offsets height.
				x0 := e offsets left.
				x1 := e offsets right.
				idx = size
					ifTrue: [
						e fractions:  (0@1 corner: 1@1).
						e offsets: (x0@(height negated) corner: x1@0)]
					ifFalse: [
						e fractions: (0@currentProportional corner: 1@currentProportional).
						e offsets: (x0@currentOffset corner: x1@ (currentOffset + height)).
						currentOffset := (currentOffset + height) ]]].
			
	(lastFractionIndex > 0 and: [ lastFractionIndex < size ])
		ifTrue: [ | index ante x0 x1 y0 y1 |
			index := size-1.
			[ index > lastFractionIndex ] whileTrue: [ | myHeight |
				ante := self commands at: index.
				index := index -1.
				x0 := ante leftOffset.
				y0 := ante topOffset.
				x1 := ante rightOffset.
				y1 := ante bottomOffset.
				myHeight := y1-y0.
				ante offsets: (x0@((height+myHeight) negated) corner: x1@(height negated)).
				height := height+myHeight ].
			self assert: (index = lastFractionIndex).
			ante := self commands at: index.
			x0 := ante leftOffset.
			y0 := ante topOffset.
			x1 := ante rightOffset.
			y1 := ante bottomOffset.
			ante offsets: (x0@y0 corner: x1@(height negated)) ].		
			
	(self commands reject: [:e | e isSplitter ]) do: [:e |
		| left right bottom top windowBorderWidth |
		windowBorderWidth := self class windowBorderWidth.
		left := e leftOffset ifNil: [0].
		right := e rightOffset ifNil: [0].

		bottom := e bottomOffset ifNil: [0].
		top := e topOffset ifNil: [0].
		
		e rightFraction = 1 ifTrue: [ 
			right isZero 
				ifTrue: [ e rightOffset: windowBorderWidth negated ]
				ifFalse: [ e rightOffset: right - ProportionalSplitterMorph splitterWidth ]].
		e leftFraction = 0
			ifTrue: [ 
				left isZero 
					ifTrue: [ e leftOffset: windowBorderWidth ]
					ifFalse: [ e leftOffset: left+ ProportionalSplitterMorph splitterWidth ]]
			ifFalse: [ e leftFraction = 1 ifFalse: [
						e leftOffset: left + ProportionalSplitterMorph splitterWidth]].

		e bottomFraction = 1 ifTrue: [ 
			bottom isZero
				ifTrue: [ e bottomOffset: windowBorderWidth negated ]
				ifFalse: [ e bottomOffset: bottom - ProportionalSplitterMorph splitterWidth ]].
		e topFraction = 0
			ifTrue: [ 
				top isZero 
					ifTrue: [ e topOffset: windowBorderWidth ]
					ifFalse: [ e topOffset: top + ProportionalSplitterMorph splitterWidth ]]
			ifFalse: [ e topFraction = 1 ifFalse: [
						e topOffset: top + ProportionalSplitterMorph splitterWidth]].
		
		e generateArguments.
		e asSpecElements do: [:el |
			result add: el ]].
	
	(self commands select: [:e | e isSplitter ]) do: [:e |
		e generateArguments.
			e asSpecElements do: [:el |
				result add: el ]].
		
	result add: #checkSplitters.
	
	^ result asArray! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:44'!
abstract

	^self new 
		type: #AbstractSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:44'!
button

	^self new
		type: #ButtonSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:44'!
checkbox

	^self new 
		type: #CheckboxSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:45'!
composed

	^self new
		type: #ComposableSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/12/2012 18:57'!
dialogWindow

	^self new 
		type: #DialogWindowSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:45'!
droplist

	^self new 
		type: #DropListSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:45'!
iconlist

	^self new 
		type: #IconListSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:45'!
label

	^self new
		type: #LabelSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:45'!
list

	^self new 
		type: #List;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:46'!
multicolumnlist

	^self new 
		type: #MultiColumnListSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:46'!
raw

	^self new 
		type: #RawSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/12/2012 18:57'!
slider

	^self new 
		type: #SliderSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:46'!
text

	^self new 
		type: #TextSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:46'!
textfield 

	^self new 
		type: #TextFieldSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:46'!
tree

	^self new 
		type: #TreeSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/12/2012 18:57'!
window

	^self new 
		type: #WindowSpec;
		yourself! !

!SpecLayout class methodsFor: 'constants' stamp: 'BenjaminVanRyseghem 7/18/2012 18:49'!
windowBorderWidth

	^ 0! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
add: aSpec 
	
	self add: aSpec origin: 0@0 corner: 1@1! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
add: aSpec origin: originPoint corner: cornerPoint 

	self add: aSpec origin: originPoint corner: cornerPoint offsetOrigin: 0@0 offsetCorner: 0@0! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
add: aSpec origin: originPoint corner: cornerPoint offsetOrigin: ooPoint offsetCorner: ocPoint
	
	commands add: (SpecLayoutAdd 
							subwidget: aSpec
							fractions: (originPoint corner: cornerPoint)
							offsets: (ooPoint corner: ocPoint)).! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
add: modelGetter withSpec: aSymbol 
	
	self add: modelGetter withSpec: aSymbol origin: 0@0 corner: 1@1! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
add: modelGetter withSpec: aSymbol origin: originPoint corner: cornerPoint 

	self add: modelGetter withSpec: aSymbol origin: originPoint corner: cornerPoint offsetOrigin: 0@0 offsetCorner: 0@0! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
add: modelGetter withSpec: aSymbol origin: originPoint corner: cornerPoint offsetOrigin: ooPoint offsetCorner: ocPoint

	commands add: (SpecLayoutAddWithSpec 
						subwidget: modelGetter 
						spec: aSymbol 
						fractions: (originPoint corner: cornerPoint)
						offsets: (ooPoint corner: ocPoint)).! !

!SpecLayout methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 7/31/2012 14:46'!
asArray
	| result |
	
	result := OrderedCollection new.
	result add: self type.
				
	self commands do: [:e |
		e asSpecElements do: [:el |
			result add: el ]].
		
	^result asArray! !

!SpecLayout methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
commands
	^ commands! !

!SpecLayout methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
commands: anObject
	commands := anObject! !

!SpecLayout methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
initialize 
	super initialize.
	
	type := #ComposableSpec.
	self commands: OrderedCollection new.! !

!SpecLayout methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
isSpecLayout

	^ true! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
newColumn: aBlock 
	
	self newColumn: aBlock origin: 0@0 corner: 1@1! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
newColumn: aBlock origin: originPoint corner: cornerPoint 

	self newColumn: aBlock origin: originPoint corner: cornerPoint offsetOrigin: 0@0 offsetCorner: 0@0! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
newColumn: aBlock origin: originPoint corner: cornerPoint offsetOrigin: ooPoint offsetCorner: ocPoint
	
	commands add: (SpecLayoutAddColumn
							block: aBlock
							fractions: (originPoint corner: cornerPoint)
							offsets: (ooPoint corner: ocPoint)).! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 7/9/2012 13:40'!
newColumn: aBlock  width: aNumber
	
	self newColumn: aBlock  origin: 0@0 corner: 0@1 offsetOrigin: 0@0 offsetCorner: aNumber @0! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
newRow: aBlock 
	
	self newRow: aBlock origin: 0@0 corner: 1@1! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 7/9/2012 17:05'!
newRow: aBlock height: aNumber
	
	self newRow: aBlock  origin: 0@0 corner: 1@0 offsetOrigin: 0@0 offsetCorner: 0@aNumber ! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
newRow: aBlock origin: originPoint corner: cornerPoint 

	self newRow: aBlock origin: originPoint corner: cornerPoint offsetOrigin: 0@0 offsetCorner: 0@0! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
newRow: aBlock origin: originPoint corner: cornerPoint offsetOrigin: ooPoint offsetCorner: ocPoint
	
	commands add: (SpecLayoutAddRow
							block: aBlock
							fractions: (originPoint corner: cornerPoint)
							offsets: (ooPoint corner: ocPoint)).! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
send: aSelector
	
	self send: aSelector withArguments: #()! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
send: aSelector withArguments: arguments


	self commands add: (SpecLayoutSend
							selector: aSelector
							arguments: arguments).! !

!SpecLayout methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
type
	^ type! !

!SpecLayout methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
type: anObject
	type := anObject! !

SpecLayout subclass: #SpecRowLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecRowLayout commentStamp: '<historical>' prior: 0!
A SpecRowLayout isthe layout used to specify a new row!

!SpecRowLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:33'!
add: aSpec width: aNumber
	
	self add: aSpec origin: 0@0 corner: 1@1 offsetOrigin: 0@0 offsetCorner: aNumber @0! !

!SpecRowLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 7/31/2012 16:09'!
addSplitter

	self commands add: (SpecSplitterVertical commands: self commands)! !

!SpecRowLayout methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 7/31/2012 18:09'!
asArray
	| result currentOffset  numberOfProportionals currentProportional delta size lastFractionIndex width |
	
	currentOffset := 0.
	currentProportional := 0.
	result := OrderedCollection new.
	result add: self type.
	numberOfProportionals := 0.
	lastFractionIndex := 0.
	size := self commands size.
	
	self commands do: [:e |
		e offsets = (0@0 corner: 0@0)
			ifTrue: [ numberOfProportionals := numberOfProportionals +1 ]].
	
	numberOfProportionals isZero
		ifTrue: [ delta := 0 ]
		ifFalse: [ delta := 1/numberOfProportionals ].
	
	self commands doWithIndex: [:e :idx |
		e offsets = (0@0 corner: 0@0)
			ifTrue: [
				e fractions: (currentProportional@0 corner: (currentProportional +delta)@1).
				e offsets: (currentOffset@0 corner: 0@0).
				currentOffset := 0.
				currentProportional := currentProportional +delta.
				lastFractionIndex := idx ]
			ifFalse: [| y0 y1 |
				width := e offsets width.
				y0 := e offsets top.
				y1 := e offsets bottom.
				idx = size 
					ifTrue: [
						e fractions: (1@0 corner: 1@1).
						e offsets: ((width negated)@y0 corner: 0@y1)]
					ifFalse: [
						e fractions: (currentProportional@0 corner: currentProportional@1).
						e offsets: (currentOffset@y0 corner: (currentOffset + width)@y1).
						currentOffset := (currentOffset + width) ]]].
	
	(lastFractionIndex > 0 and: [ lastFractionIndex < size ])
		ifTrue: [ | index ante x0 x1 y0 y1 |
			index := size-1.
			[ index > lastFractionIndex ] whileTrue: [ | myWidth |
				ante := self commands at: index.
				index := index -1.
				x0 := ante offsets topLeft x.
				y0 := ante offsets topLeft y.
				x1 := ante offsets bottomRight x.
				y1 := ante offsets bottomRight y.
				myWidth := x1-x0.
				ante offsets: (((width+myWidth) negated)@y0 corner: (width negated)@y1).
				width := width+myWidth ].
			self assert: (index = lastFractionIndex).
			ante := self commands at: index.
			x0 := ante offsets topLeft x.
			y0 := ante offsets topLeft y.
			y1 := ante offsets bottomRight y.
			ante offsets: (x0@y0 corner: (width negated)@y1) ].		
			
	(self commands reject: [:e | e isSplitter ]) do: [:e |
		| left right bottom top windowBorderWidth |
		windowBorderWidth := self class windowBorderWidth.
		left := e leftOffset ifNil: [0].
		right := e rightOffset ifNil: [0].

		bottom := e bottomOffset ifNil: [0].
		top := e topOffset ifNil: [0].
		
		e rightFraction = 1 ifTrue: [ 
			right isZero 
				ifTrue: [ e rightOffset: windowBorderWidth negated ]
				ifFalse: [ e rightOffset: right - ProportionalSplitterMorph splitterWidth ]].
		e leftFraction = 0
			ifTrue: [ 
				left isZero 
					ifTrue: [ e leftOffset: windowBorderWidth ]
					ifFalse: [ e leftOffset: left+ ProportionalSplitterMorph splitterWidth ]]
			ifFalse: [ e leftFraction = 1 ifFalse: [
						e leftOffset: left + ProportionalSplitterMorph splitterWidth]].

		e bottomFraction = 1 ifTrue: [ 
			bottom isZero
				ifTrue: [ e bottomOffset: windowBorderWidth negated ]
				ifFalse: [ e bottomOffset: bottom - ProportionalSplitterMorph splitterWidth ]].
		e topFraction = 0
			ifTrue: [ 
				top isZero 
					ifTrue: [ e topOffset: windowBorderWidth ]
					ifFalse: [ e topOffset: top + ProportionalSplitterMorph splitterWidth ]]
			ifFalse: [ e topFraction = 1 ifFalse: [
						e topOffset: top + ProportionalSplitterMorph splitterWidth]].
		e generateArguments.
		e asSpecElements do: [:el |
			result add: el ]].
	
	(self commands select: [:e | e isSplitter ]) do: [:e |
		e generateArguments.
		e asSpecElements do: [:el |
			result add: el ]].
	
	result add: #checkSplitters.
	
	^ result asArray! !

Object subclass: #TabClassical
	instanceVariableNames: 'container tab'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples-PolyWidgets'!

!TabClassical commentStamp: '<historical>' prior: 0!
A TabClassical is an example to learn how to use tabs ;)!

!TabClassical class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 1/5/2012 18:33'!
associations: associations

	^ self new
		addTabs: associations;
		yourself.! !

!TabClassical class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 6/22/2012 19:18'!
example

	| tc testMorph model anotherMorph associations |
	
	model := ClassMethodBrowser new.
	
	testMorph := model buildWithSpec: #defaultSpec.
	anotherMorph := model buildWithSpec: #defaultSpec2.
	
	associations := {'Test' -> testMorph. 'Another'-> anotherMorph}.
	tc := self associations: associations.
	
	model classes: (Smalltalk allClasses).
	tc open.! !

!TabClassical methodsFor: 'display' stamp: 'BenjaminVanRyseghem 1/7/2012 05:59'!
addAll: window
	
	window
		addMorph: tab
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ 0 corner: 0 @ 35)).
				
	window
		addMorph: container
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 35 corner: 0 @ 0)).
				
	tab tabs size = 0 ifTrue: [ ^ self ].
	tab color: Color white darker darker! !

!TabClassical methodsFor: 'display' stamp: 'BenjaminVanRyseghem 1/15/2012 22:13'!
addTabs: associations

	associations do: [:each |
		self tab 
			addTab: (Text fromString: each key) 
			withAction: [ 	self setMorph: each value ].
		container submorphs isEmpty ifTrue: [ container addMorph: each value ]]! !

!TabClassical methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/5/2012 18:30'!
initialize
	"Initialization code for TabClassical"

	super initialize.

	container := PanelMorph new changeTableLayout; listDirection: #bottomToTop; color: Color white; yourself.
	tab := PluggableTabBarMorph on: self.
	tab width: 150.! !

!TabClassical methodsFor: 'display' stamp: 'BenjaminVanRyseghem 1/5/2012 18:21'!
open

	| window panel |
	window := StandardWindow new.
	panel := PanelMorph new hResizing: #spaceFill; vResizing: #spaceFill; changeProportionalLayout.

	window addMorph: panel frame: (0@0 corner: 1@1).
	self addAll: panel.
	window openInWorld.
	
	window title: 'Tab Test'! !

!TabClassical methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/3/2012 18:59'!
setMorph: aMorph

	container removeAllMorphs.
	container addMorph: aMorph.
	aMorph color: Color white.
	aMorph takeKeyboardFocus.! !

!TabClassical methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/3/2012 19:02'!
tab

	^ tab! !
SpecBinder initialize!
